      subroutine calc_prop
      include 'PARAMET.ECEPP'
      include 'PARAMET.ADD'
      include 'sizesclu.dat'
      include 'COMMON.CNTRL'
      include 'COMMON.CNTRL1'
      include 'COMMON.IOUNIT'
      include 'COMMON.ALLANG'
      include 'COMMON.PROP'
      include 'COMMON.GEN100'
      include 'COMMON.THRLET'
      include 'COMMON.BONDSX'
      include 'COMMON.SUPER'
      include 'COMMON.CLUSTAT'
      include 'COMMON.ZOCHA'
      include 'COMMON.ATOMSS'
      include 'COMMON.RMSMAT'
      include 'COMMON.CHROMO'
      dimension b(3,3),v(3),t(3) 
      dimension avdev(maxnum_res)
      dimension z(3,maxnum_atoms)
      character*3 rsnam  

      if (lrms.or.larray) call atselect(nrclust1,nrclust2)

      do ic=1,num_conf

      do i=1,inumrs*maxnum_dihe
        angles(i)=allang(ic,i)
      enddo
      do i=1,nres
        list(i)=allseq(ic,i)
      enddo
c Generate atom coordinates
      call setup_x(0)
*
* Print angles & Cartesian coordinates.                                
*
      if (lprint1) call druang(jout)
      if (printcoord .and. lprint1) call outnw(0,30,ic)

      if (virt_chain) call virtual_chain(ic)
      if (h_bonds) call hydrogen_bonds(ic)
      if (turns) call beta_turns(ic)
      if (chirality) call ss_chiral(ic)
cd    print *,'ic=',ic,' chrom_dist=',chrom_dist
      if (chrom_dist) call chromdist(idon,iacc,ic)
      if (lellips) call ellipsoid(ic)
cd    print *,'ellips'
      if (lrms)  then
        if (larray) then
          do i=1,inumrs-2
            do j=1,i
cd            write (jout,*) 'i=',i,' j=',j
              nrsup1=j
              nrsup2=i
              nrsup=nrsup2-nrsup1+1
              istart=ntresup(nrsup1+1)
              do k=nrsup1,nrsup2
                ind1=ntresup(k+1)
                ind2=ntresup(k+2)
cd              print *,'k=',k,' ind1=',ind1,' ind2=',ind2
                do l=ind1+1,ind2
                  do ll=1,3
                    s1(ll,l-istart)=s4(ll,l)
                  enddo
                enddo
              enddo 
cd            do ii=1,nrsup
cd              write(jout,*)ii,(s1(jj,ii),jj=1,3)
cd            enddo
cd            print *,'nrsup1=',nrsup1,' nrsup2=',nrsup2,' nrsup=',nrsup
              call rmscalc(ic,t,b,nrsup,nrsup1,nrsup2)
              ind=i*(i-1)/2+j
              rmsarray(ind)=propty(ic,5)
              write (jout,'(2i6,f10.5)') i,j,propty(ic,5)
cd            print *,ind,rmsarray(ind)
cd            print *,i,j,nrsup,propty(ic,5)
            enddo
          enddo 
          write (jout,*) 'RMS array for conformation ',ic
          call matout(inumrs-2)
        else
          call rmscalc(ic,t,b,nrsup,nrsup1,nrsup2)
        endif
      endif
cd    print *,'rmscalc'
      if (lnmr) then
        call distcalc
        call constr_viol(ic,lprint1)
      endif
      if (lcont) call contact(ic)
cd    print *,'contact'
cd    print *,'lprint1=',lprint1
      if (lprint1 .and. lrms) then
        write (jout,'(a)') 'Superposed coordinates:'
        do i=1,inumrs
          nresupi=nresup(i)
          ntresupi=ntresup(i) 
          do j=1,nresupi
            ii=j+ntresupi
            iii=iresup(i,j)
            call mvvad(b,s3(1,ii),t,z(1,ii))
            write (jout,'(a4,i7,2x,a2,2x,a3,i6,4x,3f8.3)')
     &      'ATOM',ii,alph(iii),waby(i-1),i,(s4(k,ii),k=1,3)
          enddo
        enddo
        do i=1,inumrs
          nresupi=nresup(i)
          ntresupi=ntresup(i) 
          do j=1,nresupi
            ii=j+ntresupi
            iii=iresup(i,j)
            write (jout,'(a4,i7,2x,a2,2x,a3,i6,4x,3f8.3)')
     &      'ATOM',ii,alph(iii),waby(i-1),i,(z(k,ii),k=1,3)
          enddo
        enddo
        write (jout,'(/a)') 
     &   'Deviations of individual atoms along the chain:'
        do i=1,inumrs-1
          avdev(i)=0.0
        enddo
        do kk=1,nnat
          write (jout,'(2a)') 'Atom ',idatt(kk)
          do n=2,inumrs
            nresupi=nresup(n)
            ntresupi=ntresup(n) 
            do i=1,nresupi
              ii=i+ntresupi
              iii=iresup(n,i)
              if (alph(iii).eq.idatt(kk)) then
*               print *,alph(iii),idatt(kk)
                dif=0.0
                do j=1,3                              
                  dif=dif+(z(j,ii)-s4(j,ii))**2     
                enddo                                          
                avdev(n-1)=avdev(n-1)+dif
                dif=sqrt(dif)
                write (jout,'(i5,0pf15.5)') n-1,dif
                goto 133
              endif
            enddo
            write (jout,'(i5,0pf15.5)') n-1,0
  133       continue
          enddo   
        enddo
        write (jout,'(a)') 'Average deviations by residue:'
        do i=1,inumrs-1
          write (jout,'(i5,0pf15.5)') i,sqrt(avdev(i)/nresup(i+1))
        enddo 
      else if (lprint2) then
        do i=1,npre(inumrs+1)
          do j=1,3
            s3(j,i)=coord(j,i)
          enddo
        enddo
        ii1=0
        do i=1,inumrs
          if (i.eq.1 .or. i.eq.inumrs) then
            rsnam=ares(iabs(list(i))+num_restypenum_restypes)
          else
            rsnam=ares(iabs(list(i)))
          endif
          ntresupi=npre(i)
          nresupi=npre(i+1)-ntresupi
          do j=1,nresupi
            ii=j+ntresupi
            if (alph(ii)(1:1).ne.'H') then
              ii1=ii1+1
              call mvvad(b,s3(1,ii),t,z(1,ii))
              write (jout,'(a4,i7,2x,a2,2x,a3,a2,i4,4x,3f8.3)')
C    &    'ATOM',ii1+nat0,alph(ii),rsnam,' B',i-1+nres0,(z(k,ii),k=1,3)
     &    'ATOM',ii1,alph(ii),rsnam,' B',i-1,(z(k,ii),k=1,3)
            endif
          enddo
        enddo
      endif
*
*--- End of loop over conformations.
*
      enddo

      return
      end

