      subroutine clustconf
      include 'PARAMET.ECEPP'
      include 'PARAMET.ADD'
      include 'sizesclu.dat'
      include 'COMMON.IOUNIT'
      include 'COMMON.CNTRL'
      include 'COMMON.CNTRL1'
      include 'COMMON.HEADER'
      include 'COMMON.THRLET'
      include 'COMMON.FILES'
      include 'COMMON.LOC'
      include 'COMMON.GEN100'
      include 'COMMON.ALLANG'
      include 'COMMON.BONDSX'
      include 'COMMON.GEN000'
      include 'COMMON.ATOMSS'
      include 'COMMON.PDBFILE'
      include 'COMMON.CLUSTAT'
      include 'COMMON.CLUSTER'
      include 'COMMON.CLUSPRN'
      include 'COMMON.PROP'
      include 'COMMON.SUPER'
      include 'COMMON.NMR'
      include 'COMMON.CONTACT'
      include 'COMMON.ZOCHA'
      dimension allcart(maxconf,3,maxnum_atoms/7)
      dimension t(3),b(3,3)
      character*64 cfile
!      ICANT(I,J)=((num_conf+num_conf-j)*(j-1))/2+i-j
c     print *,'Enter Clust_conf.'
c
c Select atoms to superpose.
c
      write (jout,'(80(1h*)/a/80(1h*))') title
      if (minim_var) then
        write (jout,'(a)') 
     &   'Entering the minimum-variance cluster analysis routine.'
      else
      write (jout,'(a)') 
     &   'Entering the minimal-tree cluster analysis routine.'
      if (tree) then
         write (jout,'(a)') 
     &   'Minimal tree will be constructed and then partitioned.'
      else
         write (jout,'(2a/a)')
     &   'Partitioning will be carried out without explicit ',
     &   'construction','of the minial tree.' 
      endif
      endif
      do icut=1,ncut
        if (printang(icut))
     &  write (jout,'(2a/a,f8.3,a)') 
     & 'Dihedral angles of the leading members of the families ',
     & 'will be saved','for RMS cut-off value of ',rcutoff(icut),' A.'
        if (printpdb(icut).eq.1) 
     &  write (jout,'(2a/a,f8.3,a)') 
     & 'Cartesian coordinates of the leading members of the families ',
     & 'will be saved','for RMS cut-off value of ',rcutoff(icut),' A.'
        if (printpdb(icut).gt.1) 
     &  write (jout,'(2a/a,f8.3,a)') 
     & 'Cartesian coordinates of the leading members of the families ',
     & 'and up to',printpdb(icut)-1,' lowest-energy conformations',
     & 'will be saved for RMS cut-off value of ',rcutoff(icut),' A.'
      enddo
      write (jout,'(a,f8.3,a)') 'Energy cut-off is ',ecut,' kcal/mol.'
      call atselect(nrclust1,nrclust2)
*
* Do cluster analysis.
*
      t1=tcpu()
c     print *,'t1=',t1
      do ic=1,num_conf
        print *,'ic=',ic,' nacomp=',nacomp
        do i=1,inumrs*maxnum_dihe
          angles(i)=allang(ic,i)
        enddo
        do i=1,inumrs
          list(i)=allseq(ic,i)
        enddo
c       do i=1,inumrs
c         print '(10f8.3)',(angulo(j,i),j=1,maxnum_dihe)
c       enddo
        call setup_x(0)
        do i=1,nacomp
          ici=iaclust(i)
          do j=1,3
            allcart(ic,j,i)=coord(j,ici)
          enddo
c         write (jout,'(i5,3f10.5)') i,(allcart(ic,j,i),j=1,3)
        enddo
      enddo
      do i=1,num_conf
        if (onscreen) print '(a,i5)','calculating rms; i',i
        do k=1,nacomp
          do l=1,3
            s1(l,k)=allcart(i,l,k)
          enddo
        enddo
        do j=i+1,num_conf
          do k=1,nacomp
            ici=iaclust(k)
            do l=1,3
              s2(l,k)=allcart(j,l,k)
            enddo
          enddo 
          call fitsq(rms,s2,s1,nacomp,t,b) 
c         print *,'i=',i,' j=',j,' rms=',rms
          attalums(icant(j,i))=sqrt(abs(rms))
        enddo
      enddo
      t2=tcpu()
      write (jout,*)
      write (jout,'(a,f10.1,a)') 
     &     'TIME FOR DISTANCE CALCULATION:',T2-T1,' SEC.'
      if (print_distmat) then
        cfile=coorpref(:len_trim(coorpref))//'.distmat'
        open (30,file=cfile,status='unknown')
        do i=1,num_conf
          do j=i+1,num_conf
            write (30,'(2i5,f10.5)') i,j,attalums(icant(j,i))
          enddo
        enddo
      endif
      t1=tcpu()
      if (minim_var) then
        call minvar(num_conf,ecut,.false.,printang,eceppform,printpdb)
      else if (tree) then
        call clustmaz(num_conf,ecut,.false.,printang,eceppform,printpdb) 
      else
        call cluster(num_conf,ecut,.false.,printang,eceppform,printpdb) 
      endif
      call writrack
      call plotree
      t2=tcpu()
      write (jout,*)
      write (jout,'(a,f10.1,a)') 'TIME FOR CLUSTERING:',T2-T1,' SEC.'
      t1=tcpu()
      return
      end
