      SUBROUTINE INIT_BRIDGE
C                                                           
C This subroutine checks to see if the polypeptide chain   
C contains at least two half-residues.  if so it  
C processes the bridge information that has been read in the READ_BRIDGE
C subroutine.
C Code taken from AL's RDCYS modiefied on 4/16/93 to handle all types of bridge.
C
      include 'PARAMET.ECEPP'
      INCLUDE 'COMMON.CHECK'
      INCLUDE 'COMMON.BRIDGES'
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.IOUNIT'
      INCLUDE 'COMMON.PRAMX'
      INCLUDE 'COMMON.THRLET'
      character*3 res1,res2
      LASTFL=INUMRS-1                                                   
      NHALF=0                                                           
      NCYS=0
      DO 1 I=1,INUMRS
      LISTI=LIST(I)                                                     
      LISTI=IABS(LISTI)                                                 
      if (i.eq.1 .or. i.eq.inumrs) listi=listi+num_restypes
      if (inbrid(listi).eq.0) goto 1
      NHALF=NHALF+1                                                     
 1    CONTINUE                                                          
      ncys=nhalf/2
      if (ncys*2.ne.nhalf) then
        write (jout,'(2a)') 
     & 'Error in INIT_BRIDGE: the sequence has an odd number of',
     & ' bridging residues.'
        stop
      endif
      if (nhalf.ne.nloop) then
        write (jout,'(a,i4,a/a,i4,2a)') 
     & 'Error in INIT_BRIDGE: ',nhalf,' bridging residues have been ',
     & 'found in the sequence but',nloop,' have been read in',
     & ' READ_BRIDGE.'
        stop
      endif
   2  if (ncys.eq.0)  return                                            
      write (jout,210)
      do i=1,ncys
        if (npair(1,i).gt.npair(2,i)) call exch(npair(1,i),npair(2,i))
        if (npair(1,i).eq.npair(2,i)) then 
          write (jout,*) 'Error - cannot bridge a single residue.'
          stop
        endif
        listi=iabs(list(npair(1,i)))
        listj=iabs(list(npair(2,i)))
        if (npair(1,i).eq.1 .or. npair(1,i).eq.inumrs) listi=listi+
     &   num_restypes
        if (npair(2,i).eq.1 .or. npair(2,i).eq.inumrs) listj=listj+
     &   num_restypes
c       call pdbres(listi,res1)
        res1=ares(listi)
c       call pdbres(listj,res2)
        res2=ares(listj)
        np1=inbrid(listi)
        np2=inbrid(listj)
        if (np1.eq.0 .or. np2.eq.0) then
          write (jout,220) res1,npair(1,i),res2,npair(2,i)
          stop
        endif
        ii=icant(np1,np2)
        if (r0b(1,ii)*r0b(2,ii)*r0b(3,ii).eq.0) then
          write (jout,230) res1,npair(1,i),res2,npair(2,i)
          stop
        endif
        itb(i,1)=np1
        itb(i,2)=np2
        itb(i,3)=ii
	if (np1.le.np2) then
	  iom_flag(1,i)=iiomeg(1,ii)
	  iom_flag(2,i)=iiomeg(2,ii)
        else
	  iom_flag(1,i)=iiomeg(2,ii)
	  iom_flag(2,i)=iiomeg(1,ii)
        endif
C       write (jout,*) 'i=',i,' np1=',np1,' np2=',np2,' iom_flag:',
C    &    iom_flag(1,i),iom_flag(2,i)
        write (jout,240) res1,npair(1,i),res2,npair(2,i),
     &        (r0b(k,ii),k=1,3),(conb(k,ii),k=1,3)
      enddo
      nloop=ncys
      RETURN       
 210  format(/'The following bridges exist in the chain:'/
     & '     Residues         R01     R02     R03',
     & '      K1      K2      K3')
 220  format(//'Error - residues ',A3,'(',I3,') and ',A3,'(',I3,')',
     & ' cannot form a bridge.')
 230  format(//'Error - constants missing for the bridge formed by ',
     &  A3,'(',I3,') and ',A3,'(',I3,')')
 240  format(A3,'(',I3,')-',A3,'(',I3,')',6f8.3)
      END 
c------------------------------------------------------------------------
      INTEGER FUNCTION INBRID(LISTI)
      INCLUDE 'PARAMET.ECEPP'
      INCLUDE 'COMMON.BRIDGES'
      DO I=1,NRB
        IF (NBRID(I).EQ.LISTI) THEN 
          INBRID=I
          RETURN
        ENDIF
      ENDDO
      INBRID=0
      RETURN
      END
