C
C------------------------------------------------------------------------------
C
      function alpha(i1,i2,i3)
c
c  Calculates the planar angle between atoms (i1), (i2), and (i3).
c
      include 'PARAMET.ECEPP'
      include 'COMMON.ATOMSS'
      x12=coord(1,i1)-coord(1,i2)
      x23=coord(1,i3)-coord(1,i2)
      y12=coord(2,i1)-coord(2,i2)
      y23=coord(2,i3)-coord(2,i2)
      z12=coord(3,i1)-coord(3,i2)
      z23=coord(3,i3)-coord(3,i2)
      vnorm=sqrt(x12*x12+y12*y12+z12*z12)
      wnorm=sqrt(x23*x23+y23*y23+z23*z23)
      scalar=(x12*x23+y12*y23+z12*z23)/(vnorm*wnorm)
      alpha=acos(scalar)
      return
      end
C
C------------------------------------------------------------------------------
C
      function beta(i1,i2,i3,i4)
c
c  Calculates the dihedral angle between atoms (i1), (i2), (i3) and (i4)
c
      include 'PARAMET.ECEPP'
      include 'COMMON.ATOMSS'
      x12=coord(1,i1)-coord(1,i2)
      x23=coord(1,i3)-coord(1,i2)
      x34=coord(1,i4)-coord(1,i3)
      y12=coord(2,i1)-coord(2,i2)
      y23=coord(2,i3)-coord(2,i2)
      y34=coord(2,i4)-coord(2,i3)
      z12=coord(3,i1)-coord(3,i2)
      z23=coord(3,i3)-coord(3,i2)
      z34=coord(3,i4)-coord(3,i3)
      wx=-y23*z34+y34*z23
      wy=x23*z34-z23*x34
      wz=-x23*y34+y23*x34
      wnorm=sqrt(wx*wx+wy*wy+wz*wz)
      vx=y12*z23-z12*y23
      vy=-x12*z23+z12*x23
      vz=x12*y23-y12*x23
      vnorm=sqrt(vx*vx+vy*vy+vz*vz)
      if (vnorm.gt.1.E-7 .and. wnorm.gt.1.E-7) then
      scalar=(vx*wx+vy*wy+vz*wz)/(vnorm*wnorm)
      angle=arcos(scalar)
      else 
      angle=0.0
      endif
      if (angle.lt.-1.0e-7) angle=pi+angle
      tx=vy*wz-vz*wy
      ty=-vx*wz+vz*wx
      tz=vx*wy-vy*wx
      scalar=tx*x23+ty*y23+tz*z23
      if (scalar.lt.0.0) angle=-angle
      beta=angle
      return
      end
C
C------------------------------------------------------------------------------
C
      function dist(i1,i2)
c
c  Calculates the distance between atoms (i1) and (i2).
c
      include 'PARAMET.ECEPP'
      include 'COMMON.ATOMSS'
      x12=coord(1,i1)-coord(1,i2)
      y12=coord(2,i1)-coord(2,i2)
      z12=coord(3,i1)-coord(3,i2)
      dist=sqrt(x12*x12+y12*y12+z12*z12)
      return
      end
C
