      SUBROUTINE MINVAR(M,ECUT,LGRP,PRINTANG,ECEPPFORM,PRINTPDB)
      include 'sizesclu.dat'
      include 'COMMON.CNTRL'
      COMMON /CLU/ T(MAXDIST),ENERGY(MAXCONF,4),
     & NCUT,RCUTOFF(10)
      COMMON /CLU1/ N,LICZ(MAXGR),NCONF(MAXGR,MAXINGR),IASS(MAXCONF)
      COMMON /ALLES/ NVAR,ICC(MAXCONF)
      include 'COMMON.IOUNIT'

C-------------------------------------------------------------------------!
C                                                                         !
C           Clustering of symmetrical square matrix of distances T(M,M),  !
C           calculated by program BEST2.                                  !
C                                                                         !
C       Number of clusters from N1 to N2. If IT < 999, initial clustering !
C       at N=N1 will be made automatically according to a principle:      !
C       P(I) =  1,2,...,N,1 2,...,N,... If IT >= 999, P(I) is inputed.    !
C       If N2 > 20, clustering is continued until maximal distance between!
C       members of any clusters becomes less than selected value DMAX     !
C                                                                         !
C       Guide for output information detalization:                        !
C       IDR <= 0 - minimal output,                                        !
C           <= 1 - some characteristics of clustering are printed,        !
C           <= 2 - T-matrix is printed,                                   !
C           <= 3 - initial clustering is printed,                         !
C           <= 4 - intermediate steps of clustering are printed.          !
C-------------------------------------------------------------------------!
C Last revision: 03/27/93 
!      DIMENSION T(200,200),P(200),E(20),KL(200),RMAX(20)
      DIMENSION E(maxgr),KL(maxconf),P(MAXCONF),RMAX(MAXGR)
      INTEGER P
      CHARACTER *32 NAMESF,NAMEWF
      CHARACTER *1 NTI(80)
      LOGICAL EXISTF,LGRP,ECEPPFORM(10),PRINTANG(10)
      INTEGER PRINTPDB(10)

C
C--------------------------------------------------------------------------
C
!      do i=1,m
!        do j=i+1,m
!          write (jout,*) i,j,icant(i,j),t(icant(i,j))
!        enddo
!      enddo
      idr=0
      it=1
      n1=2
      n2=m      
      write (jout,'(7(t20,a/))') 
     &  '________________________________________',
     &  '| Minimum variance clustering          |',
     &  '| Programmed by Mark D. Shenderovich   |',
     &  '| Institute of Organic Synthesis       |',
     &  '| Latvian Academy of Sciences          |',
     &  '| Aizkraukles 21, Riga, LV1006, Latvia |',
     &  '----------------------------------------'
      IF (M.LE.1.OR.M.GT.maxconf) THEN
       WRITE(jout,'(a)')'Wrong number of points!'
       STOP
      ENDIF
      IF (N1.GT.N2.OR.N1.LE.1.OR.N2.GT.M) THEN
       WRITE(jout,'(a)')' Wrong number of clusters!'
       stop
      ENDIF
	IF (N2.GT.m) THEN
		WRITE (jout,'(a)')' N2.GT.M'
             stop
	ENDIF
      IF (IT.LT.999) WRITE (jout,'('' Automatic initial clustering'')')
  100 FORMAT(40A2)
C
C--------------- SUM OF ALL SQUARE DISTANCES IN DATA MATRIX ---------------
C
      IF (IDR.GE.1) THEN
      SUMT=0.0
      DO 445 I=1,M
           I1=I+1
           DO 445 J=I1,M
           SUMT=SUMT+T(icant(I,J))**2
  445 CONTINUE
      Z0=SUMT/M
      WRITE(jout,'('' MAX.SUM OF SQUARE DISTANCES PER POINT:'',F7.2)')Z0
      ENDIF
C
C------------------- INITIAL CLUSTERING -----------------------------------
C
    3 IF (IT.LT.999) THEN
           K=0
           DO 10 I=1,M
                 K=K+1
                 IF (K.GT.N1) K=K-N1
			 P(I)=K
   10      CONTINUE
      ELSE
           WRITE(*,*)' Wish to input initial clustering, don"t you?
     * Let us try!'
           DO 450 I=1,M
  451             WRITE(*,'('' Input P('',I3'') <= N1'')') I
                  READ(*,*) P(I)
                  IF (P(I).GT.N1) GO TO 451
  450      CONTINUE
           DO 415 I=1,N1
                 K=0
                 DO 413 J=1,M
                 IF (P(J).NE.I) GO TO 413
                 K=K+1
  413      CONTINUE
           IF (K.EQ.0) THEN
           WRITE(*,'('' Your clustering is wrong! We shall try another
     *     way!'')')
           IT=1
           GO TO 3
           ENDIF
  415      CONTINUE
      ENDIF
C
C------------- CLUSTERING INTO N1 - N2 CLUSTERS ---------------------------
C
      ICUT=1

      DO 14 N=N1,N2
            t1 = tcpu()
            IF (IDR.GT.0) WRITE(jout,103) N
            IF (IDR.GE.3) THEN
                WRITE(jout,106)
                WRITE(jout,104) (P(I),I=1,M)
            ENDIF
           CALL CLUDI(M,T,P,N,E,D,IDR,jout)
C--------------------------------------------------------------------------
           IF (IDR.GT.0) THEN
             WRITE(jout,107)
             WRITE(jout,104) (P(I),I=1,M)
             WRITE(jout,105) (E(J),J=1,N)
           ENDIF
C
C----- CRITERUM OF CLUSTERING: ((M-N)/(M-1))-(D/Z0) --> MAX ---------------
C
           IF (IDR.GE.1) THEN
                Z2=Z0-D
                DMEAN=(FLOAT(M-N))/(M-1)
                DREL=D/Z0
                CRIT=DMEAN-DREL
                WRITE(jout,110) D,DREL,DMEAN,CRIT
           ENDIF
C--------------------------------------------------------------------------
	     RMM=0.0
           DO 15 I=1,N
                 K=0
                 DO 13 J=1,M
                   IF (P(J).NE.I) GO TO 13
                    K=K+1
                   KL(K)=J
  13             CONTINUE
C----- CALCULATION OF MAX. DISTANCES BETWEEN MEMBERS OF CLUSTERS ---------
  	         CALL RMSMAX(K,T,KL,RM)
	         RMAX(I)=RM
	         IF (RM.GT.RMM) RMM=RM
                 LICZ(I)=K
                 DO J=1,K
                   NCONF(I,J)=KL(J)   
                 ENDDO
                 IF (IDR.GT.0) WRITE(jout,108) I,RMAX(I),(KL(J),J=1,K)
  15       CONTINUE
           do i=1,m
             iass(j)=p(j)
           enddo
C----- CHECK IF NEXT CUT-OFF IS REACHED
           IF (RMM .LT. RCUTOFF(ICUT)) THEN
             icut=icut+1
             do while (icut.le.ncut .and. rmm.lt.rcutoff(icut))
               icut=icut+1
             enddo  
             if (onscreen) print '(a,i2,a,f8.3)','icut',icut-1,' arbt',
     &       rcutoff(icut-1)
             WRITE (jout,'(/a,f10.5)') 'AT CUTOFF:',rcutoff(icut-1)
             write (jout,'(a,f8.2)') 'Maximum distance found:',rmm
             CALL SRTCLUST
             CALL TRACK(ICUT-1)
             CALL WRTCLUST(M,ICUT-1,ECUT,PRINTANG,ECEPPFORM,PRINTPDB)

             t2=tcpu()

             write (jout,'(/a,f10.1,a/)') 
     &        'TIME FOR PARTITIONING:',T2-T1,' SEC.'

             t1=tcpu()

             WRITE (jout,'(80(1H-))')

             IF (LGRP) CALL PRP(M)
             if (icut.gt.ncut) goto 16
           ENDIF
C
C--------------------- DIVISION OF THE WORST CLUSTER ----------------------
C
            IF (N.LT.N2) CALL DISMA(M,T,P,N,E,D,IDR,jout)
   14 CONTINUE
   16 CONTINUE
  103 FORMAT('0',2X,30('-'),I3,' CLUSTERS ',30('-'))
  104 FORMAT(10I5,200(/,10I5))
  105 FORMAT(' E(I)= '11F7.1)
  110 FORMAT(' SUM E=',F7.2,' D.REL=',F7.4,' D.MEAN=',F7.4,' CRITERION
     *OF CLUSTERING=',F7.4)
  106 FORMAT('  INITIAL CLUSTERING:')
  107 FORMAT('  FINAL CLUSTERING:')
  108 FORMAT(I3' CLUSTER, R.MAX='F6.2':'10I5,200(/,15X,10I5))
  109 FORMAT(1X,77('-'))
C 333 FORMAT(40a32)
      STOP
      END
C**************************************************************************
      SUBROUTINE DISMA(M,T,P,N,E,D,IDR,KO)
C
C        COSTRUCTION OF N+1 CLUSTERS FROM GIVEN N CLUSTERING
C
C        THE CLUSTER WITH GREATEST VARIANCE E(J) IS FOUND AND
C        PARTITIONED INTO TWO CLUSTERS ( J & N+1 ) USING DATA
C        MATRIX T AND SUBROUTINE KMEAN.
C
      include 'sizesclu.dat'
      DIMENSION P(maxconf), E(maxgr)
      DIMENSION T(maxdist),TC(maxdist), PC(maxconf), EC(maxgr)
      INTEGER P,PC
      NC=N+1
      EMAX=0
      DO 2 J=1,N
           EJ=E(J)
           IF (EJ.LE.EMAX) GO TO 2
           JC=J
           EMAX=EJ
    2 CONTINUE
      MC=0
      KC=1
      DO 4 I=1,M
           IF (P(I).NE.JC) GO TO 4
           MC=MC+1
           PC(MC)=KC
!  		TC(icant(I,I))=0.
		J1=I+1
		LC=MC
           DO 3 J=J1,M
			IF (P(J).NE.JC) GO TO 3
			LC=LC+1
c                print *,'i',i,' j',j,' mc',mc,' lc',lc,' ind',
c     &          icant(i,j),icant(mc,lc)
                TC(icant(MC,LC))=T(icant(I,J))
!                TC(LC,MC)=T(I,J)
    3 CONTINUE
      KC=KC+1
      IF (KC.GT.2) KC=1
    4 CONTINUE
      IF (MC.GT.2) CALL CLUDI(MC,TC,PC,2,EC,DC,IDR,KO)
      MC=0
      DO 5 I=1,M
           IF (P(I).NE.JC) GO TO 5
           MC=MC+1
           IF (PC(MC).EQ.2) P(I)=NC
    5 CONTINUE
      IF (IDR.LT.4) RETURN
      D=D-E(JC)+DC
      WRITE(KO,1) JC,JC,EC(1),NC,EC(2),D
    1 FORMAT(' CLUSTER'I3' DIVIDED INTO CLUSTERS'I3'(E='F6.2') AND'I3
     *'(E='F6.2'); NEW D='F6.2)
      RETURN
      END
C--------------------------------------------------------------------------
      SUBROUTINE CLUDI(M,T,P,N,E,D,IDR,KO)
C--------------------------------------------------------------------------
C
C      CLUSTERING OF DATA MATRICES T(M,M) ACCORDING TO THE KMEANS
C                             PRINCIPLE
C
C        E(J) IS THE SUM OF THE SQUARES OF DISTANCES BETWEEN THE
C        NEMBERS OF J-TH CLUSTER  AND  THEIR  CENTROID S( J,K ),
C        K=1,...,L . D IS THE SUM OF E(J).
C
C        FOR AN INITIAL ALLOCATION P(I), WITH 1 <= P(I) <= N AND
C        NON-EMPTY CLUSTERS , D IS REDUCED AS FAR AS POSSIBLE BY
C        REPEATED EXCHANGE OF CLUSTER MEMBERS, AND P(I) MODIFIED.
C        IF IDR >= 4, INTERMEDIATE RESULTS ARE PRINTED.
C--------------------------------------------------------------------------
      include 'sizesclu.dat'
      DIMENSION T(maxdist),P(maxconf),S(maxconf),E(maxgr),Q(maxgr),
     &          C(maxgr)
      INTEGER   P,Q,R,R1,S,H,U,V
	D=0.
	DO 5 J=1,N
	   R=0
	   E(J)=0.0
	   DO 1 I=1,M
		 IF (P(I).NE.J) GO TO 1
		 R=R+1
		 S(R)=I
    1    CONTINUE
	   R1=R-1
	   IF (R1.EQ.0) GO TO 4
	   F=0.0
	   DO 3 K=1,R1
		 K1=K+1
		 U=S(K)
		 DO 2 L=K1,R
		    V=S(L)
! 6/19/98 AL - T contains the RMS's and not their squares; code modified 
! accordingly
		    F=F+T(icant(U,V))**2
    2       CONTINUE
    3    CONTINUE
	   F=F/FLOAT(R)
	   E(J)=F
	   D=D+F
    4    Q(J)=R
    5 CONTINUE
	I=0
	IT=0
   12 IF (IDR.GE.4) WRITE (KO,11) I,D,(P(K),K=1,M)
   11 FORMAT (I4,F8.2,20I3,2(/,12X,20I3))
    6 I=I+1
	IF (I.GT.M) I=I-M
	IF (IT.EQ.M) RETURN
	R=P(I)
	U=Q(R)
	IF (U.LE.1) GO TO 6
	F=FLOAT(U)
	DO 7 J=1,N
	   C(J)=0.0
    7 CONTINUE
      DO 8 H=1,M
	   IF (H.EQ.I) GO TO 8
	   V=P(H)
! 6/19/98 AL - T contains the RMS's and not their squares; code modified 
! accordingly
	   C(V)=C(V)+T(icant(I,H))**2
    8 CONTINUE
	A=(F*E(R)-C(R))/(F-1.)
	AA=E(R)-A
	BB=1.E30
	DO 9 J=1,N
	   IF (J.EQ.R) GO TO 9
	   F=FLOAT(Q(J))
	   Y=(F*E(J)+C(J))/(F+1.)
	   YY=Y-E(J)
	   IF (YY.GE.BB) GO TO 9
	   BB=YY
	   B=Y
	   U=J
    9 CONTINUE
	IF (BB.LT.AA) GO TO 10
	IT=IT+1
	GO TO 6
   10 IT=0
	D=D-AA+BB
	E(R)=A
	E(U)=B
	Q(R)=Q(R)-1
	Q(U)=Q(U)+1
	P(I)=U
	GO TO 12
	END
C-----------------------------------------------------------------
	SUBROUTINE RMSMAX(K,T,KL,RM)
C-----------------------------------------------------------------
C     SEARCH FOR MAXIMAL DISTANCE BETWEEN MEMBERS OF CLUSTER
C-----------------------------------------------------------------
        include 'sizesclu.dat'
	DIMENSION T(maxdist),KL(maxconf)
! 6/19/98 AL - T contains the RMS's and not their squares; code modified 
! accordingly
        RM=0.0
        DO 1 M=1,K
           M1=M+1
	     K1=KL(M)
           DO 2 L=M1,K
		K2=KL(L)
    		IF (T(icant(K1,K2)).GT.RM) RM=T(icant(K1,K2))
    2	     CONTINUE				
    1 CONTINUE
!        RM=SQRT(RM2)
	RETURN
	END
