C $Date: 1994/10/04 16:18:25 $
C $Revision: 2.1 $
C
C
C
      SUBROUTINE PARAM (SUM)
C
C THIS SUBROUTINE ASSIGNS VALUES TO ARRAYS CONTAINING THE FOLLOWING
C INFORMATION FOR EACH ATOM OF THE SPECIFIED POLYPEPTIDE: ATOM TYPE
C FOR NONBONDED INTERACTIONS (NBTYPE), PARTIAL CHARGE (CHARGE), AND
C ALPHANUMERIC CHARACTERS SPECIFYING THE CHEMICAL TYPE (ALPH).  PARAM
C ALSO INITIALIZES THE ARRAY NPRE (SPECIFYING FOR EACH RESIDUE THE
C NUMBER OF ATOMS PRECEDING IT IN THE POLYPEPTIDE CHAIN), AND COMPUTES
C 'SUM' (THE NET CHARGE ON THE POLYPEPTIDE).
C
      INCLUDE 'PARAMET.ECEPP'
      INCLUDE 'COMMON.ATOMSS'
      INCLUDE 'COMMON.BONDSX'
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.GEN002X'
      INCLUDE 'COMMON.GEN004'
      INCLUDE 'COMMON.IOUNIT'
      INCLUDE 'COMMON.CHECK'
      INCLUDE 'COMMON.GEN000'
      INCLUDE 'COMMON.TOR2'
      INCLUDE 'COMMON.ENG000'
      LOGICAL LPROLIN
C
#ifdef PKSR
C
      INCLUDE 'COMMON.PARRAY'
#endif
C new changes from ecepp/3    DR. 8/92
C
      DIMENSION NZERO(5)
      DATA NZERO/0,0,22,23,24/
C
C ASSIGN PARAMETERS FOR THE AMINO END GROUP FROM THE STANDARD RESIDUE
C DATA, INCLUDING THE FIRST THREE ATOMS OF THE FIRST FULL AMINO ACID
C RESIDUE:
C
      NPRE(1) = 0
      LAMIN=LIST(1)
      KAMIN=KNDEND(LAMIN)
      KAMIN=IABS(KAMIN)
      NA = NDATOM(LAMIN)
C      WRITE (JOUT,*)' PARAM: LAMIN. KAMIN NA',LAMIN, KAMIN, NA
      DO 10 I = 1,NA
      ALPH(I) = EALPHA(I,LAMIN)
      NBTYPE(I) = NDTYPE(I,LAMIN)
      NAPTYP(I) =  KIND(NBTYPE(I))
      CHARGE(I) = ECHG(I,LAMIN)
 10   CONTINUE
      NA = NA - 3
C
C BEGINNING OF LOOP FOR EACH FULL AMINO ACID RESIDUE:
C
 20   LASTFL = INUMRS - 1
      DO 35 I = 2,LASTFL
      LISTI=LIST(I)
      LISTI = IABS(LISTI)
      KINDI=KNDRES(LISTI)
      KINDI=IABS(KINDI)
      NATOM = NATOMS(LISTI)
      NPRE(I) = NA
C
C K INDEXES (IN THE STANDARD RESIDUE DATA) THE FIRST ATOM WHOSE
C PARAMETERS WILL BE ASSIGNED TO THE POLYPEPTIDE ARRAYS.  IN GENERAL,
C K IS SET TO 1, INDEXING THE STARTING NITROGEN ATOM.  IF THIS IS THE
C FIRST FULL RESIDUE, K=4, SINCE PARAMETERS FOR THE FIRST 3 ATOMS HAVE
C ALREADY BEEN TAKEN FROM THE END GROUP DATA SET.  EXCEPTIONS ARE
C GLYCINE, PROLINE, HYDROXYPROLINE, AND IONIZED ASPARTIC ACID:
C LATELY MODIFIED TO ADD GAL'S MOLECULAR SWITCHES:SXY SLX; DR OCT93
C
      K = 1
      IF (I.EQ.2) THEN
         IF (KINDI.NE.6.AND.KINDI.NE.13.AND.KINDI.NE.22.AND.
     &       KINDI.NE.31.AND. KINDI.NE.38.AND. KINDI.NE.42 .AND. 
     &       KINDI.NE.43) K=4
C
C IF THE FIRST FULL RESIDUE IS A PROLINE OR HYDROXYPROLINE AND AN
C IMPROPER AMINO END GROUP (TYPE 1, 2, OR 3) WAS SPECIFIED, PRINT AN
C ERROR MESSAGE AND STOP:
C
         IF (LPROLIN(I)) THEN
            IF (KAMIN.EQ.1.OR.KAMIN.EQ.2.OR.KAMIN.EQ.3) THEN
#ifdef PKSR
      CALL PTHREAD_MUTEX_LOCK (IMUTEX, JSTAT)
#endif
               WRITE (JOUT,80)
#ifdef PKSR
      CALL PTHREAD_MUTEX_LOCK (IMUTEX, JSTAT)
#endif
C  This stop may produce problems in parallel applications
               STOP
            END IF
         END IF
      END IF
C
C ASSIGN THE REQUIRED PARAMETERS FOR THIS AMINO ACID RESIDUE FROM THE
C STANDARD RESIDUE DATA:
     
C     WRITE (JOUT,'(A,i4,A,i4,A,i5)') 'LIST(', I,')= ',LISTI,
C    &          'NPRE=',NPRE(I)
      DO 30 L=K,NATOM
         N = NA + L
         ALPH(N) = ALPHA(L,LISTI)
         NBTYPE(N) =  LTYPE(L,LISTI)
         NAPTYP(N) =  KIND(NBTYPE(N))
         CHARGE(N) = CHG(L,LISTI)
c         IF (KINDI.GT.50) THEN
c            WRITE (JOUT,'(A3,1x,i4,1x,f8.3)') 
c                       ALPH(N), NBTYPE(N),CHARGE(N)
c         END IF
30    CONTINUE
C
C IF THIS IS THE FIRST FULL RESIDUE AND THE END GROUP IS TYPE 1 OR 3,
C ASSIGN NBTYPE=14 FOR THE AMINO NITROGEN.  IF THE FIRST FULL RESIDUE
C IS A GLYCINE OR AN IONIZED ASPARTIC ACID, AND THE END GROUP IS TYPE
C 1 OR 2, CORRECT ALPH AND CHARGE:
C
      IF (I.EQ.2) THEN
         IF (KAMIN.EQ.1.OR.KAMIN.EQ.3) THEN
             NBTYPE(NA+1)=14
             NAPTYP(NA+1) =  KIND(NBTYPE(NA+1))
         ENDIF
         IF (KINDI.EQ.6.OR.KINDI.EQ.31) THEN 
             IF (KAMIN.EQ.1) THEN 
                 ALPH(3)=ALPH(1)
                 CHARGE(1)=1.03
C CORRECTION TO THE NEXT CHARGE INTRODUCED ON NOV-10-92  DR
                 IF (KINDI.EQ.6) THEN
                     CHARGE(2)=-4.22
                 ELSE IF (KINDI.EQ.31) THEN
                     CHARGE(2)=-4.38
                 ENDIF
                 CHARGE(3)=1.03
             ELSE IF (KAMIN.EQ.2) THEN
                  ALPH(4)=ALPH(2)
                  CHARGE(1)=  4.61
                  CHARGE(2)=  4.61
C CORRECTION TO THE NEXT CHARGE INTRODUCED ON NOV-10-92
                  IF (KINDI.EQ.6) THEN
                     CHARGE(3)=-3.11
                 ELSE IF (KINDI.EQ.31) THEN
                     CHARGE(3)=-3.27
                  ENDIF
                   CHARGE(4)=  4.61
              END IF
         END IF
      END IF
C
C END OF LOOP FOR EACH FULL AMINO ACID RESIDUE:
C
 35   NA = NA + NATOM
C
C ASSIGN PARAMETERS FOR THE CARBOXYL END GROUP FROM THE STANDARD
C RESIDUE DATA, FOR ALL ATOMS EXCEPT THE CARBONYL OXYGEN:
C
      NPRE(INUMRS) = NA
      LCARB = LIST(INUMRS)
      KCARB = KNDEND(LCARB)
      KCARB = IABS(KCARB)
      NATOM = NDATOM(LCARB)
      NPRE(INUMRS + 1) = NPRE(INUMRS) + NATOM - 1
      IF (NATOM .EQ. 1) GO TO 45
      NA = NA - 1
      DO 40 I = 2,NATOM
         N = NA + I
         ALPH(N) = EALPHA(I,LCARB)
         NBTYPE(N) = NDTYPE(I,LCARB)
         NAPTYP(N) =  KIND(NBTYPE(N))
         CHARGE(N) = ECHG(I,LCARB)
40    CONTINUE
C
C IF THE END GROUP IS TYPE 11 or 12, EQUALIZE THE CHARGE ON THE TWO
C OXYGEN ATOMS:
C
C new changes from ecepp/3    DR. 8/92
      IF (KCARB.NE.11.AND.KCARB.NE.12) GO TO 45
      LISTI=LIST(LASTFL)
      LISTI=IABS(LISTI)
      KINDI=KNDRES(LISTI)
      KINDI=IABS(KINDI)
      IF (KCARB.NE.11) GO TO 43
      IF (KINDI.NE.6) GO TO 42
      NN = NPRE(INUMRS-1) + 6
      CHARGE(NN)=6.67
      NN=NN+1
      CHARGE(NN)=-4.47
      NN=NN+1
      CHARGE(NN)=-4.32
      NN=NN+1
      CHARGE(NN)=2.97
      GO TO 45
 42   NN = NPRE(INUMRS-1) + 6
      CHARGE(NN)=6.66
      NN=NN+1
      CHARGE(NN)=-4.52
      GO TO 45
 43   IF (KCARB.NE.12) GO TO 45
      IF (KINDI.NE.6) GO TO 44
      NN = NPRE(INUMRS-1) + 6
      CHARGE(NN)=5.11
      NN=NN+1
      CHARGE(NN)=-8.57
      NN=NN+1
      CHARGE(NN)=-8.57
      GO TO 45
 44   NN = NPRE(INUMRS-1) + 6
      CHARGE(NN)=5.09
      NN=NN+1
      CHARGE(NN) = ECHG(1,LCARB)
C
C LOOP OVER ALL ATOMS IN THE POLYPEPTIDE, TO COMPUTE THE NET CHARGE,
C AND DETERMINE WHETHER ANY ATOM HAS BEEN ASSIGNED AN INVALID NONBONDED
C TYPE (12, 16, 22, 23 OR 24).  IF THIS IS THE CASE, PRINT AN ERROR
C MESSAGE AND STOP:
C
 45   SUM = 0.0
C     SUMP= 0.0
C     Psum= 0.0
      DO 60 I = 1,N
      DO 50 J = 1,5
      IF (NBTYPE(I).NE.NZERO(J)) GO TO 50
#ifdef PKSR
      CALL PTHREAD_MUTEX_LOCK (IMUTEX, JSTAT)
#endif
      WRITE (JOUT,90)  NBTYPE(I), I,  ALPH(I)
#ifdef PKSR
      CALL PTHREAD_MUTEX_LOCK (IMUTEX, JSTAT)
#endif
C  This stop may produce problems in parallel applications
      STOP
 50   CONTINUE
      SUM = SUM+CHARGE(I)
C      IF (I.GT. NPRE(5).AND.I.LE. NPRE(6)  ) THEN
C      Psum= Psum+CHARGE(I)
C      write (6,'(A3,1x,i4,1x,2f8.3)') 
C    &       ALPH(I), NBTYPE(I),CHARGE(I),Psum
C      END IF

C DR          JULY-93
c      WRITE(JOUT, 5553 ) I, ALPH(I), CHARGE(I), SUM
c5553  format (' atom (',i4,') ', A3, ' charge= ', f8.3,
c     & 'partial SUM=' f8.3)

C      DO 59 L = 2,INUMRS+1
C      IF (I.EQ. NPRE(L)) THEN
C         DIFCHG=(SUM-SUMP)/12.8841
CC        IF(ABS(DIFCHG).GT.0.5) WRITE(JOUT, 5554 ) (L-1), DIFCHG
C         WRITE(JOUT, 5554 ) (L-1), DIFCHG
C         SUMP=SUM
C      END IF
C 59   CONTINUE
C5554  format (' Charge of residue ',i4,' = ',f8.3)
 60   CONTINUE
      IF( ABS(SUM).GT.0.01 )THEN
#ifdef PKSR
      CALL PTHREAD_MUTEX_LOCK (IMUTEX, JSTAT)
#endif
         WRITE(JOUT, 5555 )SUM
#ifdef PKSR
      CALL PTHREAD_MUTEX_UNLOCK (IMUTEX, JSTAT)
#endif
      ENDIF
5555  FORMAT ('Total charge for the sequence= ',F8.3)
      RETURN
 80   FORMAT(/47H USE ENDGROUP 6, 7, OR 8 INSTEAD OF 1, 2, OR 3./)
 90   FORMAT(' YOU HAVE USED AN INVALID ATOM TYPE ',i2,1x,' ON ATOM ',
     & I4,1x,'IDENTIFIED AS ', A4/)
      END
