      subroutine drzewo(iout,iz)
*
* Procedura POdzial NATuralny sluzy do podzialu zbioru punktow na
* nieznana ilosc skupien w oparciu o macierz odleglosci. W pierwszej
* kolejnosci tworzony jest dendryt, ktory nastepnie ulega podzialowi.
*
      include 'sizesclu.dat'
      parameter (maxiz=maxconf)
      integer cio
      real min
      logical jest,zmiana
      integer w1(maxiz),w2(maxiz),nskup(maxgr),istskup(maxgr,maxingr)
      real dl(0:maxiz+1),iloraz(maxiz)
      logical presen
      common /clu/ dyst_orig(maxdist),energy(maxiz,4),
     &  ncut,rcutoff(10)
      common /clu1/is,nskup,istskup
      common /clu2/io,w1,w2,dl,iloraz
      common /clu3/ dyst(maxdist)

      do i=1,iz
        do j=i+1,iz
          kk = icant(i,j)  
          k = ((2*iz - i)*(i-1)) / 2 + j - i
          if (dyst_orig(kk).lt.1.0E-3) then
            dyst(k)=1.0E-3 
          else
            dyst(k)=dyst_orig(kk)
          endif
        enddo
      enddo
      do i=1,iz
        nskup(i)=1
        istskup(i,1)=i
      enddo
      is = iz
      io = 0
      do i=1,iz
        if (i.eq.1) then
          min = dyst(1)
        else
          min = dyst(i-1) 
        endif
        i1 = i
        i2 = 1
        do j=2,i-1
          k = ((2*iz - j)*(j-1)) / 2 + i - j
          d = dyst(k)
          if (d.lt.min) then
            min = d
            i2 = j
          endif
        enddo
        do j=i+1,iz
          k = ((2*iz - i)*(i-1)) / 2 + j - i
          d = dyst(k) 
          if (d.lt.min) then
            min = d
            i2 = j
          endif
        enddo

* i-te polaczenie znalezione : i1-i2 

        if (i1.gt.i2) then
          call zami(i1,i2)
          j = 0
          jest = .false.
          do while (.not.jest)
            j = j+1
            if (presen(i1,j)) then
              jest = .true.
              if (.not.presen(i2,j)) then
                io = io+1
                w1(io) = i1
                w2(io) = i2
                dl(io) = min
                k = 0
                jest = .false.
                do while (.not.jest)
                  k = k+1
                  jest = presen(i2,k)
                enddo
                call addset(j,k)
                is = is-1
                do l=k,is
                  nskup(l)=nskup(l+1)
                  do m=1,nskup(l)
                    istskup(l,m) = istskup(l+1,m)
                  enddo
                enddo
              endif
            endif
          enddo
        endif
      enddo

* znakowanie uwzglednionych odleglosci

      do i=1,is
        do j=1,iz
          if (presen(j,i)) then
            do k=j+1,iz
              if (presen(k,i)) then
                m = ((2*iz - j)*(j-1)) / 2 + k - j
                dyst(m) = -dyst(m) 
              endif
            enddo
          endif
        enddo
      enddo 
       
* skupienia wyzszych rzedow

      cio = (iz*iz - iz) / 2
      do while (is.gt.1)
        jj = 1
        do while (dyst(jj).lt.0.0 .and. (jj.lt.cio))
          jj = jj+1
        enddo
        if ((dyst(jj).lt.0.0) .and. (jj.eq.cio)) then
          is = 1
        else
          min = dyst(jj) 
          do i=jj+1,cio
            if ( (dyst(i).gt.0.0) .and. (dyst(i).lt.min)) then
              jj = i
              min = dyst(i) 
            endif 
          enddo
          i1 = 0
	  i2 = 0
          do while (i2.lt.1 .or. i2.gt.iz)
            i1 = i1+1
            i2 = jj+i1-((iz+iz-i1)*(i1-1))/2
          enddo
          do i=1,is
            if (presen(i1,i)) then
              j = i
            elseif (presen(i2,i)) then
              k = i
            endif
          enddo
          if (j.gt.k) call zami(j,k)
          io = io+1
          w1(io) = i1
          w2(io) = i2
          dl(io) = min
          call addset(j,k)
          is = is-1
          do i=k,is
            nskup(i)=nskup(i+1)
            do m=1,nskup(i)
              istskup(i,m) = istskup(i+1,m)
            enddo
          enddo
          if (is.gt.1) then
            do i=1,iz
              if (presen(i,j)) then
                jj = ((iz + iz - i)*(i-1)) / 2 - i
                do l=i+1,iz
                  if (presen(l,j)) then
                    m = jj + l
                    if (dyst(m).gt.0.0) dyst(m) = -dyst(m) 
                  endif
                enddo
              endif
            enddo
          endif
        endif
      enddo
 
* porzadkowanie dendrytu calkowitego

      zmiana=.true.
      do while (zmiana)
        zmiana = .false.
        do i=1,io-1  
          if (dl(i).gt.dl(i+1)) then
            zmiana = .true.
            k = i+1
            call zamr(dl(i),dl(k))
            call zami(w1(i),w1(k)) 
            call zami(w2(i),w2(k))
          endif
        enddo
      enddo

* wydruk dendrytu calkowitego

      write(iout,'(a)') 'MINIMAL TREE:'
      write(iout,'(a)') '      OBJECTS       DISTANCE   QUOTIENT'
      do i=io,2,-1
        iloraz(i) = dl(i)/dl(i-1)
      enddo
      iloraz(1)=0.0
      do j=io,1,-1
        write(iout,100) w1(j),w2(j),dl(j),iloraz(j)  
      enddo
  100 format (i8,i10,f10.4,f9.3)
      return
      end
****************************************************************************l
      subroutine podzial(iout,icut,iz)

      include 'sizesclu.dat'
      parameter (maxiz=maxconf)
      logical jest,zmiana,znalazlem
      integer w1(maxiz),w2(maxiz),nskup(maxgr),istskup(maxgr,maxingr)
      real dl(0:maxiz+1),iloraz(maxiz)
      logical juz(maxiz)
      logical presen
      common /clu/ dyst_orig(maxdist),energy(maxiz,4),
     &  ncut,rcutoff(10)
      common /clu1/is,nskup,istskup
      common /clu2/io,w1,w2,dl,iloraz
      common /clu3/ dyst(maxdist)

* podzial dendrytu

      k = 0
      l = 0
      i = io+2
      dl(0)=0.0
      dl(io+1)=1000.0
      rc=rcutoff(icut)

      write (iout,*)
      write (iout,*) 'AT CUTOFF: ',rc
      write (iout,*) 

      do while (i.gt.0)
        i = i-1
        l = l+1
*       if (iloraz(i).gt.1.1*iloraz(i+1) 
*    &      .or. iloraz(i).ge.1.5*iloraz(i-1)) then
        if (dl(i).gt.rc .and. dl(i-1).le.rc) then
          znalazlem = .true.
          k = k+1
          do j=1,l
            nskup(j) = 0
          enddo
          do j=i,1,-1
            juz(j) = .false.
          enddo
          zmiana = .false.
          jj = 0
          if (i.gt.1) then
            nskup(1)=2
            istskup(1,1) = w1(i-1)
            istskup(1,2) = w2(i-1)
            juz(i-1) = .true.
          else
            do i=1,iz
              nskup(i)=1
              istskup(i,1)=i
            enddo
            is=iz
            return
          endif
          do while (.not.zmiana)
            jj = jj+1
            zmiana=.true.
            do while (zmiana)
              zmiana = .false.
              do j=i-2,1,-1
                if (.not.juz(j)) then
                  if (nskup(jj).eq.0 .or. presen(w1(j),jj) .or.
     &                presen(w2(j),jj)) then
                    nsk=nskup(jj)
                    if (.not.presen(w1(j),jj)) then
		      istskup(jj,nsk+1)=w1(j)
		      nsk=nsk+1
		    endif
                    if (.not.presen(w2(j),jj)) then
		      istskup(jj,nsk+1)=w2(j)
		      nsk=nsk+1
		    endif
                    nskup(jj)=nsk
                    juz(j) = .true.
                    zmiana = .true.
                  endif
                endif
              enddo
            enddo
            zmiana = .true.
            do m=i-1,1,-1
              if (.not.juz(m)) zmiana = .false.
            enddo  
          enddo
          do j=1,iz
            jj = 0
            jest = .false.
            do while (.not.jest)
              jj = jj+1
              if (nskup(jj).eq.0 .or. presen(j,jj)) then
                jest = .true.
                if (.not.presen(j,jj)) then
                  nskup(jj)=1
                  istskup(jj,1) = j
                endif
              endif
            enddo 
          enddo
          is=l
        else
          znalazlem = .false.
        endif
      enddo
      return
      end
*****************************************************************************
      subroutine zami(i1,i2)
      ipom=i1
      i1=i2
      i2=ipom
      return
      end
*****************************************************************************
      subroutine zamr(x1,x2)
      xpom=x1
      x1=x2
      x2=xpom
      return
      end
****************************************************************************
      logical function presen(i,j)
      include 'sizesclu.dat'
      common /clu1/ is,nskup(maxgr),istskup(maxgr,maxingr)
      nskj=nskup(j)
      do k=1,nskj
        if (istskup(j,k).eq.i) then
          presen=.true.
          return
        endif
      enddo
      presen=.false.
      return 
      end 
****************************************************************************
      subroutine addset(i,j)
      include 'sizesclu.dat'
      common /clu1/ is,nskup(maxgr),istskup(maxgr,maxingr)
      nski=nskup(i)
      do k=1,nskup(j)
        istskup(i,nski+k)=istskup(j,k)
      enddo
      nskup(i)=nskup(i)+nskup(j)
      return
      end 
