      SUBROUTINE SPECV(LICZ)
C
C THIS SUBROUTINE DETERMINES VARIABLE DIHEDRAL ANGLES BASED ON THE INFORMATION
C READ IN READ_SPEC
C
C IVARFLAG=
C 1 ("BACK") VARIES ALL BACKBONE DIHEDRAL ANGLES
C 2 ("SIDE") VARIES ALL SIDECHAIN DIHEDRAL ANGLES
C 3 ("ALL ") VARIES ALL DIHEDRAL ANGLES
C 4 ("SPEC") MEANS THE USER SPECIFIES EXPLICITLY VIA DATA CARDS WHICH
C       DIHEDRAL ANGLES HE WANTS TO VARY
C 5 ("NONE") MEANS THERE ARE NO VARIABLE DIHEDRAL ANGLES
C 6 ("PHPS") VARIES PHI-PSI DIHEDRAL ANGLES
C 7 ("BKSD") VARIES PHI, PSI AND CHI'S.
C
C This subroutine is the modified subroutine SPECV of old ECEPP.
C Variable-angle specification is read in READ_SPEC and passed
C as the integer variable IVARFLAG. IVARFLAG=1 thru 7 corresponds
C to the former KV1 thru KV7. In addition to variable-angle
C specification of old ECEPP we introduced the possibility of
C specifying the _residues_ with variable angles, while still
C specifying the variable dihedrals in a "general" manner that
C is "ALL", "SIDE", etc. If "SPEC" is specified (IVARFLAG=4),
C the variable angles are read in READ_SPEC and SPECV will only
C print their indices for information.
C
C 20 Nov 1984: The last omega is no longer a variable for BACK and BKSD.
C
C 29 Feb 1984: 1. BKSD option corrected so that NV for proline equals 1.
C ----------------------------------------------------------------------
C As of August 2, 1993
C ***
      INCLUDE 'PARAMET.ECEPP'
C     CHARACTER *4 KV,KV1,KV2,KV3,KV4,KV5, KV6, KV7
      INTEGER KV,KV1,KV2,KV3,KV4,KV5, KV6, KV7
      INCLUDE 'COMMON.CNTRL' 
      INCLUDE 'COMMON.BONDSX'
      INCLUDE 'COMMON.CHECK'
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.GEN002X'
      INCLUDE 'COMMON.GEN004'
      INCLUDE 'COMMON.IOUNIT'
      INCLUDE 'COMMON.TORQUEX'
      INCLUDE 'COMMON.TOR2'
      INCLUDE 'COMMON.KVS'
      INCLUDE 'COMMON.PICK'
      logical lprolin

      CHARACTER*4  QKV(7)/'BACK','SIDE','ALL ','SPEC','NONE',
     &   'PHPS', 'BKSD' /
      DATA KV1,KV2,KV3,KV4,KV5,KV6,KV7 /1,2,3,4,5,6,7/
C
C READ KV
C Change 8/2/93 DR & AL: The KV is now passed from READ_SPEC. 
      KV=IVARFLAG
      IF (LICZ.EQ.1) WRITE (JOUT,200) QKV(KV)
      IF ( (NVARRES.EQ.0) .AND. (KV.NE.5) ) THEN
C This is for QKV= BACK, SIDE, ALL, PHPS,BKSD.
        NVARRES=INUMRS
        DO I=1,INUMRS
          NUMVARRES(I)=I
        ENDDO
      ELSE IF (KV.NE.4) THEN
        IF (LICZ.EQ.1) WRITE (JOUT,201) ( NUMVARRES(K), K=1,NVARRES)
  201 FORMAT('For residues in the following list ' ,/,20i4)
      ENDIF
      IF (KV.EQ.4) THEN
C  If  kv = 4 ("SPEC" flag), then, the variables NUMVR0 and NV0 were 
C  already set in read_spec routine.                          DR NOV93.
C            IF (NUMVAR.EQ.0) THEN
        IF (NUMVR0.EQ.0) THEN
           WRITE (JOUT,'(2A/A)')
     &      'Error in SPEC: the card VAR_ANGLES=SPEC was ',
     &      'specified in $CNTRL , but ',
     &      'no $SPEC card seems to be present in the input data'
           stop 
        ELSE
C Pass the variables read to local variables of the processor. 
C Also check for inconsistencies in the definition of variables,e.g.
C defining a number of variables larger than the total number 
C of dihedral angles for the residue or a variable PHI in PRO residues.
C  MAR95
           NUMVAR = 0
           DO I=1,INUMRS
             LISTI=IABS(LIST(I))
             INDIG=NCHI(LISTI)+3
             IF(NV0(I).GT.INDIG) THEN
                NV(I)=INDIG
                WRITE(JOUT,'(2a,i4,/a)')'SPEC WARNING: The number of',
     &            'variables specified for residue',i,
     &          ' exceeds the total number of dihedral for the residue'
             ELSE
                NV(I)=NV0(I)
             ENDIF
             KK=0
             DO K=1,NV(I)
                IF(LPROLIN(I).AND. (NDXARR0(K,I).EQ.1) )THEN
                   WRITE(JOUT,'(a,i4,a)')'SPEC WARNING: proline  PHI(',
     &                          I,') was specified as a variable'
                   NV(I)=NV(I)-1
                   NUMVAR = NUMVAR+1
                ELSE
                   KK=KK+1
                   NDXARR(KK,I)= NDXARR0(K,I)
                ENDIF
             ENDDO
           ENDDO
        ENDIF
      ELSE
        NUMVAR=0
        DO I=1,INUMRS
          NV(I)=0
        ENDDO
      ENDIF
C
C SET VARIABLES USED BELOW
      LASTFL=INUMRS-1
      LAST1=INUMRS+1
      LAMIN=LIST(1)
      LCARB=LIST(INUMRS)
      KAMIN=KNDEND(LAMIN)
      KCARB=KNDEND(LCARB)
      JFLAG=0
      DO 5 I=2,LASTFL
      LISTI=LIST(I)
      LISTI=IABS(LISTI)
      KINDI=KNDRES(LISTI)
      KINDI=IABS(KINDI)
      IF (KINDI.EQ.22) JFLAG=1
      IF (JFLAG.EQ.1) GO TO 6
 5    CONTINUE
 6    IF (LICZ .EQ. 1) THEN
         IF (JFLAG.EQ.1) WRITE(JOUT,1600)
      END IF
C
C SUBROUTINES AMINO AND CBOXL ARE NOT NEEDED IN SPECV BUT
C ARE CALLED HERE FOR CONVENIENCE.  THEY MUST NOT BE CALLED
C BEFORE KAMIN AND KCARB ARE DEFINED ABOVE.
c obsolete if only geometry is calculated.
c     CALL AMINO
c     CALL CBOXL
C
      IF (KV.EQ.KV5) RETURN
      IF (KV.EQ.KV4) GO TO 40
      IF (KV.EQ.KV2) GO TO 20
      IF ( KV .EQ. KV1 ) GO TO 10
      IF ( KV .EQ. KV3 ) GO TO 10
      IF ( KV .EQ. KV6 ) GO TO 10
      IF ( KV .EQ. KV7 ) GO TO 10
C       UNRECOGNIZED OPTION.
      GO TO 44
C
C BACKBONE
C THIS SECTION IS FOR KV "BACK" OR "ALL "; I.E., ALL BACKBONE ANGLES ARE
C VARIED.  ALSO FOR KV "PHPS" or "BKSD".
C
C 1ST WE TAKE CARE OF THE NON-END GROUPS
C10   DO 14 I=2,LASTFL
 10   DO 14 II=1,NVARRES
      I=NUMVARRES(II)
      IF (I.EQ.1) GOTO 18 
      IF (I.EQ.INUMRS) GOTO 19 
      NV(I)=3
      IF ( KV .EQ. KV6 .OR. KV .EQ. KV7 ) NV(I) = 2
      NOPHI=0
      LISTI=LIST(I)
      LISTI=IABS(LISTI)
      KINDI=KNDRES(LISTI)
      KINDI=IABS(KINDI)
      IF(KINDI.NE.13.AND.KINDI.NE.22) GO TO 12
 11   NOPHI=1
      NV(I)=2
      IF ( KV .EQ. KV6 .OR. KV .EQ. KV7 ) NV(I) = 1
 12   IF (I.NE.LASTFL) GO TO 121
      LISTN=LIST(INUMRS)
      KINDN=KNDEND(LISTN)
C     IF ( KV .EQ. KV6 .OR. KV .EQ. KV7 ) NV(I) = NV(I) + 1   
      IF (KINDN.NE.12.AND.KINDN.NE.20) GO TO 121
      NV(I)=NV(I) - 1
 121  NVR=NV(I)
      DO 13 L=1,NVR
 13   NDXARR(L,I)=L+NOPHI
      GOTO 14 
C
C NOW WE CONSIDER THE AMINO END
18    NDIHED=NBOND(LAMIN)
      NV(1)=NDIHED
      IF(NDIHED.EQ.0) GO TO 16
      DO 15 L=1,NDIHED
 15   NDXARR(L,1)=L
 16   CONTINUE
      GOTO 14
C
C NOW WE CONSIDER THE CARBOXYL END
19    NDIHED=NBOND(LCARB)-1
      IF(NDIHED.LE.0) GO TO 14
      NV(INUMRS)=NDIHED
      DO 17 L=1,NDIHED
 17   NDXARR(L,INUMRS)=L
 14   CONTINUE
      NUMVAR=1
C
C DOES THE USER WANT TO VARY ONLY THE BACKBONE DIHEDRAL ANGLES?
      IF ( KV .EQ. KV1 .OR. KV .EQ. KV6 ) RETURN
C
C SIDECHAIN
C THIS SECTION IS FOR KV "SIDE" OR "ALL "; I.E., ALL SIDECHAIN ANGLES
C ARE VARIED
C
C20   DO 22 I=2,LASTFL
 20   DO 22 II=1,NVARRES
      I=NUMVARRES(II)
      IF (I.EQ.1 .OR. I.EQ.INUMRS) GOTO 22
      LISTI=LIST(I)
      LISTI=IABS(LISTI)
      NUMCHI=NCHI(LISTI)
      IF(NUMCHI.EQ.0) GO TO 22
      NVBACK=NV(I)
      NV(I)=NVBACK+NUMCHI
      DO 21 L=1,NUMCHI
      LP=L+NVBACK
 21   NDXARR(LP,I)=L+3
 22   CONTINUE
      NUMVAR=1
C     RETURN
C
C USER SPECIFIES
C THIS SECTION IS USED WHEN THE READER WANTS TO SPECIFY THE ANGLES TO BE
C VARIED.  THE USER GIVES THE RESIDUE NUMBER, THE NUMBER OF VARIABLES IN
C THAT RESIDUE, AND THE ANGLES TO BE VARIED.
C  the following variables were already read in read_spec routine in this
C version.   DR NOV93.
C
C Uncomment the following line for printing of variable angles
40    CONTINUE
      IF (LICZ .EQ. 1 .AND. (KV.NE.3) ) THEN
         WRITE (JOUT,300)
      END IF
      DO 42 I=1,LAST1
      NVAR=NV(I)
      IF (NVAR.EQ.0) GOTO 42
      IF (LICZ .EQ. 1 .AND. (KV.NE.3) ) THEN
         WRITE(JOUT,500) I,NVAR,(NDXARR(K,I),K=1,NVAR)
      END IF
 42   CONTINUE
      RETURN
  44  WRITE (JOUT,700)
      STOP
  100 FORMAT (A4)
  200 FORMAT(/,'Angles to be treated as variables ' ,A4)
  300 FORMAT (/, ' Res.No.  ',' variables','   angles to be varied')
  400 FORMAT (16I5)
  500 FORMAT (I5,5X,I5,5X,12I5)
 1600 FORMAT(/,' The internal conformational energy of the fixed part ',
     1 'of the',/, ' hydroxyproline ring is not included in EPRO.' )
  700 FORMAT (/1X,'Illegal input data for variable KV as read in ',
     1 ' subroutine SPECV.' )
      END

