      logical function find_arg(ipos,line,errflag)
      parameter (maxlen=80)
      character*81 line
      character*1 empty /' '/,equal /'='/
      logical errflag
* This function returns .TRUE., if an argument follows keyword keywd; if so
* IPOS will point to the first non-blank character of the argument. Returns
* .FALSE., if no argument follows the keyword; in this case IPOS points
* to the first non-blank character of the next keyword.
      do while (ipos.le.maxlen .and. line(ipos:ipos).eq.empty )
        ipos=ipos+1
      enddo 
      errflag=.false.
      if (ipos.le.maxlen .and. line(ipos:ipos).eq.equal) then
         find_arg=.true.
         ipos=ipos+1
         do while (line(ipos:ipos) .eq. empty .and. ipos.le.maxlen)
           ipos=ipos+1
         enddo
         if (ipos.gt.maxlen) errflag=.true.
      else
         find_arg=.false.
      endif
      return
      end
c------------------------------------------------------------------------------
      logical function find_group(iunit,jout,key1)
      character*(*) key1
      character*81 karta,ucase
      integer ilen
      logical lcom
      rewind (iunit)
      karta=' '
      ll=len_trim(key1)
      do while (index(ucase(karta),key1(1:ll)).eq.0.or.lcom(1,karta)) 
        read (iunit,'(a)',end=10) karta
      enddo
      write (jout,'(2a)') '> ',karta(1:78)
      find_group=.true.
      return
   10 find_group=.false.
      return
      end
c------------------------------------------------------------------------------
      logical function iblnk(charc)
      character*1 charc
      integer n
      n = ichar(charc)
      iblnk = (n.eq.9) .or. (n.eq.10) .or. (charc.eq. ' ')
      return
      end
c------------------------------------------------------------------------------
      integer function ilen(string)
      character*(*) string
#ifndef AIX
      entry len_trim(string)
#endif
      logical iblnk
 
      ilen = len(string)
1     if ( ilen .gt. 0 ) then
         if ( iblnk( string(ilen:ilen) ) ) then
            ilen = ilen - 1
            goto 1
         endif
      endif
      return
      end
c------------------------------------------------------------------------------
      integer function in_keywd_set(nkey,ikey,narg,keywd,keywdset)
      character*16 keywd,keywdset(1:nkey,0:nkey)
      character*16 ucase
      do i=1,narg
        if (ucase(keywd).eq.keywdset(i,ikey)) then
* Match found
          in_keywd_set=i
          return
        endif
      enddo
* No match to the allowed set of keywords if this point is reached. 
      in_keywd_set=0
      return
      end
c------------------------------------------------------------------------------
      character*(*) function lcase(string)
      integer i, k, idiff
      character*(*) string
      character*1 c
      character*40 chtmp
c
      i = len(lcase)
      k = len(string)
      if (i .lt. k) then
         k = i
         if (string(k+1:) .ne. ' ') then
            chtmp = string
         endif
      endif
      idiff = ichar('a') - ichar('A')
      lcase = string
      do 99 i = 1, k
         c = string(i:i)
         if (lge(c,'A') .and. lle(c,'Z')) then
            lcase(i:i) = char(ichar(c) + idiff)
         endif
   99 continue
      return
      end
c------------------------------------------------------------------------------
      logical function lcom(ipos,karta)
      character*81 karta
      character koment(2) /'!','#'/
      lcom=.false.
      do i=1,2
        if (karta(ipos:ipos).eq.koment(i)) lcom=.true.
      enddo 
      return
      end
      logical function lower_case(ch)
      character*(*) ch
      lower_case=(ch.ge.'a' .and. ch.le.'z')
      return
      end
c------------------------------------------------------------------------------
      subroutine mykey(line,keywd,ipos,blankline,errflag) 
* This subroutine seeks a non-empty substring keywd in the string LINE.
* The substring begins with the first character different from blank and
* "=" encountered right to the pointer IPOS (inclusively) and terminates
* at the character left to the first blank or "=". When the subroutine is 
* exited, the pointer IPOS is moved to the position of the terminator in LINE. 
* The logical variable BLANKLINE is set at .TRUE., if LINE(IPOS:) contains
* only separators or the maximum length of the data line (80) has been reached.
* The logical variable ERRFLAG is set at .TRUE. if the string 
* consists only from a "=".
      parameter (maxlen=80)
      character*1 empty /' '/,equal /'='/,comma /','/
      character*(*) keywd
      character*81 line
      logical blankline,errflag,lcom
      errflag=.false.
      do while ( (ipos.le.maxlen) .and. line(ipos:ipos).eq.empty)
        ipos=ipos+1
      enddo
      if (ipos.gt.maxlen .or. lcom(ipos,line) ) then 
* At this point the rest of the input line turned out to contain only blanks
* or to be commented out.
        blankline=.true.
        return
      endif
      blankline=.false.
      istart=ipos
* Checks whether the current char is a separator.
      do while (line(ipos:ipos).ne.empty .and. line(ipos:ipos).ne.equal
     & .and. line(ipos:ipos).ne.comma .and. ipos.le.maxlen) 
        ipos=ipos+1
      enddo
      iend=ipos-1 
* Error flag set to .true., if the length of the keyword was found less than 1.
      if (iend.lt.istart) then
        errflag=.true.
        return
      endif
      keywd=line(istart:iend)
      return
      end      
c------------------------------------------------------------------------------
      subroutine numstr(inum,numm)
      character*10 huj /'0123456789'/
      character*(*) numm
      character*9 form 
#ifdef HUJ
      inumm=inum
      inum1=inumm/10
      inum2=inumm-10*inum1
      inumm=inum1
      numm(3:3)=huj(inum2+1:inum2+1)
      inum1=inumm/10
      inum2=inumm-10*inum1
      inumm=inum1
      numm(2:2)=huj(inum2+1:inum2+1)
      inum1=inumm/10
      inum2=inumm-10*inum1 
      inumm=inum1
      numm(1:1)=huj(inum2+1:inum2+1)
#else
      form='(bz,i . )'
      write (form(6:6),'(i1)') len(numm)
      write (form(8:8),'(i1)') len(numm)
c      print *,'form=',form
      write (numm,form) inum
#endif
      return
      end       
C------------------------------------------------------------------------------
      subroutine read_data_group(jin,jout,nkwd,keywdset,narg,flag,cflag)
* Column 0 of the array keywdset contains the "main" keywords.
* Columns 1 thru nkwd contain the arguments (if any) that correspond
* to the specific keywords of column 0. The numbers of arguments are
* stored in the array narg; the zeroth element of the latter array 
* is the number of "main" keywords.
      parameter (errind=-1.0D10)
      character*16 keywd,keyarg,keywdset(1:nkwd,0:nkwd) 
      character*81 line,ucase
      dimension narg(0:nkwd),flag(0:nkwd)
      character*16 cflag(0:nkwd)
      logical errflag,blankline,found_arg,find_arg
c
      data izero /0/, ione /1/, itwo /2/, ithree /3/,ifour /4/,
     &  ifive /5/, isix /6/, isev /7/

      do i=0,nkwd
        cflag(i)=' '
        flag(i)=0.0
      enddo   
      read (jin,'(a)',end=10) line
      write (jout,'(2a)') '> ',line(1:78)
* Process the following lines of the data group until the end flag is
* met.
      do while (index(ucase(line),'$END').eq.0)
        ipos=1
* Find the first keyword in the current line.
        keywd=' '
        keyarg=' '
        call mykey(line,keywd,ipos,blankline,errflag) 
        do while (.not.blankline)
          if (errflag) then
            flag(0)=errind
            call errout(jout,nkwd,izero,keywd,line,narg,keywdset,ione)
          endif
          if (.not.blankline) then
* Check whether the found keyword is in the keyword set.
            ikey=in_keywd_set(nkwd,0,narg(0),keywd,keywdset)
* Check whether an argument follows the keyword.
            found_arg=find_arg(ipos,line,errflag)
* If an argument was found, read it into the KEYARG string.
            if (.not.errflag .and. found_arg)
     &        call mykey(line,keyarg,ipos,blankline,errflag)
            if (ikey.gt.0) then
* The found keyword does belong to the set of allowed keywords.
              if (narg(ikey).gt.0) then
* Case 1. The found keyword has arguments.
                if (errflag .or. blankline) then
* Errors have occurred when reading the argument.
                  flag(ikey)=errind
                  call errout(jout,nkwd,ikey,keyarg,line,narg,keywdset,
     &                                   itwo)
                else if (.not.found_arg) then
* An argument was expected to follow the keyword, but none was found.
                  flag(ikey)=errind
                  call errout(jout,nkwd,ikey,keywd,line,narg,keywdset,
     &                                   ifour)
                else 
* An argument was expected and received.
                  if (index(keywdset(1,ikey),'NUM').gt.0) then
* A numeric arguments is expected.
                    read (keyarg,*,err=30) flag(ikey)
                    goto 40
   30               flag(ikey)=errind
                    call errout(jout,nkwd,ikey,keyarg,line,narg,
     &                                        keywdset,ithree)
   40               continue
                  else if (index(keywdset(1,ikey),'CHAR').gt.0) then
* Any string is expected as an argument.
                    flag(ikey)=-1
                    cflag(ikey)=keyarg
                  else 
* The argument must belong to the pre-specified set of allowed sub-keywords.
                    iarg=in_keywd_set(nkwd,ikey,narg(ikey),keyarg,
     &                  keywdset)
                    if (iarg.gt.0) then
* Match found. Set FLAG(IKEY) to the position of the argument in 
* the sub-keyword array.
                      flag(ikey)=float(iarg)
                    else
* No match to sub-keywords. 
                      call errout(jout,nkwd,ikey,keyarg,line,narg,
     &                            keywdset,isix)
                      flag(ikey)=errind
                    endif
                  endif 
                endif
              else if (found_arg) then
* Argument received, but not expected to this keyword.
                call errout(jout,nkwd,ikey,keyarg,line,narg,keywdset,
     &                                 ifive)
                flag(ikey)=errind
              else
* Argument not received and not expected. Set FLAG(IKEY) at 1 to indicate 
* that the keyword has appeared.
                flag(ikey)=1.0
              endif
            else
* The keyword doesn't match the allowed-keyword set.
c             ipos=ipos+1
              flag(0)=errind
              call errout(jout,nkwd,0,keywd,line,narg,keywdset,
     &                           iseven)
            endif
          endif
* Find the next keyword in the current line.
          keywd=' '
          keyarg=' '
          call mykey(line,keywd,ipos,blankline,errflag) 
        enddo  
* Read the next line belonging the the curent data group.
        read (jin,'(a)',end=10) line
        write (jout,'(2a)') '> ',line(1:78)
      enddo
      return
   10 write (jout,100) jin
      flag(0)=errind
      return
  100 format (//'******* Error - end of data on unit',i3,' before',
     & ' a valid terminator was found.')
      end
c------------------------------------------------------------------------------
      character*(*) function ucase(string)
      integer i, k, idiff
      character*(*) string
      character*1 c
      character*40 chtmp
c
      i = len(ucase)
      k = len(string)
      if (i .lt. k) then
         k = i
         if (string(k+1:) .ne. ' ') then
            chtmp = string
         endif
      endif
      idiff = ichar('a') - ichar('A')
      ucase = string
      do 99 i = 1, k
         c = string(i:i)
         if (lge(c,'a') .and. lle(c,'z')) then
            ucase(i:i) = char(ichar(c) - idiff)
         endif
   99 continue
      return
      end
c------------------------------------------------------------------------------
      subroutine concat(a,b,c)
      character*(*) a,b,c
      character*1 aux
      ind=0
      c=' '
      do 1 i=1,len_trim(a)
        aux=a(i:i)
        if (aux.eq.' ') goto 1
        ind=ind+1
        c(ind:ind)=aux
    1 continue
      do 2 i=1,len_trim(b)
        aux=b(i:i)
        if (aux.eq.' ' ) goto 2
        ind=ind+1
        c(ind:ind)=aux
    2 continue
      return
      end
C******************************************************************************
      SUBROUTINE EXCHR(A,B)
      AUX=A
      A=B
      B=AUX
      RETURN
      END
C******************************************************************************
      SUBROUTINE EXCH(IA,IB)
      IAUX=IA
      IA=IB
      IB=IAUX
      RETURN
      END
