      program analyze
*
*    This program processes EDMC *.ang files in order to:
*
* -  calculate molecular properties (rms deviation from the chosen structure,
*    radius of gyration, principal axes of the molecular ellipsoid, 
*    number of hydrophobic contacts, molecular volume) during the course 
*    of EDMC simulations;
*
* -  perform cluster analysis of the sets of conformations resulting from 
*    EDMC;
*
* -  calculate Boltzmann-averaged conformation(s) and their fluctuations. 
* 
* ECEPP/3 geometry only is applied in the present version.
* No energy evaluation/minimization routines are included.
*
*        --- As of 6/22/99
*
      include 'PARAMET.ECEPP'
      include 'PARAMET.ADD'
      include 'sizesclu.dat'
      include 'COMMON.IOUNIT'
      include 'COMMON.CNTRL'
      include 'COMMON.CNTRL1'
      include 'COMMON.FILES'
      include 'COMMON.HEADER'
      character*24 today
      character*64 runtyp(7)
     & /'calculate conformation-dependent properties.',
     &  'Boltzmann-average Cartesian coordinates.',
     &  'Boltzmann-average interproton distances.',
     &  'perform a cluster analysis.',
     &  'calculate dihedrals from the supplied Cartesian coordinates.',
     &  'filter conformations compatible with the NMR data.',
     &  'calculate/fit the NOE spectra for the supplied conformations.'/

#ifdef AIX
      call fdate_(today)
#else
      call fdate(today)
#endif
      call set_defaults
      write (jout,'(80(1h*)/2a)')
     &  'ANALYZE - program to process EDMC outo.* files; run on ',today
      call readkey
      write (jout,'(a/80(1h*))') title
      write (jout,'(2a)')
     & 'Main input file        : ',infile,
     & 'List file              : ',outfile,
     & 'Input angle file       : ',savefile,
     & 'Output angle file      : ',angfile,
     & 'Residue ECEPP data base: ',readfile
      write (jout,'(/2a)') 'This run will ',runtyp(iruntyp)
      call setup
      call read_angles
cd    print '(a)','Run set up.'

      goto (110,120,130,140,150,160,170) iruntyp

  110 call calc_prop
      call print_prop
      if (dist_prop) call prop_distr
      stop 110
  120 call ave_coord
      stop 120
  130 call ave_dist
      stop 130
  140 call clustconf
      stop 140
  150 call calc_angles
      stop 150
  160 call nmr_filter
      stop 160
  170 call morass_interface
      stop 170
      end
