      subroutine readkey
      include 'PARAMET.ECEPP'
      parameter (iempt=maxnumdatag-12)
      character*16 keywdup(maxnumdatag) 
     & /'$TITLE','$CNTRL','$SEQ','$BRIDGE','$PROPERTY','$RMSCALC',
     &  '$BOUNDS','$CHROMO','$CLUSTER','$MORASS','$NOES','$MARQUARDT',
     &   iempt*' '/
      include 'COMMON.IOUNIT'
      include 'COMMON.CNTRL'
      include 'COMMON.DATA_READ'
      include 'COMMON.VTFEX'
      include 'COMMON.MOVE'
      include 'COMMON.XBOUNDX'
      logical find_group
      write (jout,1000)
 1000 format (80(1h*)/'Echo of the input data and error messages of ',
     & 'the data-reading routines:'/)
      do 100 ikey=1,12
        il=len_trim(keywdup(ikey))
        rewind (jin)
        if (find_group(jin,jout,keywdup(ikey))) then
          present(ikey)=.true.
C         write (jout,'(a,i2,a)')'present(',ikey,')'
          goto (110,120,130,140,150,160,170,180,190,200,210,220) ikey
        endif
        if (ikey.eq.2 .or. ikey.eq.3) then
          write (jout,*)
          write (jout,'(3a)') '******** Fatal error. The data group ',
     &                 keywdup(ikey)(1:il),' is missing. Stop.'
          write (jout,*)
          stop
        endif 
        goto 100
  110   call read_title(jin,jout,errflag(1))
        goto 10
  120   call read_control(jin,jout,errflag(2))
        goto 10
  130   continue



        call inputt
	call read_seq(jin,jout,errflag(3))
        goto 10
  140   call read_bridge(jin,jout,errflag(4))
        goto 10
  150   call read_proptyp(jin,jout,errflag(5))
        goto 10
  160   call read_rmscalc(jin,jout,errflag(6))
        goto 10
  170   call read_bounds(jin,jout,errflag(7))
        goto 10
  180   call read_chromo(jin,jout,errflag(8))
        goto 10
  190   call read_cluster(jin,jout,errflag(9))
        goto 10
  200   continue
        print *,'Calling Read_Morass'
        call read_morass(jin,jout,errflag(10))
c       print *,'Exited Read_Morass, calling Read_Hlab'
c       call read_Hlab(labelh,jout,errflag(11))
c       print *,'Exited Read_Hlab'
c       if (errflag(11)) then
c         write (jout,'(a)') 'Error in Hlabel file!'
c         errflag(10)=.true.
c       endif
        goto 10
  210   call read_noesetup(jin,jout,errflag(11))
        goto 10
  220   call read_marquardt(jin,jout,errflag(12))
        goto 10
C
   10   if (errflag(ikey)) then
          write(jout,111) keywdup(ikey)(1:il)
        else
          write(jout,112) keywdup(ikey)(1:il)
        endif
  100 continue
C
  105 continue
      do ikey=1,maxnumdatag
        if (errflag(ikey)) then
          write (jout,113)
          stop
        endif
      enddo
      write (jout,1010)
 1010 format (/'Input data from the main input file have been read in ',
     & '- no errors detected.'/80(1h*))
      return
  111 format ('Errors detected in data group ',a12,'.')
  112 format ('Normal termination of reading the data group ',a12,'.')
  113 format ('Calculation terminated due to error(s).')
      end 
c------------------------------------------------------------------------------
      subroutine read_control(jin,jout,errflag)
      include 'PARAMET.ECEPP'
      include 'PARAMET.ADD'
      include 'COMMON.CLUSPRN'
* Number of keywords in this data group
      parameter (nkwd=18)
      parameter (errind=-1.0D10)
      character*16 keywdset(1:nkwd,0:nkwd) /'RUNTYP','VERBOSE','NRES',
     & 'RES_CODE','PRINT_PDB','FILE','VIRT_CHAIN','BETA_TURNS',
     & 'CHIRALITY','H_BONDS','T','NRCLUS1','NRCLUS2','TREE','DISTMAT',
     & 'FULLPRINT','PLOT_TREE','RES_DBASE', 
     & 'PROPERTY','AVE_COORD','AVE_DIST','CLUSTER','ANGLES','FILTER',
     & 'MORASS',11*' ',
     & 18*' ', 
     & 'NUM',17*' ',
     & 'ECEPP','THREE_LETTER','ONE_LETTER',15*' ',
     & 'NUM',17*' ',
     & 'CHAR',17*' ',
     & 18*' ',
     & 18*' ',
     & 18*' ',
     & 18*' ',
     & 'NUM',17*' ',
     & 'NUM',17*' ',
     & 'NUM',17*' ',
     & 18*' ',18*' ',18*' ',18*' ',
     & 'CHAR',17*' '/
      integer narg(0:nkwd) /18,7,0,1,3,1,1,0,0,0,0,1,1,1,0,0,0,0,1/

      dimension flag(0:nkwd)
      character*16 cflag(0:nkwd)
      logical errflag
      include 'COMMON.CNTRL'
      include 'COMMON.CNTRL1'
      include 'COMMON.FILES'
      include 'COMMON.SETUP'
      include 'COMMON.PDBFILE'
      include 'COMMON.KVS'
      include 'COMMON.TIME1'
      include 'COMMON.SUPER'

      call read_data_group(jin,jout,nkwd,keywdset,narg,flag,cflag)
      errflag=.false.
      do i=0,nkwd
        if (flag(i).eq.errind) errflag=.true.
      enddo
      if (flag(1).ne.0.0) iruntyp=aint(flag(1))
      onscreen = (flag(2).gt.0.0)
c     print *,'onscreen=',onscreen
      lprint1 = (flag(16).gt.0.0)
c     print *,'lprint1=',lprint1
      nres = aint(flag(3))
      if (flag(4).ne.0.0) icode=aint(flag(4))
      printcoord = (flag(5).gt.0.0)
      npdb_write = aint(flag(5))
      if (printcoord) then
        if (len_trim(cflag(6)).gt.0) then
          coorpref = cflag(6)
        else
          call getenv('COORPREF',coorpref)
          if (len_trim(coorpref).eq.0) coorpref = 'coords'
        endif
      endif
      virt_chain = (flag(7).gt.0.0)
      turns = (flag(8).gt.0.0) 
      chirality = (flag(9).gt.0.0)
      h_bonds = (flag(10).gt.0.0)
      if (flag(11).gt.0.0) temper = flag(11)
      if (temper.eq.0.0) temper=298.0
      betbol=1.0/(1.987E-3*temper)
      nrclust1=aint(flag(12))
      nrclust2=aint(flag(13))
c     write(jout, *)'nrclust1=',nrclust1,' nrclust2=',nrclust2
      tree=(flag(14).gt.0.0)
      print_distmat=(flag(15).gt.0.0)
      plot_tree=(flag(17).gt.0.0)
cd    print *,'plot_tree=',plot_tree
      if (len_trim(cflag(18)).gt.0) then
        if (index(cflag(18),'/').eq.0) then
          readfile = dbs//cflag(18)
        else
          readfile = cflag(18)
        endif 
      endif
      return
      end
c------------------------------------------------------------------------------
      subroutine read_proptyp(jin,jout,errflag)
      include 'PARAMET.ECEPP'
      include 'PARAMET.ADD'
      include 'COMMON.CNTRL'
      include 'COMMON.CNTRL1'
      include 'COMMON.PDBFILE'
      include 'COMMON.SUPER'
      logical errflag
* Number of keywords in this data group
      parameter (nkwd=7)
      parameter (errind=-1.0D10)
      dimension flag(0:nkwd)
      character*16 cflag(0:nkwd)
      character*16 keywdset(1:nkwd,0:nkwd) /
     & 'ELLIPSE','RMS','NMR','CONTACTS','CHROM_DIST','DIST_PROP',
     & 'PROP_FILE',
     & 'AXES','VOLUME','RGYR','ALL',3*' ',
     & 'OVERALL','ARRAY',5*' ',
     & 7*' ',
     & 'HYDROPHOBIC','HYDROPHILIC','ALL',4*' ',
     & 7*' ',
     & 7*' ',
     & 'CHAR',6*' '/
      integer narg(0:nkwd) /7,4,2,0,3,0,0,1/
      call read_data_group(jin,jout,nkwd,keywdset,narg,flag,cflag)
      errflag=.false.
      do i=0,nkwd
        if (flag(i).eq.errind) errflag=.true.
      enddo
      lellips = (flag(1).gt.0.0)
      if (lellips) then
        if (flag(1).eq.4.0) then
          axes=.true.
          volume = .true.
          rgyr = .true.
        else
          axes = (flag(1).eq.1.0)
          volume = (flag(1).eq.2.0)
          rgyr = (flag(1).eq.3.0)
        endif
      endif
      lrms = (flag(2).gt.0.0)
      larray = (flag(2).eq.2.0) 
      lnmr = (flag(3).gt.0.0)
      lcont = (flag(4).gt.0.0)
      if (lcont) then
        if (flag(4).eq.3) then
          hydrophobic=.true.
          hydrophilic=.true.
        else
          hydrophobic=(flag(4).eq.1.0)
          hydrophilic=(flag(4).eq.2.0)
        endif
      endif
      chrom_dist = (flag(5).gt.0.0)
      dist_prop = (flag(6).gt.0.0)
      if (len_trim(cflag(7)).gt.0) then
        prop_file = cflag(7)
      else 
        call getenv('PREFIX',prop_file)
        if (len_trim(prop_file).eq.0) prop_file = 'prop'
      endif
cd    print '(2a)','prop_file ',prop_file
Cd    pause
      
      return
      end
c------------------------------------------------------------------------------
      subroutine read_rmscalc(jin,jout,errflag)
      include 'PARAMET.ECEPP'
      include 'PARAMET.ADD'
      include 'COMMON.CNTRL1'
      include 'COMMON.SUPER'
      include 'COMMON.CLUSTAT'
      include 'COMMON.PDBFILE'
      include 'COMMON.SETUP'
      logical errflag
* Number of keywords in this data group
      parameter (nkwd=5)
      parameter (errind=-1.0D10)
      character*16 keywdset(1:nkwd,0:nkwd) /
     & 'REF_FILE','NRSUP1','NRSUP2','PRINT','NRSUP_REF',
     & 'CHAR',4*' ',
     & 'NUM',4*' ',
     & 'NUM',4*' ',
     & 'NONE','SUPERPOSED','ALL',2*' ',
     & 'NUM',4*' '/
      dimension flag(0:nkwd)
      character*16 cflag(0:nkwd)
      integer narg(0:nkwd) /5,1,1,1,3,1/
      logical find_group
      call read_data_group(jin,jout,nkwd,keywdset,narg,flag,cflag)
      errflag=.false.
      do i=0,nkwd
        if (flag(i).eq.errind) errflag=.true.
      enddo
      if (lrms .or. iruntyp.eq.2) then
        if (find_group(jin,jout,'$SUPAT')) then
           call read_supat(jin,jout,errflag)
        elseif (lrms) then
           write (jout,'(a)') 
     &      'RMS calculation requires $SUPAT data group.'
           errflag=.true.
           return
        else
           nnat=1
           idatt(1)='HEAVY' 
        endif 
        if (.not.larray) then
          nrsup1=aint(flag(2))
          nrsup2=aint(flag(3))
          if (nrsup1.eq.0) nrsup1=1 
          if (nrsup2.eq.0) nrsup2=nres
          nrsup=nrsup2-nrsup1+1
          nrsup_ref=aint(flag(5))
          if (nrsup_ref.eq.0) nrsup_ref=nrsup1-1
        else
          nrsup1=1
          nrsup2=nres
          nrsup=nrsup2-nrsup1
          nrsup_ref=0
          print '(a)',
     &    'RMS array will be calculated for each conformation.'
        endif
        fpdb = cflag(1)
        nrclust1=nrsup1
        nrclust2=nrsup2
        print_super_only=(flag(4).eq.2)
        print_all=(flag(4).eq.3)
      endif
      return
      end
c------------------------------------------------------------------------------
      subroutine read_supat(jin,jout,errflag)
      include 'PARAMET.ECEPP'
      include 'PARAMET.ADD'
      include 'COMMON.CLUSTAT'
      logical errflag
      read(jin,*,end=10,err=10) nnat
      read(jin,'(15(A4,1X))',end=10,err=10) (idatt(i),i=1,nnat)
cd    write(*,*) nnat
cd    write(*,'(15(A4,1X))') (idatt(i),i=1,nnat)
      return
   10 errflag=.true.
      return
      end
c------------------------------------------------------------------------------
      subroutine read_chromo(jin,jout,errflag)
      include 'PARAMET.ECEPP'
      include 'COMMON.CNTRL1'
      include 'COMMON.CHROMO'
      include 'COMMON.GEN100'
      include 'COMMON.SETUP'
      parameter (nkwd=2)
      parameter (errind=-1.0D10)
      character*16 keywdset(1:nkwd,0:nkwd) /
     & 'IDON','IACC',
     & 'NUM',' ',
     & 'NUM',' '/
      integer narg(0:nkwd) /2,1,1/
      logical errflag
      dimension flag(0:nkwd)
      character*16 cflag(0:nkwd)
      call read_data_group(jin,jout,nkwd,keywdset,narg,flag,cflag)
      errflag=.false.
      do i=0,nkwd
        if (flag(i).eq.errind) errflag=.true.
      enddo
      if (chrom_dist) then
        do i=0,nkwd
          if (flag(i).eq.errind) errflag=.true.
        enddo
        ires1=aint(flag(1))
        ires2=aint(flag(2))
        if (ires1*ires2.gt.0) then
          lires1=iabs(list(ires1))
          lires2=iabs(list(ires2))
          if (lires1.eq.20 .or. ires1.eq.1) then
            iraux=ires1
            ires1=ires2
            ires2=ireaux
            lires1=iabs(list(ires1)) 
            lires2=iabs(list(ires2)) 
          endif
          if (lires1.ne.19 .or. (lires2.ne.20 .and. lires2.ne.36)
     &       .and. .not. (ires2.eq.1 .and. lires2.eq.30)) then
            write(jout,'(a)') 
     &       'Bad residues to calculate chromophore distance.'
            chrom_dist=.false.
          endif
        else 
          ires1=0
          ires2=0
          do i=2,nres+1
cd          write (jout,*)'i=',i,' list=',list(i)
            if (iabs(list(i)).eq.19 .and. ires1.eq.0) ires1=i
          enddo
          if (iabs(list(1)).eq.30) then
            ires2=1
          else
            do i=2,nres+1
              if ((iabs(list(i)).eq.20 .or. iabs(list(i)).eq.36) 
     &          .and. ires2.eq.0) ires2=i
            enddo
          endif
          if (ires1*ires2.eq.0) then
            write(jout,'(2a)') 'Not enough chromophore residues',
     &              ' to calculate chromophore distance ditribution.'
            chrom_dist=.false.
          endif
        endif 
        idon=ires1
        iacc=ires2
cd      write(jout,'(a,i3,a,i3)')'idon=',ires1,' iacc=',ires2
      endif 
      return
      end
c------------------------------------------------------------------------------
      subroutine read_cluster(jin,jout,errflag)
      include 'PARAMET.ECEPP'
      include 'PARAMET.ADD'
      include 'sizesclu.dat'
      logical errflag
      include 'COMMON.CNTRL'
      include 'COMMON.CNTRL1'
      include 'COMMON.CLUSTER'
      include 'COMMON.CLUSTAT'
      include 'COMMON.SUPER'
      include 'COMMON.CLUSPRN'
      include 'COMMON.SETUP'
      logical find_group
      if (iruntyp.eq.4 .or. iruntyp.eq.7) then
        if (nrclust1.eq.0) nrclust1=1
        if (nrclust2.eq.0) nrclust2=nres+1
        read(jin,*,end=10,err=10) ncut,(rcutoff(i),i=1,ncut)
        do i=1,ncut
          eceppform(i)=.true.
          if (rcutoff(i).lt.0.0) then
            rcutoff(i)=abs(rcutoff(i))
            printang(i)=.true.
            printpdb(i)=npdb_write
          else
            printang(i)=.false.
            printpdb(i)=0
          endif
        enddo  
cd      write (jout,'(a)') 'read_cluster: rcutoff,printang,printpdb:'
        do i=1,ncut
cd        write (jout,*) i,rcutoff(i),printang(i),printpdb(i)
        enddo
        read (jin,*,err=10) ecut
cd      write (jout,*) 'ecut=',ecut
        if (find_group(jin,jout,'$SUPAT')) then
           call read_supat(jin,jout,errflag)
        else
           write (jout,'(a)') 
     &      'Cluster analysis requires $SUPAT data group.'
           errflag=.true.
           return
        endif 
      endif
      return
   10 write (jout,'(a)') 'Bad data in $CLUSTER data group.'
      errflag=.true.
      end
c---------------------------------------------------------------------------
      subroutine read_bounds(jjin,jjout,errflag)
      include 'PARAMET.ECEPP'
      include 'PARAMET.ADD'
* Number of keywords in this data group
      parameter (nkwd=1)
      parameter (errind=-1.0D10)
      character*16 keywdset(1:nkwd,0:nkwd) /
     & 'NMR_FILE',
     & 'CHAR'/
      dimension flag(0:nkwd)
      character*16 cflag(0:nkwd)
      integer narg(0:nkwd) /1,1/
      logical find_group,errflag
      include 'COMMON.CNTRL'
      include 'COMMON.CNTRL1'
      include 'COMMON.IOUNIT'
      include 'COMMON.NMR'
      character*16 fnmr

      nconstr=0
      call read_data_group(jjin,jjout,nkwd,keywdset,narg,flag,cflag)
      errflag=.false.
      do i=0,nkwd
        if (flag(i).eq.errind) errflag=.true.
      enddo
      fnmr=cflag(1)
      if (errflag) return
      if (fnmr.eq.'KEYBOARD') then
        print '(a)',
     & 'Enter the name of NMR constraints file (^D to abort)'      
 26     read (*,'(a32)',end=33,err=33) fnmr
        open (21,file=fnmr,status='old',form='formatted',err=27)
        goto 28
 27     print *,'file does not exist, reenter'
        goto 26
      else
        open (21,file=fnmr,status='old',form='formatted',err=29)
        goto 28
 29     write (jjout,'(a)') 'Error opening NMR constraint file.'
        errflag=.true.      
        goto 33
      endif
 28   do iconstr=1,max_nmr_constr
        write (jjout,*) 'iconstr=',iconstr
        read (21,100,end=44,err=44) 
     &    icor,rsnam1(iconstr),ir1(iconstr),rsnam2(iconstr),
     &    ir2(iconstr),atname1(iconstr),atname2(iconstr),
     &    bl(iconstr),bu(iconstr),na(iconstr,1),(ia(iconstr,i,1),i=1,6),
     &    na(iconstr,2),(ia(iconstr,i,2),i=1,6)
      write(jjout,100)icor,rsnam1(iconstr),ir1(iconstr),rsnam2(iconstr),
     &    ir2(iconstr),atname1(iconstr),atname2(iconstr),
     &    bl(iconstr),bu(iconstr),na(iconstr,1),(ia(iconstr,i,1),i=1,6),
     &    na(iconstr,2),(ia(iconstr,i,2),i=1,6)
      enddo
   44 close(21)
      nconstr=iconstr
      write (jjout,*) 'nconstr=',nconstr
      call set_names
   33 if (nconstr.eq.0) lnmr=.false.

      return
  100 format (i3,1x,a3,i3,1x,a3,i3,2(1x,a3),2f8.1/2(i3,2x,6i5,5x))
      end
c----------------------------------------------------------------------------
      subroutine read_bridge(jin,jout,errors)
      include 'PARAMET.ECEPP'
      logical errflag,errors,blankline
      character*80 line,line1,ucase
      common/loops/kcys,nhalf,npair(2*maxloop)
      errors=.false.
      nhalf=0
      read (jin,'(a)') line
      write (jout,'(2a)') '> ',line(1:78)
      do while (index(ucase(line),'$END').eq.0)
        ipos=1
        blankline=.false.
        errflag=.false.
        do while (.not. blankline)
          call mykey(line,line1,ipos,blankline,errflag)
          if (errflag) goto 10 
          errors=errors .or. errflag
          if (.not. blankline .and. .not. errflag) then
            if (nhalf.lt.2*maxloop) then
              nhalf=nhalf+1
              read (line1,*,err=10) npair(nhalf)
            else
              errors=.true.
              write (jout,1000) nhalf/2,maxloop
              return
            endif
          endif
        enddo
        read (jin,'(a)') line
        write (jout,'(2a)') '> ',line(1:78)
      enddo
      if (2*(nhalf/2).ne.nhalf) then
        errors=.true.
        write (jout,'(2a,i4,a)') 'Error in $BRIDGE: odd number of',
     & ' bridging residues has been specified (',nhalf,').'
      endif
cd    write (jout,'(16i5)') (npair(i),i=1,nhalf)
      return
   10 write (jout,'(a/a)') 'Read error in $BRIDGE in data line:',line
      errors=.true.
 1000 format ('Error in $BRIDGE: The number of bridges read (',i4,
     & ') exceeds maximum (',i4,').')
      return
      end
c------------------------------------------------------------------------------
      subroutine read_seq(jin,jout,errors)
      include 'PARAMET.ECEPP'
      include 'COMMON.GEN100'
      include 'COMMON.THRLET'
      include 'COMMON.PRAMX'
      include 'COMMON.SETUP'
      include 'COMMON.CNTRL'
      character*80 line,line1,ucase
      character*8 sequence(maxnum_res),temp_str
      character*3 res
      logical errflag,errors,err_res_nam,blankline,lower_case
      errors=.false.
      read (jin,'(a)') line
      write (jout,'(2a)') '> ',line(1:78)
      line1=ucase(line)
      iseq=1
      do while (index(line1,'$END').eq.0)
* Override commented lines.
         ipos=1
         blankline=.false.
         if (icode.lt.3) then 
* Numeric or three-letter code. A separator is required between residue IDs.
           do while (.not. blankline)                 
             call mykey(line,temp_str,ipos,blankline,errflag)
             if (errflag) write (jout,'(2a)')
     & 'Error when reading sequence in line: ',line
             errors=errors .or. errflag
             if (.not. blankline .and. .not. errflag) then
               if (iseq.le.maxnum_res) then
                 sequence(iseq)=temp_str
                 iseq=iseq+1
               else
                 errors=.true.
                 write (jout,1000) iseq,maxnum_res
                 goto 80
               endif
             endif
           enddo
         else
* One-letter code
           do while (.not.blankline)
             line1=' '
             call mykey(line,line1,ipos,blankline,errflag) 
             if (errflag) write (jout,'(2a)')
     & 'Error when reading sequence in line: ',line
             errors=errors .or. errflag
             if (.not. blankline .and. .not. errflag) then
               if (line1(1:1).eq.'@@') then
                 il=2
                 ipos1=3
               else 
                 il=1
                 ipos1=2
               endif
               iend=len_trim(line1)
               if (iseq.le.maxnum_res) then
                 sequence(iseq)=line1(1:il)
               else
                 errors=.true.
                 write (jout,1000) iseq,maxnum_res
                 goto 80
               endif
               do while (ipos1.le.iend)
                 if (line1(ipos1:ipos1).eq.'+' .or. 
     &               line1(ipos1:ipos1).eq.'-' .or.
     &               line1(ipos1:ipos1).eq.'<' .or.
     &               line1(ipos1:ipos1).eq.'>' .or.
     &               line1(ipos1:ipos1).eq.'*' .or.
     &               line1(ipos1:ipos1).eq.'_') then
                   sequence(iseq)=line1(ipos1-il:ipos1)
                   ipos1=ipos1+1
                 else
                   iseq=iseq+1
                   if (ipos1.lt.iend .and. 
     &                      line1(ipos1:ipos1).eq.'@@') then
                     il=2
                     ipos1=ipos1+2
                   else
                     il=1
                     ipos1=ipos1+1
                   endif
                   if (iseq.le.maxnum_res) then
                       sequence(iseq)=line1(ipos1-il:ipos1-1)
                   else
                     errors=.true.
                     write (jout,1000) iseq,maxnum_res
                     goto 80
                   endif
                 endif
               enddo
               iseq=iseq+1
             endif
           enddo
         endif
         read (jin,'(a)') line
         write (jout,'(2a)') '> ',line(1:78)
         line1=ucase(line)
      enddo
   80 continue
cd    write (jout,'(10a8)') (sequence(i),i=1,iseq-1)
* If the user has specified the length of the chain, check whether the 
* found length of the chain is correct.
      length_of_chain=iseq-3
      if (nres.eq.0) nres=length_of_chain
      if (length_of_chain .ne. nres) then
        errors=.true.
        write (jout,'(a,i4,a,i4,a)') 
     & 'Error - the found number of residues (',length_of_chain,
     & ') does not match the number specified in $CNTRL (',nres,').' 
      endif
* Now decode the sequence.
      goto (10,20,30) icode
* Numeric code of the sequence
   10 do ires=1,nres+2
        read (sequence(ires),*,err=100) list(ires)
        goto 40
  100   write (jout,'(a,i4,2a)') 'Error in residue ',ires,': ',
     &   sequence(ires)
        errors=.true.
   40 enddo 
      return
* Three-letter code of the sequence.
   20 do ires=1,nres+2
        ils=len_trim(sequence(ires))
        ichir=1
        err_res_nam=.false.
        if (ils.le.3) then
          res=sequence(ires)
          if (lower_case(res(1:1))) ichir=-1 
        elseif ( (ils.eq.4 .and. ucase(sequence(ires)(1:1)).eq.'D') 
     &  .or. (ils.eq.5 .and. ucase(sequence(ires)(1:2)).eq.'D-') ) then
          res=sequence(ires)(ils-2:ils)
          ichir=-1
        else
          err_res_nam=.true.
          errors=.true.
          write (jout,'(3a,i4)') 'Error - bad three-letter code ',
     & sequence(ires),' found in position',ires
        endif
        res=ucase(res)
        if (.not.err_res_nam) then
          i=1
          do while (res.ne.ares(i) .and. i.le.num_restypes+num_endgrp)
            i=i+1
          enddo
          if (i.gt.num_restypes+num_endgrp) then
            errors=.true.
            write (jout,1010) sequence(ires),ires
          else if (ires.ne.1 .and. ires.ne.nres+2) then
            list(ires)=ichir*i
          else
            list(ires)=i
          endif
          if (ires.gt.1 .and. ires.lt.nres+2 .and. i.gt.num_restypes) 
     &    then
            errors=.true.
            write (jout,'(3a,i4,a)') 
     &                      'Error - an end group ',sequence(ires),
     &      ' has been found in the position',ires,' of the chain.'
          elseif ((ires.eq.1 .or. ires.eq.nres+2).and.
     &             i.le.num_restypes) then
            errors=.true.
            if (ires.eq.1) write (jout,'(2a)')
     &         'Error - sequence is started with a full residue ',
     &          sequence(ires)
            if (ires.eq.nres+2) write (jout,'(2a)')
     &         'Error - sequence is terminated with a full residue ',
     &          sequence(ires)
          endif
        endif
      enddo
      list(1)=list(1)-num_restypes
      list(nres+2)=list(nres+2)-num_restypes
      write (jout,'(16i5)') (list(i),i=1,nres+2)
      return 
* One-letter code of the sequence. First process full residues.
   30 do ires=2,nres+1
        ils=len_trim(sequence(ires))
        ichir=1
        if (lower_case(sequence(ires)(1:1)) .or. 
     &      lower_case(sequence(ires)(2:2)) ) ichir=-1 
        i=1  
        do while (ucase(sequence(ires)(1:3)).ne.one_let(i) .and. 
     &    i.le.num_restypes)
          i=i+1
        enddo
        if (i.gt.num_restypes) then
          errors=.true.
          write (jout,1010) sequence(ires),ires
        else
          list(ires)=ichir*i    
        endif 
      enddo
* End groups
      do ires=1,nres+2,nres+1
        ils=len_trim(sequence(ires))
        i=num_restypes+1
        do while(ucase(sequence(ires)(1:2)).ne.one_let(i) .and. 
     &     i.le.num_restypes+num_endgrp)
          i=i+1
        enddo
        if (i.gt.num_restypes+num_endgrp) then
          errors=.true.
          write (jout,1010) sequence(ires),ires
        else
          list(ires)=i    
        endif 
      enddo
      list(1)=list(1)-num_restypes
      list(nres+2)=list(nres+2)-num_restypes
      write (jout,'(16i5)') (list(i),i=1,nres+2)
      return
 1000 format('Error - the number of residues (',i4,
     & ') has exceeded maximum (',i4,').')
 1010 format ('Error - unrecognized residue or end group ',a8,
     & ' in position',i4)
      end
c------------------------------------------------------------------------------
      subroutine read_spec(jin,jout,errors)
      include 'PARAMET.ECEPP'
      logical errflag,errors,blankline
      include 'COMMON.KVS'
      include 'COMMON.SETUP'
      include 'COMMON.TOR2'
      include 'COMMON.BONDSX'
      character*80 line,line1,ucase
      errors=.false.
      nvr=0
      numvr0=0
      read (jin,'(a)') line
      write (jout,'(2a)') '> ',line(1:78)
      do while (index(ucase(line),'$END').eq.0)
C
C IVARFLAG=5 (i.e. "NONE") then SPEC card if useless and the information 
C  will not be considered. We read the lines until $END card is found.  
C
        if (ivarflag.eq.5) goto 20
C
        if (ivarflag.eq.4) then
C IVARFLAG=4 means that the user specifies the variable angles explicitly.
          read (line,*,err=10) ires,nvi,(ndxarr0(k,ires),k=1,nvi)
          nv0(ires)=nvi
          numvr0=numvr0+nvi
          nvr=nvr+1  
          numvarres(nvr)=ires
        else
          ipos=1
          blankline=.false.
          errflag=.false.
          do while (.not. blankline)
            call mykey(line,line1,ipos,blankline,errflag)
            errors=errors .or. errflag
            if (errflag) goto 10 
            if (.not. blankline .and. .not. errflag) then
              if (nvr.lt.nres+2) then
                nvr=nvr+1
                read (line1,*,err=10) numvarres(nvr)
              else
                errors=.true.
                write (jout,1000) nres+2
                return
              endif
            endif
          enddo
        endif
 20     read (jin,'(a)') line
        write (jout,'(2a)') '> ',line(1:78)
      enddo
      if (nvarres.eq.0) then
        nvarres=nvr
      elseif (nvr.ne.nvarres) then
        write (jout,'(2a/a,i4,a,i4,a)') 
     &   'Error in $SPEC: the number of residues with ',
     &   'variable dihedrals specified in ','$CNTRL (',nvarres,
     &   ') is not equal to the number read here (',nvr,').'
        errors=.true.
      endif
      if (ivarflag.eq.4) then
        if (nvr.eq.0) then
          write (jout,'(2a/a)')
     &     'Error in $SPEC: VAR_ANGLES=SPEC was ',
     &     'specified in $CNTRL, but ',
     &     'no dihedral angle has been defined in the $SPEC card'
          errors=.true.
        endif
      endif
C Sort the NUMVARRES array and the rows of NDXARR and simultaneously
C check for repetitions. -- AL 11/02/93
      do i=1,nvarres
        imin=i
        ires=numvarres(i)
        nvi=nv0(ires)
        do j=i+1,nvarres
          jres=numvarres(j)
          if (ires.eq.jres) then
            write (jout,'(2a,i3,a)') 'Error in $SPEC data group. ',
     & 'Residue with variable angles',ires,' specified repeatedly.'
            errors=.true.
          else if (ires .gt. jres) then
            imin=j
            ires=jres 
          endif
        enddo
        if (imin.gt.i) call exch(numvarres(i),numvarres(imin))
      enddo             
      if (ivarflag.eq.4) then
        do i=1,nres+2
          nvi=nv0(i)  
          if (nvi .gt. 0) then
            do j=1,nvi
              jmin=j
              ndxji=ndxarr0(j,i)
              do k=j+1,nvi
                ndxki=ndxarr0(k,i)
                if (ndxji.eq.ndxki) then
                  write (jout,'(2a,i2,a,i3,a)') 
     & 'Error in $SPEC data group. ',
     & 'Angle',ndxji,' for residue',i,' specified repeatedly.'
                  errors=.true.
                else if (ndxji.gt.ndxki) then
                  jmin=k
                  ndxji=ndxki
                endif
              enddo
              call exch(ndxarr0(j,i),ndxarr0(jmin,i))
            enddo
          endif
        enddo
      endif
      write (jout,'(16i5)') (numvarres(i),i=1,nvarres)
      return
   10 write (jout,'(2a)')'Error when reading $SPEC in line: ',line
      errors=.true.
      return
 1000 format ('Error - the number of variable residues exceeds the ',
     & /,'total number of residues and end groups (',i4,').')
 1100 format ('Error - VAR_ANGLES and VAR_RES cards have been ',
     & ' specified',/,' simultaneously in $CNTRL.')
      end
c--------------------------------------------------------------------------
      subroutine read_title(jin,jout,errflag)
      include 'COMMON.HEADER'
      logical errflag
      read (jin,'(a)',err=10,end=10) title 
      errflag=.false.
      return
   10 errflag=.true.
      return
      end
c--------------------------------------------------------------------------
      subroutine read_Hgrps(jin,jout,errflag)
      include 'PARAMET.ECEPP'
      include 'COMMON.XBOUNDX'
      character*80 line,line1,ucase
      character*20 rname
      logical lcom,blankline,errflag
      character*5 lchara(3)
      integer ival1,ival2
      numbgrp= 0
      ie=1
 10   read (jin,'(a)',end=100) line
      if (  lcom(1,line(1:1) )  ) goto 10
C     write (*,'(a)')  line
      do while (index(ucase(line),'$END').eq.0)
         ipos=1
         blankline=.false.
         errflag=.false.
C read the three first record of the line.
         do k= 1, 3 
            call mykey(line,line1,ipos,blankline,errflag)
            ie=2
            if (errflag) goto 100
            if (.not. blankline .and. .not. errflag) then
               ie=6
               read (line1,'(a3)',end=100,err=100) lchara(k)
            else
               ie=3
               goto 100
            endif
         enddo
C first record is used to indicate the group number.
         ie=4
         read (lchara(1),*,err=100)  igrp
         ie=5
C groupName, name or label used to identify the particular group.
         read (lchara(2),'(a3)',err=100)  groupName(igrp)

C numOfsites, number of H labels under this group.
         ie=6
         read (lchara(3),*,err=100)   inumsit
         numOfsites(igrp)=inumsit

         do l=1, inumsit
C for each group, read two record from the line.
            do k= 1, 2 
               call mykey(line,line1,ipos,blankline,errflag)
               ie=7
               if (errflag) goto 100
               if (.not. blankline .and. .not. errflag) then
                  ie=8
                  read (line1,'(a3)',end=100,err=100) lchara(k)
               else
                  ie=9
                  goto 100
               endif
            enddo

C iresNum, no. of protons in group.
            ie=10
            read (lchara(1),*,err=100)  irex
            iresNum(l,igrp) =irex
C atomName, ecepp no. of first proton of the group.
            ie=11
            read (lchara(2),'(a3)',err=100)  atomName(l,igrp)
         enddo

C       write(jout,'(i4,2a)') igrp, 'groupName= ', groupName(igrp)
C       write(jout,'(10i4)') (iresNum(l,igrp), l=1,numOfsites(igrp))
C       write(jout,'(10a)') (atomName(l,igrp), l=1,numOfsites(igrp))
   
         numbgrp= numbgrp+1

         ie=12
 20      read (jin,'(a)',end=100) line
         if (  lcom(1,line(1:1) )  ) goto 20
C        write (*,'(a)')  line
C
C End do while loop.
      enddo
      ie=12
      if (numbgrp.ne.igroupNum) then
         write(jout,300) ie, igroupNum
300       FORMAT ( 'ERROR(',i4, ') Number of groups read is not ',i4,
     &    ' as specified by  igroupNum  in DIST_CONST data group.')
      endif

      return
100   write(jout,'(a,i4,a/a/a)') 'ERROR(',ie ,') reading line: ', 
     & line,line1
      stop 88888
      end
c------------------------------------------------------------------------------
      subroutine read_Hlab(jin,jout,errflag)
      include 'PARAMET.ECEPP'
      include 'COMMON.XBOUNDX'
      character*80 line,line1
      character*20 rname
      logical lcom,blankline,errflag
      character*5 lchara(3)
      integer ival1,ival2

cd    print *,'jin=',jin
      ie=1
 10   read (jin,'(a)',end=100) line
C check for comments. If found, omit the line.
      if (  lcom(1,line(1:1) )  ) goto 10
      
C reading total number of residues in data file
      ie=2
      read (line,*,err=100) nres,nend
      do i=1, nres+nend
         ie=3
 20      read (jin,'(a)',end=100) line
C check for comments. If found, omit the line.
         if (  lcom(1,line(1:1) )  ) goto 20

         ie=4
C        read (line,*,err=100) ires, ival1, ival2, rname
         read (line,*,err=100) ires, ival1, ival2
         if (i.gt.nres) ires=ires+num_restypes
cd       write(*,'(a,i4)') 'i=',i,' residue= ', ires
         numh(ires)=ival1
         numalth(ires)=ival2
         numtot=ival1+ival2
cd       write (jout,*) 'numtot=',numtot
         do j=1,numtot  
           ie=4
 30        read (jin,'(a)',end=100) line
           if (  lcom(1,line(1:1) )  ) goto 30
	   ipos=1
           blankline=.false.
           errflag=.false.
C read the three first record of the line.
	   do  k= 1, 3 
cd           write (jout,*) 'j=',j,' k0=',k,' ipos=',ipos
             call mykey(line,line1,ipos,blankline,errflag)
cd           write (jout,'(a)') line
             ie=5
             if (errflag) goto 100
             if (.not. blankline .and. .not. errflag) then
               ie=6
               read (line1,'(a3)',end=100,err=100) lchara(k)
             else
               ie=7
	       goto 100
             endif
           enddo
C first record in this type of file is not used. Should be equal to 
C the index "j".

C nameh, name or label used to identify the particular hydrogen.
           ie=8
           read (lchara(2),'(a3)',err=100)  nameh(j,ires)

C numgrh, number of groups of H's under the same label.
           ie=9
           read (lchara(3),*,err=100)  numgrh(j,ires)

           do l=1, numgrh(j,ires)
C for each group, read three record from the line.
	      do  k= 1, 3 
cd               write (jout,*) 'j=',j,' k=',k,' l=',l,' ipos=',ipos
cd               write (jout,'(a)') line
                 call mykey(line,line1,ipos,blankline,errflag)
cd               write (jout,'(a)') line1
                 ie=10
                 if (errflag) goto 100
                 if (.not. blankline .and. .not. errflag) then
                    ie=11
                    read (line1,'(a3)',end=100,err=100) lchara(k)
                 else
                    ie=12
	            goto 100
                 endif
              enddo

C ihnum, no. of protons in group.
              ie=13
              read (lchara(1),*,err=100)  ihnum(l,j,ires)
C ilock, ecepp no. of first proton of the group.
              ie=14
              read (lchara(2),*,err=100)  ilock(l,j,ires)
C 4/19/97 AL 
C imeth, flag to indicate that the group contains methyl protons.
              ie=15
              read (lchara(3),*,err=100)  imeth(l,j,ires)
              if (imeth(l,j,ires).eq.1 .and. ihnum(l,j,ires).ne.3) then
                write (jout,'(a,i3,a,i3,a)') 
     &        'Proton group ',l,' of residue ',ires,
     &        ' marked methyl, but number of protons different from 3.'
              errflag=.true.
              endif

C end loop over groups.
           enddo

         write(jout,'(a,i3,2a)') 'Residue',ires,' atom= ', nameh(j,ires)
         write(jout,'(a,10i4)') nameh(j,ires),numgrh(j,ires),
     &       (ihnum(l,j,ires), l=1,numgrh(j,ires) ),
     &       (ilock(l,j,ires), l=1,numgrh(j,ires) )
C end loop over line describing the data for proton.
         enddo

C end loop over residue data file.
      enddo

      return
100   write(jout,'(a,i4,a/a/a)') 'ERROR(',ie ,') reading line: ', 
     & line,line1
      errflag=.true.
      return
      end
c------------------------------------------------------------------------------
      subroutine read_noesetup(jin,jout,errflag)
      include 'PARAMET.ECEPP'
      include 'PARAMET.ADD'
      include 'sizesclu.dat'
      include 'PARAMET.FIT'
      include 'COMMON.MORASS'
      include 'COMMON.XBOUNDX'
      include 'COMMON.FILES'
      parameter (nkwd=22)
      parameter (errind=-1.0D10)
      character*16 keywdset(1:nkwd,0:nkwd) /
     & 'MODE','CONF','AVERAGE','BYSTROV','GEMINAL','VICINAL','RIGID',
     & 'NOE','ANTINOE','WEI_COUPL','NTYP_COUPL','A0','A1','A2',
     & 'SA0','SA1','SA2',
     & 'WBASE','PRINT','EQUIVALENCE','NOE_FILE','ALPHA_ENT',
     & 'SIMUL','FITTING',20*' ',
     & 'CLUSTERED','ALL',20*' ',
     & 22*' ',
     & 'NO','YES',20*' ','NO','YES',20*' ',
     & 'NO','YES',20*' ','NO','YES',20*' ','ALL','INTER','LONG',19*' ',
     & 'ALL','INTER','LONG','NONE',18*' ',
     & 'NUM',21*' ','NUM',21*' ','NUM',21*' ','NUM',21*' ','NUM',21*' ',
     & 'NUM',21*' ','NUM',21*' ','NUM',21*' ','NUM',21*' ',
     & 22*' ',
     & 'NO','BY_NAME','LIST',19*' ',
     & 'CHAR',21*' ','NUM',21*' '/
      integer narg(0:nkwd)
     & /22,2,2,0,2,2,2,2,3,4,1,1,1,1,1,1,1,1,1,0,3,1,1/
      logical errflag,find_group
      dimension flag(0:nkwd)
      character*16 cflag(0:nkwd)
      call read_data_group(jin,jout,nkwd,keywdset,narg,flag,cflag)
      errflag=.false.
      do i=0,nkwd
        if (flag(i).eq.errind) errflag=.true.
      enddo
C
C MOD_MORASS indicates the purpose of NOE calculation:
C   SIMUL - just calculate NOE spectra for the supplied conformations;
C   FITTING - fit the statistical weights of the conformations so as to best
C               reproduce the experimental NOE spectrum.
      mod_morass=aint(flag(1))
C
C MOD_CALC specifies, which conformations will be considered in the calcs:
C   CLUSTERED - a cluster analysis will precede NOE calculation (see below);
C   ALL - the NOE spectra of all conformations will be calculated.
      mod_calc=aint(flag(2))
C
C AVERGAGE says whether the spectra will be Boltzmann averaged over the whole
C          ensamble (for MOD_CALC=ALL) or over families (MOD_CALC=CLUSTERED).
      average=(flag(3).gt.0.0)
C
C Calculate or not the coupling constants?
      if (flag(4).gt.0.0) bystrov = (flag(4).gt.1.0) 
C
C Include or not the NOE's from geminal protons in fitting?
      if (flag(5).gt.0.0) geminal = (flag(5).gt.1.0)
C
C Include or not the NOE's from vicinal protons in fitting?
      if (flag(6).gt.0.0) vicinal = (flag(6).gt.1.0)
C
C Include or not the NOE's from "rigid" pairs of protons in fitting?
      if (flag(7).gt.0.0) rigid = (flag(7).gt.1.0)
C
C Which of the NOE's to fit?
C   ALL   - all NOE's;
C   INTER - interresidue NOE's only;
C   LONG  - long-range NOE's only (protons belonging to non-consecutive 
C           residues).
      if (flag(8).gt.0.0) noe=aint(flag(8))
C
C How to include the anti-NOE's in fitting?
C   ALL   - all anti-NOE's;
C   INTER - interresidue anti-NOE's only;
C   LONG  - long-range anti-NOE's only;
C   NONE  - no anti-NOE's.
      if (flag(9).gt.0.0) antinoe=aint(flag(9))
      if (antinoe.lt.noe) antinoe=noe
C
C Weight of the coupling-constant term in the target function.
      if (flag(10).ne.0.0) weight_coupl = flag(10)
C
C Following variables are the constants a0, a1, a2, a3 and their standard
C deviations sa0, sa1, sa2, sa3 in the Bystrov-Karplus equation.
      
      if (flag(11).ne.0.0) ntyp_coupl=aint(flag(11))
      if (flag(12).ne.0.0) aa0(1)=flag(12)
      if (flag(13).ne.0.0) aa1(1)=flag(13)
      if (flag(14).ne.0.0) aa2(1)=flag(14)
      if (flag(15).ne.0.0) sa0(1)=flag(15)
      if (flag(16).ne.0.0) sa1(1)=flag(16)
      if (flag(17).ne.0.0) sa2(1)=flag(17)
      aa0(2)=2*aa0(1)+1.5*aa2(1)
      aa1(2)=aa1(1)
      aa2(2)=-aa2(1)
      sa0(2)=sa0(1)
      sa1(2)=sa1(1)
      sa2(2)=sa2(1)
C Baseline to add to peak intensities in weight construction. 
C The weight of ith NOE will equal 1/(v(i)+wbase).
      if (flag(18).ne.0.0) wbase=flag(18)
      if (bystrov) then
        if (find_group(jin,jout,'$COUPLING')) then
           call read_coupling(errflag)
        else
          write (jout,'(2a)') 'Coupling constant evaluation requested,',
     &    ' but the data group $COUPLING is not supplied.'
          errflag=.true.
        endif
      endif
      print_all_spectra=(flag(19).gt.0.0)
      if (flag(20).gt.0) equiv=aint(flag(20))
      if ( len_trim(cflag(21)).gt.0 ) sumslfile=cflag(21)
C ALPHA_ENTR indicates whether to do maximum-entropy fitting: 
C <=0 - do not include maximum entropy
C >0  - do maximum-entropy fitting with the weight ALPHA_ENT to the "entropy"
C       term
      alpha_ent = flag(22)
      
      return
      end
c------------------------------------------------------------------------------
      subroutine read_marquardt(jin,jout,errflag)
      include 'PARAMET.ECEPP'
      include 'PARAMET.ADD'
      include 'sizesclu.dat'
      include 'PARAMET.FIT'
      include 'COMMON.MARQ'
      include 'COMMON.MORASS'
      parameter (nkwd=11)
      parameter (errind=-1.0D10)
      character*16 keywdset(1:nkwd,0:nkwd) /
     & 'MAXIT,','MAXMAR','LAMBDA','VMARQ',
     & 'TOLX','TOLF','RTOLF','TOLLAM','RLMIN','MAXFUN','MINIMIZER',
     & 'NUM',10*' ',
     & 'NUM',10*' ',
     & 'NUM',10*' ',
     & 'NUM',10*' ',
     & 'NUM',10*' ',
     & 'NUM',10*' ',
     & 'NUM',10*' ',
     & 'NUM',10*' ',
     & 'NUM',10*' ',
     & 'NUM',10*' ',
     & 'NONE','MARQ','SUMSL',8*' '/
      integer narg(0:nkwd) /11,1,1,1,1,1,1,1,1,1,1,3/
      logical errflag
      dimension flag(0:nkwd)
      character*16 cflag(0:nkwd)
      call read_data_group(jin,jout,nkwd,keywdset,narg,flag,cflag)
      errflag=.false.
      do i=0,nkwd
        if (flag(i).eq.errind) errflag=.true.
      enddo
      
C Choose minimizer 
      if (aint(flag(11)).eq.1) then
        write (jout,'(a)') 'No minimization, just Boltzmann averaging'
        minimizer = -1
      else if (alpha_ent .gt. 1.0d-7 .or. flag(11).eq.2) then
        write (jout,'(a)') 'Maximum entropy fitting implies SUMSL...'
        minimizer = 1
      else
        minimizer = 0
      endif
      print *,cflag(11),' ',minimizer
C Max. number of iterations in Marquardt's fitting procedure.
      maxit=aint(flag(1))
C Max. number of microiterations carried out, until a lower function value 
C is obtained.
      maxmar=aint(flag(2))
C Initial value of Marquardt's lambda factor.
      rl=flag(3)
C Multiplicative increment/decrement of lambda.
      vmarq=flag(4)
C Tolerance on the 1-norm of weight vector.
      tolx=flag(5)
C Absolute tolerance on function.
      tolf=flag(6)
C Relative tolerance on function.
      rtolf=flag(7)
C Upper bound of lambda, such that iteration can be terminated, if the other
C criteria are satisfied.
      tollam=flag(8)
C Lower bound of lambda (will not be decremented below this value).
      rlmin=flag(9)
C Maximum number of function evaluations (to be used in SUMSL)
      maxfun=aint(flag(10))
      
      return
      end
c------------------------------------------------------------------------------
      subroutine read_morass(jin,jout,errflag)
      include 'PARAMET.ECEPP'
C Following include file comes from MORASS
      include 'molecule.inc'
      parameter (nkwd=6)
      parameter (errind=-1.0D10)
      character*16 keywdset(1:nkwd,0:nkwd) /
     & 'TAUC','TAUM','TIME','VOL0','SFRQ','CUTT',
     & 'NUM',5*' ',
     & 'NUM',5*' ',
     & 'NUM',5*' ',
     & 'NUM',5*' ',
     & 'NUM',5*' ',
     & 'NUM',5*' '/
      integer narg(0:nkwd) /6,1,1,1,1,1,1/
      logical errflag
      dimension flag(0:nkwd)
      character*16 cflag(0:nkwd)
      call read_data_group(jin,jout,nkwd,keywdset,narg,flag,cflag)
      errflag=.false.
      do i=0,nkwd
        if (flag(i).eq.errind) errflag=.true.
      enddo

      if (flag(1).ne.0.0) tau=flag(1)
      if (flag(2).ne.0.0) taum=flag(2)
      if (flag(3).ne.0.0) time=flag(3)
      if (flag(4).ne.0.0) v0=flag(4)
      if (flag(5).ne.0.0) om0=flag(5)
      if (flag(6).ne.0.0) rcut=flag(6)
      
      return
      end
c-----------------------------------------------------------------------------
      subroutine read_coupling(errflag)
      implicit none
      include 'PARAMET.ECEPP'
      include 'PARAMET.ADD'
      include 'sizesclu.dat'
      include 'PARAMET.FIT'
      include 'COMMON.IOUNIT'
      include 'COMMON.GEN100'
      include 'COMMON.ATOMSS'
      include 'COMMON.MATRIX'
      include 'COMMON.MORASS'
      include 'COMMON.SETUP'
      integer i,j,ii,icant
      logical errflag
C Read the coupling constants.
      ncoupl=0
      do i=1,nres+2
        read (jin,*,end=10,err=10) ii,nang(i),(iang(j,i),j=1,nang(i))
        if (nang(i).gt.0) then
          do j=1,nang(i)
            icoupl(j,i)=ncoupl+j
          enddo ! j
          read (jin,*,end=10,err=10) 
     &          (ityp_coupl(icoupl(j,i)),coupl(icoupl(j,i)),phase(j,i),
     &          j=1,nang(i))
          ncoupl=ncoupl+nang(i)
        endif ! nang(i).gt.0
      enddo ! i
      do i=1,nres+2
        write (jout,*) 'Residue:',i
        do j=1,nang(i)
          write (jout,'(3i4,f7.1,i4,f8.4)') 
     &       j,iang(j,i),ityp_coupl(icoupl(j,i)),phase(j,i),icoupl(j,i),
     &       coupl(icoupl(j,i))
        enddo ! j
      enddo ! i
      errflag=.false.
      return
   10 errflag=.true.
      return
      end

