      SUBROUTINE FITSQ(rms,X,Y,NN,T,B)
C  X AND Y ARE THE VECTORS OF COORDINATES (DIMENSIONED (3,N)) OF THE TWO
C  STRUCTURES TO BE SUPERIMPOSED.  NN IS 3*N, WHERE N IS THE NUMBER OF  
C  POINTS.   T AND B ARE RESPECTIVELY THE TRANSLATION VECTOR AND THE    
C  ROTATION MATRIX THAT TRANSFORMS THE SECOND SET OF COORDINATES TO THE 
C  FRAME OF THE FIRST SET.                                              
C  ETA =  MACHINE-SPECIFIC VARIABLE                                     
                                                                        
      DIMENSION X(*),Y(*),T(3)                                          
      DIMENSION B(3,3),Q(3,3),R(3,3),V(3),XAV(3),YAV(3),E(3),C(3,3)     
      ETA = Z00100000                                                   
C     SMALL=25.0*RMDCON(3)                                              
C     SMALL=25.0*ETA                                                    
C     SMALL=25.0*10.E-10                                                
C THE FOLLOWING IS A VERY LENIENT VALUE FOR 'SMALL'                     
      SMALL = 0.0001                                                    
      FN=NN                                                             
      DO 10 I=1,3                                                       
      XAV(I)=0.0                                                        
      YAV(I)=0.0                                                        
      DO 10 J=1,3                                                       
   10 B(J,I)=0.0                                                        
      NC=0                                                              
C                                                                       
      DO 30 N=1,NN                                                      
C Uncomment following line for debugging
cd    print '(i2,3f10.5,2x,3f10.5)',n,(X(NC+I),i=1,3),(Y(NC+I),i=1,3)
      DO 20 I=1,3                                                       
      XAV(I)=XAV(I)+X(NC+I)/FN                                          
   20 YAV(I)=YAV(I)+Y(NC+I)/FN                                          
   30 NC=NC+3                                                           
C                                                                       
                                                                        
*     PRINT*,'XAV = ',(XAV(J),J=1,3)                                    
*     PRINT*,'YAV = ',(YAV(J),J=1,3)                                    
                                                                        
      NC=0                                                              
      RMS=0.0                                                           
      DO 50 N=1,NN                                                      
      DO 40 I=1,3                                                       
      RMS=RMS+((X(NC+I)-XAV(I))**2+(Y(NC+I)-YAV(I))**2)/FN              
      DO 40 J=1,3                                                       
      B(J,I)=B(J,I)+(X(NC+I)-XAV(I))*(Y(NC+J)-YAV(J))/FN                
   40 C(J,I)=B(J,I)                                                     
   50 NC=NC+3                                                           
      CALL SIVADE(B,Q,R,D)                                              
      SN3=SIGN(1.0,D)                                                   
      DO 120 I=1,3                                                      
      DO 120 J=1,3                                                      
  120 B(J,I)=-Q(J,1)*R(I,1)-Q(J,2)*R(I,2)-SN3*Q(J,3)*R(I,3)             
      CALL MVVAD(B,XAV,YAV,T)                                           
      DO 130 I=1,3                                                      
      DO 130 J=1,3                                                      
      RMS=RMS+2.0*C(J,I)*B(J,I)                                         
  130 B(J,I)=-B(J,I)                                                    
      IF (ABS(RMS).GT.SMALL) GO TO 140                                  
*     WRITE (6,301)                                                     
      RETURN                                                            
  140 IF (RMS.GT.0.0) GO TO 150                                         
*     WRITE (6,303) RMS                                                 
      rms=0.0
*     STOP                                                              
* 150 WRITE (6,302) SQRT(RMS)                                           
  150 continue
      RETURN                                                            
  301 FORMAT (5X,'RMS DEVIATION NEGLIGIBLE')                            
  302 FORMAT (5X,'RMS DEVIATION ',F14.6)                                
  303 FORMAT (//,5X,'NEGATIVE MS DEVIATION - ',F14.6)                   
      END                                                               
      SUBROUTINE SIVADE(X,Q,R,DT)                                       
C  COMPUTES Q,E AND R SUCH THAT Q(T)XR = DIAG(E)                        
      DIMENSION X(3,3),Q(3,3),R(3,3),E(3)                               
      DIMENSION H(3,3),P(3,3),U(3,3),D(3)                               
      ETA = Z00100000                                                   
      SMALL=25.0*10.E-10                                                
C     SMALL=25.0*ETA                                                    
C     SMALL=2.0*RMDCON(3)                                               
      XNRM=0.0                                                          
      DO 20 I=1,3                                                       
      DO 10 J=1,3                                                       
      XNRM=XNRM+X(J,I)*X(J,I)                                           
      U(J,I)=0.0                                                        
      R(J,I)=0.0                                                        
   10 H(J,I)=0.0                                                        
      U(I,I)=1.0                                                        
   20 R(I,I)=1.0                                                        
      XNRM=SQRT(XNRM)                                                   
      DO 110 N=1,2                                                      
      XMAX=0.0                                                          
      DO 30 J=N,3                                                       
   30 IF (ABS(X(J,N)).GT.XMAX) XMAX=ABS(X(J,N))                         
      A=0.0                                                             
      DO 40 J=N,3                                                       
      H(J,N)=X(J,N)/XMAX                                                
   40 A=A+H(J,N)*H(J,N)                                                 
      A=SQRT(A)                                                         
      DEN=A*(A+ABS(H(N,N)))                                             
      D(N)=1.0/DEN                                                      
      H(N,N)=H(N,N)+SIGN(A,H(N,N))                                      
      DO 70 I=N,3                                                       
      S=0.0                                                             
      DO 50 J=N,3                                                       
   50 S=S+H(J,N)*X(J,I)                                                 
      S=D(N)*S                                                          
      DO 60 J=N,3                                                       
   60 X(J,I)=X(J,I)-S*H(J,N)                                            
   70 CONTINUE                                                          
      IF (N.GT.1) GO TO 110                                             
      XMAX=AMAX1(ABS(X(1,2)),ABS(X(1,3)))                               
      H(2,3)=X(1,2)/XMAX                                                
      H(3,3)=X(1,3)/XMAX                                                
      A=SQRT(H(2,3)*H(2,3)+H(3,3)*H(3,3))                               
      DEN=A*(A+ABS(H(2,3)))                                             
      D(3)=1.0/DEN                                                      
      H(2,3)=H(2,3)+SIGN(A,H(2,3))                                      
      DO 100 I=1,3                                                      
      S=0.0                                                             
      DO 80 J=2,3                                                       
   80 S=S+H(J,3)*X(I,J)                                                 
      S=D(3)*S                                                          
      DO 90 J=2,3                                                       
   90 X(I,J)=X(I,J)-S*H(J,3)                                            
  100 CONTINUE                                                          
  110 CONTINUE                                                          
      DO 130 I=1,3                                                      
      DO 120 J=1,3                                                      
  120 P(J,I)=-D(1)*H(J,1)*H(I,1)                                        
  130 P(I,I)=1.0+P(I,I)                                                 
      DO 140 I=2,3                                                      
      DO 140 J=2,3                                                      
      U(J,I)=U(J,I)-D(2)*H(J,2)*H(I,2)                                  
  140 R(J,I)=R(J,I)-D(3)*H(J,3)*H(I,3)                                  
      CALL MMMUL(P,U,Q)                                                 
  150 NP=1                                                              
      NQ=1                                                              
      IF (ABS(X(2,3)).GT.SMALL*(ABS(X(2,2))+ABS(X(3,3)))) GO TO 160     
      X(2,3)=0.0                                                        
      NQ=NQ+1                                                           
  160 IF (ABS(X(1,2)).GT.SMALL*(ABS(X(1,1))+ABS(X(2,2)))) GO TO 180     
      X(1,2)=0.0                                                        
      IF (X(2,3).NE.0.0) GO TO 170                                      
      NQ=NQ+1                                                           
      GO TO 180                                                         
  170 NP=NP+1                                                           
  180 IF (NQ.EQ.3) GO TO 310                                            
      NPQ=4-NP-NQ                                                       
      IF (NP.GT.NPQ) GO TO 230                                          
      N0=0                                                              
      DO 220 N=NP,NPQ                                                   
      NN=N+NP-1                                                         
      IF (ABS(X(NN,NN)).GT.SMALL*XNRM) GO TO 220                        
      X(NN,NN)=0.0                                                      
      IF (X(NN,NN+1).EQ.0.0) GO TO 220                                  
      N0=N0+1                                                           
      GO TO (190,210,220),NN                                            
  190 DO 200 J=2,3                                                      
  200 CALL GIVNS(X,Q,1,J)                                               
      GO TO 220                                                         
  210 CALL GIVNS(X,Q,2,3)                                               
  220 CONTINUE                                                          
      IF (N0.NE.0) GO TO 150                                            
  230 NN=3-NQ                                                           
      A=X(NN,NN)*X(NN,NN)                                               
      IF (NN.GT.1) A=A+X(NN-1,NN)*X(NN-1,NN)                            
      B=X(NN+1,NN+1)*X(NN+1,NN+1)+X(NN,NN+1)*X(NN,NN+1)                 
      C=X(NN,NN)*X(NN,NN+1)                                             
      DD=0.5*(A-B)                                                      
      XN2=C*C                                                           
      RT=B-XN2/(DD+SIGN(SQRT(DD*DD+XN2),DD))                            
      Y=X(NP,NP)*X(NP,NP)-RT                                            
      Z=X(NP,NP)*X(NP,NP+1)                                             
      DO 300 N=NP,NN                                                    
      IF (ABS(Y).LT.ABS(Z)) GO TO 240                                   
      T=Z/Y                                                             
      C=1.0/SQRT(1.0+T*T)                                               
      S=C*T                                                             
      GO TO 250                                                         
  240 T=Y/Z                                                             
      S=1.0/SQRT(1.0+T*T)                                               
      C=S*T                                                             
  250 DO 260 J=1,3                                                      
      V=X(J,N)                                                          
      W=X(J,N+1)                                                        
      X(J,N)=C*V+S*W                                                    
      X(J,N+1)=-S*V+C*W                                                 
      A=R(J,N)                                                          
      B=R(J,N+1)                                                        
      R(J,N)=C*A+S*B                                                    
  260 R(J,N+1)=-S*A+C*B                                                 
      Y=X(N,N)                                                          
      Z=X(N+1,N)                                                        
      IF (ABS(Y).LT.ABS(Z)) GO TO 270                                   
      T=Z/Y                                                             
      C=1.0/SQRT(1.0+T*T)                                               
      S=C*T                                                             
      GO TO 280                                                         
  270 T=Y/Z                                                             
      S=1.0/SQRT(1.0+T*T)                                               
      C=S*T                                                             
  280 DO 290 J=1,3                                                      
      V=X(N,J)                                                          
      W=X(N+1,J)                                                        
      A=Q(J,N)                                                          
      B=Q(J,N+1)                                                        
      X(N,J)=C*V+S*W                                                    
      X(N+1,J)=-S*V+C*W                                                 
      Q(J,N)=C*A+S*B                                                    
  290 Q(J,N+1)=-S*A+C*B                                                 
      IF (N.GE.NN) GO TO 300                                            
      Y=X(N,N+1)                                                        
      Z=X(N,N+2)                                                        
  300 CONTINUE                                                          
      GO TO 150                                                         
  310 DO 320 I=1,3                                                      
  320 E(I)=X(I,I)                                                       
  330 N0=0                                                              
      DO 360 I=1,3                                                      
      IF (E(I).GE.0.0) GO TO 350                                        
      E(I)=-E(I)                                                        
      DO 340 J=1,3                                                      
  340 Q(J,I)=-Q(J,I)                                                    
  350 IF (I.EQ.1) GO TO 360                                             
      IF (ABS(E(I)).LT.ABS(E(I-1))) GO TO 360                           
      CALL SWITCH(I,1,Q,R,E)                                            
      N0=N0+1                                                           
  360 CONTINUE                                                          
      IF (N0.NE.0) GO TO 330                                            
      IF (ABS(E(3)).GT.SMALL*XNRM) GO TO 370                            
      E(3)=0.0                                                          
      IF (ABS(E(2)).GT.SMALL*XNRM) GO TO 370                            
      E(2)=0.0                                                          
  370 DT=DET(Q(1,1),Q(1,2),Q(1,3))*DET(R(1,1),R(1,2),R(1,3))            
*     WRITE (1,501) (E(I),I=1,3)                                        
      RETURN                                                            
  501 FORMAT (/,5X,'SINGULAR VALUES - ',3E15.5)                         
      END                                                               
      SUBROUTINE GIVNS(A,B,M,N)                                         
      DIMENSION A(3,3),B(3,3)                                           
      IF (ABS(A(M,N)).LT.ABS(A(N,N))) GO TO 10                          
      T=A(N,N)/A(M,N)                                                   
      S=1.0/SQRT(1.0+T*T)                                               
      C=S*T                                                             
      GO TO 20                                                          
   10 T=A(M,N)/A(N,N)                                                   
      C=1.0/SQRT(1.0+T*T)                                               
      S=C*T                                                             
   20 DO 30 J=1,3                                                       
      V=A(M,J)                                                          
      W=A(N,J)                                                          
      X=B(J,M)                                                          
      Y=B(J,N)                                                          
      A(M,J)=C*V-S*W                                                    
      A(N,J)=S*V+C*W                                                    
      B(J,M)=C*X-S*Y                                                    
   30 B(J,N)=S*X+C*Y                                                    
      RETURN                                                            
      END                                                               
      SUBROUTINE SWITCH(N,M,U,V,D)                                      
      DIMENSION U(3,3),V(3,3),D(3)                                      
      DO 10 I=1,3                                                       
      TEM=U(I,N)                                                        
      U(I,N)=U(I,N-1)                                                   
      U(I,N-1)=TEM                                                      
      IF (M.EQ.0) GO TO 10                                              
      TEM=V(I,N)                                                        
      V(I,N)=V(I,N-1)                                                   
      V(I,N-1)=TEM                                                      
   10 CONTINUE                                                          
      TEM=D(N)                                                          
      D(N)=D(N-1)                                                       
      D(N-1)=TEM                                                        
      RETURN                                                            
      END                                                               
C     SUBROUTINE MVVAD(A,B,C,D)                                         
      SUBROUTINE MVVAD(B,XAV,YAV,T)                                     
      DIMENSION B(3,3),XAV(3),YAV(3),T(3)                               
C     DIMENSION A(3,3),B(3),C(3),D(3)                                   
C     DO 10 J=1,3                                                       
C     D(J)=C(J)                                                         
C     DO 10 I=1,3                                                       
C  10 D(J)=D(J)+A(J,I)*B(I)                                             
      DO 10 J=1,3                                                       
      T(J)=YAV(J)                                                       
      DO 10 I=1,3                                                       
   10 T(J)=T(J)+B(J,I)*XAV(I)                                           
      RETURN                                                            
      END                                                               
      REAL FUNCTION DET (A,B,C)                                         
      DIMENSION A(3),B(3),C(3)                                          
      DET=A(1)*(B(2)*C(3)-B(3)*C(2))+A(2)*(B(3)*C(1)-B(1)*C(3))         
     1  +A(3)*(B(1)*C(2)-B(2)*C(1))                                     
      RETURN                                                            
      END                                                               
      SUBROUTINE MMMUL(A,B,C)                                           
      DIMENSION A(3,3),B(3,3),C(3,3)                                    
      DO 10 I=1,3                                                       
      DO 10 J=1,3                                                       
      C(I,J)=0.0                                                        
      DO 10 K=1,3                                                       
   10 C(I,J)=C(I,J)+A(I,K)*B(K,J)                                       
      RETURN                                                            
      END                                                               
      SUBROUTINE MATVEC(UVEC,TMAT,PVEC,NBACK)                           
      REAL*4 TMAT(3,3),UVEC(3,NBACK), PVEC(3,NBACK)                     
C                                                                       
      DO 2 J=1,NBACK                                                    
         DO 1 I=1,3                                                     
         UVEC(I,J) = 0.0                                                
         DO 1 K=1,3                                                     
    1    UVEC(I,J)=UVEC(I,J)+TMAT(I,K)*PVEC(K,J)                        
    2 CONTINUE                                                          
      RETURN                                                            
      END                                                               
