      double precision function rdif(nparm,nfun,parm,lder)
      implicit none
      include 'PARAMET.ECEPP'
      include 'PARAMET.ADD'
      include 'sizesclu.dat'
      include 'PARAMET.FIT' 
      include 'COMMON.MORASS'
      integer nconf,nparm,nfun
      real*8 parm(nparm)
      real*8 abjom,derva0,derva1,derva2,bbij,std,partij,sumparm,
     &       stdcoupl,cost,coscost,we(maxconf)
      logical lder
      integer i,ii,j
      include 'COMMON.IOUNIT'
      include 'COMMON.MARQ'
      include 'COMMON.MATRIX'
      nfun=nfun+1
      std=0.0D0
C Contributions due to coupling constants
      sumparm=0.0D0
      if (bystrov) then
        nconf=nparm-3
      else
        nconf=nparm
      endif

      do i=1,nconf+3
        do j=1,nparm
          derv(i,j)=0.0d0
        enddo
      enddo
      do j=1,nconf
        we(j)=dexp(parm(j))
        sumparm=sumparm+we(j)
      enddo

      if (bystrov) then

        aa0=parm(nconf+1)
        aa1=parm(nconf+2)
        aa2=parm(nconf+3)
        do i=1,ncoupl
          ii=i+npeak
          derva1=0.0d0
          derva2=0.0d0
          abjom=0.0D0
          do j=1,nconf
            cost=costhe(i,j)
            coscost=cost*cost
            derva1=derva1+cost*we(j)
            derva2=derva2+coscost*we(j)
            bbij=aa0+cost*aa1+coscost*aa2
            partij=bbij*we(j)
            abjom=abjom+partij
            derv(ii,j)=partij 
          enddo
          abjom=abjom/sumparm
          derv(ii,nconf+1)=1.0d0
          derv(ii,nconf+2)=derva1/sumparm
          derv(ii,nconf+3)=derva2/sumparm
          do j=1,nconf
            derv(ii,j)=(derv(ii,j)-abjom*we(j))/sumparm
          enddo ! j
          std=std+wpeak(ii)*(vol(ii)-abjom)**2
          dvol(ii)=vol(ii)-abjom
        enddo ! i
        dvol(npeak+ncoupl+1)=a0-aa0
        dvol(npeak+ncoupl+2)=a1-aa1
        dvol(npeak+ncoupl+3)=a2-aa2
        derv(npeak+ncoupl+1,nconf+1)=1.0d0
        derv(npeak+ncoupl+2,nconf+2)=1.0d0
        derv(npeak+ncoupl+3,nconf+3)=1.0d0
        std=std+wpeak(npeak+ncoupl+1)*(a0-aa0)**2+
     &          wpeak(npeak+ncoupl+2)*(a1-aa1)**2+
     &          wpeak(npeak+ncoupl+3)*(a2-aa2)**2
      endif !bystrov
C Contributions due to peak volumes
      do i=1,npeak
        abjom=0.0D0
        do j=1,nconf
          partij=bb(i,j)*we(j)
          abjom=abjom+partij
          derv(i,j)=partij 
        enddo
        std=std+wpeak(i)*(vol(i)-abjom)**2
        dvol(i)=vol(i)-abjom
cd      write (jout,'(i5,4(1pe15.5))') i,abjom,vol(i),wpeak(i),std
      enddo
      rdif=std
      return
      end  
c-------------------------------------------------------------------
      subroutine heval(nparm,parm,lsecond)
      implicit none
      include 'PARAMET.ECEPP'
      include 'PARAMET.ADD'
      include 'sizesclu.dat'
      include 'PARAMET.FIT'
      include 'COMMON.MATRIX'
      include 'COMMON.MARQ'
      include 'COMMON.MORASS'
      logical lsecond
      integer nparm,nfun
      real*8 parm(nparm)
      real*8 abjom,gi,aii,aij,dervki,partij
      integer i,j,k,nexp
      if (bystrov) then
        nexp=npeak+ncoupl+3
      else
        nexp=npeak
      endif
      do i=1,nparm
        gi=0.0D0
        aii=0.0D0
        do k=1,nexp
          dervki=derv(k,i)
          gi=gi+dervki*dvol(k)*wpeak(k)
          aii=aii+dervki*dervki*wpeak(k)
        enddo  ! k
        g(i)=gi
        h(i,i)=aii
        do j=i+1,nparm
          aij=0.0D0
          do k=1,nexp
            aij=aij+wpeak(k)*derv(k,i)*derv(k,j)
          enddo! k
          h(i,j)=aij
          h(j,i)=aij
        enddo  ! j
      enddo    ! i
      return
      end
