      double precision function rdif(nparm,nfun,parm,lder)
      implicit none
      include 'PARAMET.ECEPP'
      include 'PARAMET.ADD'
      include 'sizesclu.dat'
      include 'PARAMET.FIT' 
      include 'COMMON.MORASS'
      integer nconf,nparm,nfun
      real*8 parm(nparm)
      real*8 abjom,derva0,derva1,derva2,bbij,std,partij,sumparm,
     &       stdcoupl,cost,coscost,we(maxconf),aux
      logical lder
      integer i,k,ii,iti,j,nall
      include 'COMMON.IOUNIT'
      include 'COMMON.MARQ'
      include 'COMMON.MATRIX'
      nfun=nfun+1
      std=0.0D0
C Contributions due to coupling constants
      sumparm=0.0D0
      if (bystrov) then
        nconf=nparm-3*ntyp_coupl
      else
        nconf=nparm
      endif

      do i=1,nconf+3
        do j=1,nparm
          derv(i,j)=0.0d0
        enddo
      enddo
      do j=1,nconf
        we(j)=dexp(parm(j))
        sumparm=sumparm+we(j)
      enddo

      nall=npeak
      if (bystrov) then

        do i=1,ntyp_coupl
          aa0(i)=parm(nconf+3*(i-1)+1)
          aa1(i)=parm(nconf+3*(i-1)+2)
          aa2(i)=parm(nconf+3*(i-1)+3)
        enddo
        do i=1,ncoupl
          ii=i+npeak
          iti=ityp_coupl(i)
c          write (jout,*) 'i',i,' ii',ii,' iti',iti,
c     &     ' aa0',aa0(iti),' aa1',aa1(iti),' aa2',aa2(iti)
c          write (jout,*) 
          derva1=0.0d0
          derva2=0.0d0
          abjom=0.0D0
          do j=1,nconf
            cost=costhe(i,j)
            coscost=cost*cost
            derva1=derva1+cost*we(j)
            derva2=derva2+coscost*we(j)
            bbij=aa0(iti)+cost*aa1(iti)+coscost*aa2(iti)
            partij=bbij*we(j)
            abjom=abjom+partij
            derv(ii,j)=partij 
          enddo
          abjom=abjom/sumparm
          derv(ii,nconf+3*(iti-1)+1)=1.0d0
          derv(ii,nconf+3*(iti-1)+2)=derva1/sumparm
          derv(ii,nconf+3*(iti-1)+3)=derva2/sumparm
c          write (jout,*) 
c     &     ii,(3*(iti-1)+k,derv(ii,nconf+3*(iti-1)+k),k=1,3)
          do j=1,nconf
            derv(ii,j)=(derv(ii,j)-abjom*we(j))/sumparm
          enddo ! j
          std=std+wpeak(ii)*(vol(ii)-abjom)**2
c          write (jout,*) 'vol',vol(ii),' abjom',abjom
          dvol(ii)=vol(ii)-abjom
        enddo ! i
        do iti=1,ntyp_coupl
          dvol(npeak+ncoupl+3*(iti-1)+1)=a0(iti)-aa0(iti)
          dvol(npeak+ncoupl+3*(iti-1)+2)=a1(iti)-aa1(iti)
          dvol(npeak+ncoupl+3*(iti-1)+3)=a2(iti)-aa2(iti)
          derv(npeak+ncoupl+3*(iti-1)+1,nconf+3*(iti-1)+1)=1.0d0
          derv(npeak+ncoupl+3*(iti-1)+2,nconf+3*(iti-1)+2)=1.0d0
          derv(npeak+ncoupl+3*(iti-1)+3,nconf+3*(iti-1)+3)=1.0d0
c          write (jout,*) (3*(iti-1)+k,
c     &    derv(npeak+ncoupl+3*(iti-1)+k,nconf+3*(iti-1)+k),k=1,3)
          std=std+wpeak(npeak+ncoupl+1)*(a0(iti)-aa0(iti))**2+
     &          wpeak(npeak+ncoupl+2)*(a1(iti)-aa1(iti))**2+
     &          wpeak(npeak+ncoupl+3)*(a2(iti)-aa2(iti))**2
        enddo
        nall=npeak+ncoupl+3*ntyp_coupl
      endif !bystrov
! Apply maximum entropy
      entropy=0.0d0
      do i=1,nconf
        entropy=entropy+we(i)*parm(i)
      enddo
      aux=entropy/(sumparm*sumparm)
      entropy=entropy/sumparm-dlog(sumparm)
      do i=1,nconf
        gent(i)=we(i)*(aux-parm(i)/sumparm)
      enddo
C Contributions due to peak volumes
      do i=1,npeak
        abjom=0.0D0
        do j=1,nconf
          partij=bb(i,j)*we(j)
          abjom=abjom+partij
          derv(i,j)=partij 
        enddo
        std=std+wpeak(i)*(vol(i)-abjom)**2
        dvol(i)=vol(i)-abjom
cd      write (jout,'(i5,4(1pe15.5))') i,abjom,vol(i),wpeak(i),std
      enddo
      rdif=std
      return
      end  
c-------------------------------------------------------------------
      subroutine heval(nparm,parm,lsecond)
      implicit none
      include 'PARAMET.ECEPP'
      include 'PARAMET.ADD'
      include 'sizesclu.dat'
      include 'COMMON.IOUNIT'
      include 'PARAMET.FIT'
      include 'COMMON.MATRIX'
      include 'COMMON.MARQ'
      include 'COMMON.MORASS'
      logical lsecond
      integer nparm,nfun
      real*8 parm(nparm)
      real*8 abjom,gi,aii,aij,dervki,partij
      integer i,j,k,nexp
      if (bystrov) then
        nexp=npeak+ncoupl+nparm
      else
        nexp=npeak+nparm
      endif
c      do k=1,nexp
c        write (jout,*) k,wpeak(k)
c      enddo
      do i=1,nparm
        gi=0.0D0
        aii=0.0D0
        do k=1,nexp
          dervki=derv(k,i)
          gi=gi+dervki*dvol(k)*wpeak(k)
          aii=aii+dervki*dervki*wpeak(k)
        enddo  ! k
        g(i)=gi
c        write (jout,*) 'i',i,' g',g(i)
        h(i,i)=aii
        do j=i+1,nparm
          aij=0.0D0
          do k=1,nexp
            aij=aij+wpeak(k)*derv(k,i)*derv(k,j)
          enddo! k
          h(i,j)=aij
          h(j,i)=aij
        enddo  ! j
      enddo    ! i
      return
      end
