C
C------------------------------------------------------------------------------
C
      SUBROUTINE READGM(NST,INP,IOUT,FAIL,FAIL1)
C THIS SUBROUTINE READS IN THE INTERNAL COORDINATES, CHECKS THE TYPES
C FOR CORECTNESS, AND SORTS THE ATOM REFERENCE TABLE (IREF). FAIL IS SET
C TO .TRUE., IF FURTHER PROCESSING OF THE DATA IS IMPOSSIBLE. FAIL1=.TRU
C INDICATES THAT INTERNAL COORDINATES CAN BE CALCULATED, THOUGH SOME
C THING GOES WRONG. THREE INPUT FORMATS ARE AVAILABLE.
      include 'PARAMET.ECEPP'
      include 'PARAMET.ADD'
      LOGICAL FAIL,CHECK,FAIL1,BEGIN
      DIMENSION NUM(30)
      COMMON /NAMAT/ NAME(30)
      include 'COMMON.ATOMS3'
      include 'COMMON.LOC'
      DATA NUM/' 1',' 2',' 3',' 4',' 5',' 6',' 7',' 8',' 9','10','11',
     1 '12','13','14','15','16','17','18','19','20','21','22','23','24',
     2 '25','26','27','28','29','30'/
      FAIL=.FALSE.
      FAIL1=.FALSE.
      IF (NST.GT.NATOMS) GOTO 111
      NLIN=2                                                           
      WRITE (IOUT,2030)
      READ (INP,1001) INAM                                                
 1001 FORMAT (I1)
      DO 1 I=NST,NATOMS
C     IF (INAM.NE.1) GOTO 60
C     READ (INP,'(A2)') IT
C     READ (INP,*) NUMER,I1,I2,I3,DIA,ALFIAB,BIABC,IND
C     GOTO 61                                                   
   60 IF (INAM.EQ.0) GOTO 62                                           
      READ (INP,1005,END=25) IT,NUMER,DIA,ALFIAB,BIABC,I1,I2,I3,IND    
      GOTO 61                                                          
   62 READ (INP,1000,END=25) IT,NUMER,I1,I2,I3,DIA,ALFIAB,BIABC,IND    
   61 IF (NUMER.EQ.0) NUMER=I                                          
      IF (I.EQ.1) GOTO 32                                              
      IF (I.LE.3.AND.I1.EQ.0) I1=I-1                                   
      IF (I.EQ.3.AND.I2.EQ.0) I2=I-2                                   
      II1=I-1                                                          
      DO 33 J=1,II1                                                    
      IF (NUMER.NE.IREF(J,1)) GOTO 33                                  
      WRITE (IOUT,1100) NUMER                                          
      FAIL=.TRUE.                                                      
      GOTO 32
   33 CONTINUE                                                          
   32 CONTINUE                                                          
      DO 2 J=1,30                                                       
      IF (IT.NE.NAME(J)) GOTO 3                                         
      ITYPE(NUMER)=J                                                    
      GOTO 4                                                            
    3 IF (IT.NE.NUM(J)) GOTO 2                                          
      ITYPE(NUMER)=J                                                    
      GOTO 4                                                            
    2 CONTINUE                                                          
C                                                                       
C IF THIS POINT IS REACHED, THE ATOM TYPE IS ILLEGAL. AN ERROR MESSAGE  
C IS PRINTED.                                                           
C                                                                       
      FAIL1=.TRUE.                                                      
      WRITE (IOUT,1010) NUMER,IT                                        
    4 IF (DIA.GT.0.D0.OR.I2.EQ.0.D0) GOTO 20                                
      WRITE (IOUT,1020) NUMER                                           
      FAIL1=.TRUE.                                                      
   20 IREF(I,1)=NUMER                                                   
      IREF(I,2)=I1                                                      
      IREF(I,3)=I2                                                      
      IREF(I,4)=I3                                                      
      IREF(I,5)=IND                                                     
      DCOR(I,1)=DIA                                                        
      DCOR(I,2)=ALFIAB                                                     
      DCOR(I,3)=BIABC                                                      
      WRITE (IOUT,2000) NAME(J),NUMER,J,I1,I2,I3,DIA,
     # ALFIAB,BIABC,IND 
    1 CONTINUE
      GOTO 31
   25 WRITE (IOUT,2050)
      NATOMS=I-1
      FAIL1=.TRUE.
      IF (NATOMS.EQ.0) RETURN
   31 IF (NATOMS.EQ.1) RETURN
C 
C THE INTERNAL COORDINATES HAVE BEEN ALREADY READ IN. THE PROGRAM WILL
C SORT AND SIMULTANEOUSLY CHECK FOR CORECTNESS THE TABLE IREF.
C
C NOW THE FIRST (ACC. TO IREF) ATOM IS BEING SEARCHED.
C
      CHECK=.FALSE.
      DO 5 I=1,NATOMS
      IF (IREF(I,2).NE.0) GOTO 5
      IF (CHECK) GOTO 6
      II=I
      CHECK=.TRUE.
      GOTO 5
    6 WRITE (IOUT,1040) IREF(I,1)
      FAIL=.TRUE.
    5 CONTINUE
      IF (CHECK) GOTO 7
      FAIL=.TRUE.
      WRITE (IOUT,1050)
      RETURN
    7 IF (II.EQ.1) GOTO 8
      DO 9 I=1,5
      IRE=IREF(II,I)
      IREF(II,I)=IREF(1,I)
    9 IREF(1,I)=IRE
      DO 10 I=1,3
      DI=DCOR(II,I)
      DCOR(II,I)=DCOR(1,I)
   10 DCOR(1,I)=DI
C
C SEARCHES FOR THE SECOND ATOM.
C
    8 IF (NATOMS.EQ.1) RETURN
      CHECK=.FALSE.
      DO 11 I=2,NATOMS
      IF (IREF(I,3).NE.0) GOTO 11 
      IF (CHECK) GOTO 12
      II=I
      CHECK=.TRUE.
      GOTO 11
   12 WRITE (IOUT,1070) IREF(I,1)
      FAIL=.TRUE.
   11 CONTINUE
      IF (CHECK) GOTO 13
      FAIL=.TRUE.
      WRITE (IOUT,1080)
      RETURN
   13 IF (IREF(II,2).EQ.IREF(1,1)) GOTO 39
      WRITE (IOUT,1060) IREF(1,1)
      FAIL=.TRUE.
      RETURN
   39 IF (II.EQ.2) GOTO 14
      DO 15 I=1,5
      IRE=IREF(II,I)
      IREF(II,I)=IREF(2,I)
   15 IREF(2,I)=IRE
      DO 16 I=1,3
      DI=DCOR(II,I)
      DCOR(II,I)=DCOR(2,I)
   16 DCOR(2,I)=DI
C
C NOW THE TABLE IREF IS BEING SORTED.
C
   14 BEGIN=.TRUE.
      IF (NATOMS.EQ.2) RETURN
      DO 17 I=3,NATOMS
      I1=I-1
      DO 18 J=I,NATOMS
      CHECK=.TRUE.
      DO 19 JJ=2,4
      IREJ=IREF(J,JJ)
      IF (IREJ.GT.0) GOTO 30
      IF (DCOR(J,2).EQ.0.D0.OR.DCOR(J,2).EQ.180.D0) GOTO 23
      IF (.NOT.BEGIN) GOTO 21
      BEGIN=.FALSE.
      GOTO 23
   21 WRITE (IOUT,1090) IREF(J,1) 
      FAIL1=.TRUE.
      DCOR(J,2)=0.D0
      GOTO 23
   30 DO 22 K=1,I1
      IK=I-K
      IREK=IREF(IK,1)
      IF (IREJ.NE.IREK) GOTO 22
      GOTO 19
   22 CONTINUE
      CHECK=.FALSE.
      GOTO 18
   19 CONTINUE
      IF (CHECK) GOTO 23
   18 CONTINUE
      WRITE (IOUT,1060) IREF(I-1,1)
      NATOMS=I-1
      FAIL1=.TRUE.
      GOTO 24
   23 IF (J.EQ.I) GOTO 17
      DO 26 JJ=1,5
      IRE=IREF(J,JJ)
      IREF(J,JJ)=IREF(I,JJ)
   26 IREF(I,JJ)=IRE
      DO 27 JJ=1,3
      DJ=DCOR(J,JJ)
      DCOR(J,JJ)=DCOR(I,JJ)
   27 DCOR(I,JJ)=DJ
   17 CONTINUE
   24 WRITE (IOUT,2040)
  111 WRITE (IOUT,2030)
      DO 28 I=1,NATOMS
      NUMER=IREF(I,1)
      J=ITYPE(NUMER)
      WRITE (IOUT,2000) NAME(J),NUMER,J,IREF(I,2),IREF(I,3),
     1 IREF(I,4),DCOR(I,1),DCOR(I,2),DCOR(I,3),IREF(I,5)
   28 CONTINUE
 1000 FORMAT (A2,I3,3I5,3F15.10,I5)
 1005 FORMAT (A2,3X,I5,3F20.10,4I2)
 1010 FORMAT (1X,' * * * ERROR - ATOM',I4,' HAS AN UNRESOLVED SYMBOL',
     1 ' OR TYPE: ',A2)
 1020 FORMAT (1X,' * * * ERROR - ATOM',I4,' HAS ZERO BOND LENGTH')
 1040 FORMAT (1X,' * * * ERROR - ATOM',I4,' HAS NO REFERENCES. FIRST',
     1 ' ATOM HAS BEEN ALREADY FOUND.')
 1050 FORMAT (1X,' * * * ERROR - FIRST ATOM HAS NOT BEEN FOUND.')
 1060 FORMAT (1X,' * * * ERROR - ATOMS FOLLOWING ATOM',I4,' HAVE UNDEF',
     1 'INED REFERENCES')
 1070 FORMAT (1X,' * * * ERROR - ATOM',I4,' HAS INCOMPLETE REFERENCES.',
     1 ' SECOND ATOM HAS BEEN ALREADY FOUND.')
 1080 FORMAT (1X,' * * * ERROR - SECOND ATOM HAS NOT BEEN FOUND.')
 1090 FORMAT (1X,' * * * ERROR - ATOM',I4,' HAS NOT THIRD REFERENCE ',
     1 'ATOM, WHILE ITS FIRST LOCATION ANGLE IS NOT ZERO OR 180 DEG.'/
     2 1X,'ANGLE WAS SET TO ZERO DEG.')
 1100 FORMAT (1X,' * * * ERROR - ATOM OF NUMBER',I4,' HAS BEEN ALREADY',
     1 ' FOUND')
 2000 FORMAT (1X,A2,1H(,I3,1H),1X,I4,2X,3I5,F15.5,2F15.3,I5)
 2030 FORMAT (/1X,10(2H* ),'INPUT INTERNAL COORDINATES ',10(2H* )//1X,
     1 ' ATOM   ATOMIC     LOCATION',9X,'DISTANCE',4X,'FIRST ANGLE',
     2 3X,'SECOND ANGLE',2X,'IND'/9X,'NUMBER'/1X,79(1H-))
 2040 FORMAT (//1X,' * * * * * * * * * * DATA AFTER SORTING * * * * ',
     1 '* * * * * *')         
 2050 FORMAT (/1X,' * * * ERROR - NUMBER OF DATA LESS THAN THE NUMBER ',
     1 'OF ATOMS SPECIFIED.')
      RETURN
      END
C
C------------------------------------------------------------------------------
C
      SUBROUTINE LOCATE(NST,NEND,FAIL,IOUT)
      include 'PARAMET.ECEPP'
      include 'PARAMET.ADD'
C THIS SUBROUTINE CALCULATES CARTESIAN COORDINATES OF ALL ATOMS.
C NST IS THE POSITION IN IREF OF FIRST ATOM WHOSE COORDINATES
C ARE CALCULATED.
      LOGICAL FAIL,FAIL1,LINEAR
      include 'COMMON.ATOMS3'
      include 'COMMON.LOC'
      include 'COMMON.LOCSYS'
      NNST=NST
      IF (NNST.GT.NEND) RETURN
      IF (NNST.GT.2) GOTO 4
      IF (NNST.EQ.2) GOTO 5
      IRE=IREF(1,1)
      DO 3 I=1,3
    3 X(IRE,I)=0.0
      IF (NEND.EQ.1) RETURN
    5 IRE=IREF(2,1)
      X(IRE,1)=DCOR(2,1)
      X(IRE,2)=0.0
      X(IRE,3)=0.0
      IF (NEND.EQ.2) RETURN
      NNST=3
      NLIN=2
    4 IF (NNST-NLIN-2) 8,9,9
    8 IF (NNST.LE.NLIN) NLIN=NNST-1
      DO 2 ILIN=NNST,NEND
      ALFIAB=DCOR(ILIN,2)*RAD
      DIA=DCOR(ILIN,1)
      I1=IREF(ILIN,1)
      I2=IREF(ILIN,2)
      I3=IREF(ILIN,3)
      CALL LOCLIN(FAIL1,LINEAR,IOUT)
      FAIL=FAIL.OR.FAIL1
      IF (.NOT.LINEAR) GOTO 1
    2 CONTINUE
C
C IF THIS POINT IS REACHED, THE MOLECULE IS LINEAR.
C
      RETURN
    1 NLIN=ILIN-1
      NNST=ILIN+1
      IF (X(I2,1)-X(I3,1)) 10,10,12
   10 X(I1,1)=X(I2,1)+DIA*COSA
      GOTO 13
   12 X(I1,1)=X(I2,1)-DIA*COSA
   13 X(I1,2)=DIA*SIN(ALFIAB)
      X(I1,3)=0.D0
      IF (NNST.GT.NEND) RETURN
    9 DO 14 II=NNST,NEND
      I1=IREF(II,1)
      I2=IREF(II,2)
      I3=IREF(II,3)
      I4=IREF(II,4)
      DIA=DCOR(II,1)
      if (dia.eq.0.0) then
        do jj=1,3
          x(i1,jj)=x(i2,jj)
        enddo
        goto 14
      endif
      ALFIAB=DCOR(II,2)*RAD
      BIABC=DCOR(II,3)*RAD
      CALL LOCLIN(FAIL1,LINEAR,IOUT)
      IF (LINEAR.OR.FAIL1) GOTO 114
      IF (IREF(II,5).GT.0.D0) GOTO 15
      CALL REFSYS(FAIL1,IOUT)
      FAIL=FAIL.OR.FAIL1
      IF (FAIL1) GOTO 114
      CALL LOCBET
      GOTO 14
   15 IPOM=I2
      I2=I3
      I3=IPOM
      CALL REFSYS(FAIL1,IOUT)
      FAIL=FAIL.OR.FAIL1
      CALL LOCALF(FAIL1,IOUT)
      FAIL=FAIL.OR.FAIL1
  114 CONTINUE
   14 CONTINUE
      RETURN
      END
C
C------------------------------------------------------------------------------
C
      SUBROUTINE LOCBET
      include 'PARAMET.ECEPP'
      include 'PARAMET.ADD'
C THIS SUBROUTINE CALCULATES THE CARTESIAN COORDINATES OF ATOM (I1)
C OF REFERENCES (I2), (I3), AND (I4), IF THE PLANAR ANGLE (I1,I2,I3)
C AND THE DIHEDRAL ANGLE (I1,I2,I3,I4) ARE GIVEN.
      include 'COMMON.ATOMS3'
      include 'COMMON.LOC'
      include 'COMMON.LOCAL'
      include 'COMMON.LOCSYS'
      SINA=SIN(ALFIAB)                                                  
      V1=-DIA*COSA                                                      
      V2=DIA*SINA*COS(BIABC)                                            
      V3=DIA*SIN(BIABC)*SINA                                            
      DO 1 I=1,3                                                        
    1 X(I1,I)=X(I2,I)+E1(I)*V1+E2(I)*V2+E3(I)*V3                        
      RETURN                                                            
      END                                                               
C                                                                       
C------------------------------------------------------------------------------
C                                                                       
      SUBROUTINE LOCALF(FAIL,IOUT)                                      
      include 'PARAMET.ECEPP'
      include 'PARAMET.ADD'
C THIS SUBROUTINE CALCULATES THE CARTESIAN COORDINATES OF ATOM (I1)     
C OF REFERENCES (I2), (I3), AND (I4), IF TWO PLANAR ANGLES ARE GIVEN.   
C SETS FAIL TO .TRUE. IF THESE ANGLES ARE FROM INVALID RANGE.
      LOGICAL FAIL
      include 'COMMON.ATOMS3'
      include 'COMMON.LOC'
      include 'COMMON.LOCAL'
      include 'COMMON.LOCSYS' 
      DATA TOLSQ /1.E-6/                                                
      FAIL=.FALSE.                                                      
      V1=DIA*COSA                                                       
      COSIN=(U(1)*Z(1)+U(2)*Z(2)+U(3)*Z(3))*S1*S2                       
      SINUS=SQRT(1.0-COSIN*COSIN)                                       
      COSB=COS(BIABC)                                                   
      V2=DIA*(COSB-COSIN*COSA)/SINUS                                    
      SGN=-1.0                                                          
      IF (BIABC.LT.0.0) SGN=1.0                                         
      IF (BIABC.LT.3.14159) SGN=-SGN                                    
      ARG=DIA*DIA-V1*V1-V2*V2                                           
      IF (ABS(ARG).LE.TOLSQ) ARG=0.0                                    
      IF (ARG.GE.0) GOTO 1                                              
      WRITE (IOUT,1000) I1,I2,I3,I1,I2,I4,I1                            
 1000 FORMAT (/1X,' * * * ERROR - ANGLES',2(I4,1H-),I4,' AND',2(I4,1H-),
     1 I4,' ARE INVALID. COORDINATES OF ATOM',I4,' ARE SET TO ZERO.')   
      FAIL=.TRUE.                                                       
      DO 2 I=1,3                                                        
    2 X(I1,I)=0.0                                                       
      RETURN                                                            
    1 V3=SGN*SQRT(ARG)                                                  
      DO 3 I=1,3                                                        
    3 X(I1,I)=X(I3,I)+E1(I)*V1+E2(I)*V2+E3(I)*V3                        
      RETURN                                                            
      END
C
C------------------------------------------------------------------------------
C
      SUBROUTINE LOCLIN(FAIL,LINEAR,IOUT)
      include 'PARAMET.ECEPP'
      include 'PARAMET.ADD'
C THIS SUBROUTINE CHECKS IF ATOMS (I1), (I2), AND (I3) FORM A LINEAR    
C FRAGMENT AND CALCULATES THE COORDINATES OF ATOM (I1) IN SUCH A CASE.  
C SETS FAIL TO .TRUE., IF THE REFERENCE ATOMS (I2) AND (I3) COINCIDE.
      LOGICAL FAIL,LINEAR
      include 'COMMON.ATOMS3'
      include 'COMMON.LOCSYS'
      DATA TOLLIN /.9999/,COINC /.001/                                  
      LINEAR=.FALSE.                                                    
      FAIL=.FALSE.                                                      
      COSA=COS(ALFIAB)                                                  
      IF (ABS(COSA).LT.TOLLIN) RETURN                                   
      LINEAR=.TRUE.                                                     
      X1=X(I2,1)                                                        
      X2=X(I2,2)                                                        
      X3=X(I2,3)                                                        
      V1=X1-X(I3,1)                                                     
      V2=X2-X(I3,2)                                                     
      V3=X3-X(I3,3)                                                     
      ANORM=SQRT(V1*V1+V2*V2+V3*V3)                                     
      IF (ANORM.GT.COINC) GOTO 1                                        
      WRITE (IOUT,1000) I2,I3,I1                                        
 1000 FORMAT (/1X,' * * * ERROR - ATOMS',I4,' AND',I4,' COINCIDE. ',    
     1 'COORDINATES OF ATOM',I4,' ARE SET TO ZERO')                     
      FAIL=.TRUE.                                                       
      DO 2 I=1,3                                                        
    2 X(I1,I)=0.0                                                       
      RETURN                                                            
    1 ANORM=-DIA/ANORM*COSA                                             
      X(I1,1)=X1+V1*ANORM                                               
      X(I1,2)=X2+V2*ANORM                                               
      X(I1,3)=X3+V3*ANORM                                               
      RETURN                                                            
      END
C
C-----------------------------------------------------------------------------
C            
      SUBROUTINE REFSYS(FAIL,IOUT)
      include 'PARAMET.ECEPP'
      include 'PARAMET.ADD'
C THIS SUBROUTINE CALCULATES UNITY VECTORS OF A LOCAL REFERENCE SYSTEM
C DEFINED BY ATOMS (I2), (I3), AND (I4). THE X AXIS IS THE AXIS FROM
C ATOM (I3) TO ATOM (I2), AND THE XY PLANE IS THE PLANE DEFINED BY ATOMS
C (I2), (I3), AND (I4). Z AXIS IS DIRECTED ACCORDING TO THE SIGN OF THE
C VECTOR PRODUCT (I3)-(I2) AND (I3)-(I4). SETS FAIL TO .TRUE. IF ATOMS
C (I2) AND (I3) OR (I3) AND (I4) COINCIDE OR ATOMS (I2), (I3), AND (I4)
C FORM A LINEAR FRAGMENT. RETURNS VECTORS E1, E2, AND E3.
      LOGICAL FAIL
      include 'COMMON.ATOMS3'
      include 'COMMON.LOC'
      include 'COMMON.LOCAL'
      include 'COMMON.LOCSYS'
      DATA COINC /.001E0/,ALIGN /.000001E0/
      FAIL=.FALSE.
      S1=0.0
      S2=0.0
      DO 1 I=1,3
      ZI=X(I2,I)-X(I3,I)
      UI=X(I4,I)-X(I3,I)
      S1=S1+ZI*ZI
      S2=S2+UI*UI
      Z(I)=ZI
    1 U(I)=UI
      S1=SQRT(S1)
      S2=SQRT(S2)
      IF (S1.GT.COINC) GOTO 2
      WRITE (IOUT,1000) I2,I3,I1
      FAIL=.TRUE.
      DO 3 I=1,3
    3 X(I1,I)=0.0
      RETURN
    2 IF (S2.GT.COINC) GOTO 4
      WRITE(IOUT,1000) I3,I4,I1
      FAIL=.TRUE.
      DO 5 I=1,3
    5 X(I1,I)=0.0
      RETURN
    4 S1=1.0/S1
      S2=1.0/S2
      V1=Z(2)*U(3)-Z(3)*U(2)
      V2=Z(3)*U(1)-Z(1)*U(3)
      V3=Z(1)*U(2)-Z(2)*U(1)
      ANORM=SQRT(V1*V1+V2*V2+V3*V3)
      IF (ANORM.GT.ALIGN) GOTO 6
      WRITE (IOUT,1010) I2,I3,I4,I1
      FAIL=.TRUE.
      DO 7 I=1,3
    7 X(I1,I)=0.0
      RETURN
    6 ANORM=1.0/ANORM
      E3(1)=V1*ANORM
      E3(2)=V2*ANORM
      E3(3)=V3*ANORM
      E1(1)=Z(1)*S1
      E1(2)=Z(2)*S1
      E1(3)=Z(3)*S1
      E2(1)=E1(3)*E3(2)-E1(2)*E3(3)
      E2(2)=E1(1)*E3(3)-E1(3)*E3(1)
      E2(3)=E1(2)*E3(1)-E1(1)*E3(2)
 1000 FORMAT (/1X,' * * * ERROR - ATOMS',I4,' AND',I4,' COINCIDE.',
     1 'COORDINATES OF ATOM',I4,' ARE SET TO ZERO.')
 1010 FORMAT (/1X,' * * * ERROR - ATOMS',2(I4,2H, ),I4,' FORM A LINEAR'
     1 ' FRAGMENT. COORDINATES OF ATOM',I4,' ARE SET TO ZERO.')
      RETURN
      END
C
