C =========================================================================
C MOLECULE.INC 
C   'INCLUDE' FILE CONTAINING
C             VARIOUS GLOBAL PARAMETERS, COUNTERS, AND LOGICALS
C             ATOMIC IDS, COORDINATES INC. METHYLS & HBONDS
C             GLOBAL NMRD DATA     
C             DEFAULT VALUES AND FILE NAMES
C             COMMON BLOCKS
C =========================================================================
C
      INTEGER I,MXCRD,MXMP,MXWRD,MXMRG,MXWR
      PARAMETER (MXCRD=2500)
      PARAMETER (MXMP=600)
      PARAMETER (MXWRD=300)
      PARAMETER (MXMRG=600)
      PARAMETER (MXWR=100)
C
C -----
C VARIABLES USED IN ATOMIC IDENTIFIERS, POSITIONS, CARTESIAN COORDINATES
C -----
C
      CHARACTER*40    FMTYPE,PDBFILE
      CHARACTER*4     CR, CRES(MXCRD), CA, CATM(MXCRD)
      CHARACTER*4     HBCRES(MXMP),  HBCATM(MXMP)
      CHARACTER*4     MCRES(MXMP),  MCATM(MXMP)
      INTEGER         IA, IATM(MXCRD), IR, IRES(MXCRD),NSPT
      INTEGER         IMATM(MXMP), IMRES(MXCRD), NMETS
      INTEGER         IHBATM(MXMP), IHBRES(MXMP), NBSE
      INTEGER         IAPTRI(MXCRD),IAPTRJ(MXCRD),LPDBFIL
      COMMON   /ATMID/  CRES,CATM,CR,CA,IATM,IRES,IA,IR,NSPT,
     +                  NBSE,FMTYPE,IHBATM,IHBRES,HBCRES,HBCATM,
     +                  NMETS,IMATM,IMRES,MCATM,MCRES,PDBFILE,LPDBFIL
C
      REAL            X, RX(MXCRD), Y, RY(MXCRD), Z, RZ(MXCRD)
      REAL            RXM(MXMP), RYM(MXMP), RZM(MXMP)
      COMMON /COOR/   RX,RY,RZ,X,Y,Z,RXM,RYM,RZM
C
C -----
C NMR DATA FOR WHOLE MOLECULE
C -----
C
      REAL            VOL0T(MXCRD),RHOT(MXCRD),SHIFT(MXCRD),V0,TIME,TAU,
     +                OM0,RCUT,TAUM
      COMMON /MAGN/   VOL0T,RHOT,SHIFT,V0,TIME,TAU,OM0,RCUT,TAUM
C
C -----
C GLOBAL LOGICALS
C -----
C
      LOGICAL       CHECK,INTRCTV,VERBOSE
      COMMON /MISC/ CHECK,INTRCTV,VERBOSE
C
C -----
C DEFAULT VALUES.
C -----
C
       REAL     TAUDEF,TAUMDEF,TIMEDEF,OM0DEF,V0DEF,RCUTDEF
       REAL     SMLRDEF,MEDRDEF,LRGRDEF
       INTEGER  ISIMDEF
       CHARACTER*40  DEFSGAM, DEFRGAM, DEFMVOL
C
C GRASP ARRAYS WITH DEFAULT LEVELS, CHANGE HERE IF NEEDED
C
       REAL GABS(6),GPCT(6)
       DATA (GABS(I),I=1,6) /.10,.20,.40,.70,1.10,1.60/
       DATA (GPCT(I),I=1,6) /5.0,10.0,15.0,25.0,35.0,50.0/
C
       DATA TAUDEF, TAUMDEF, TIMEDEF /4.5, 0.100, 0.200 /
       DATA OM0DEF, V0DEF, RCUTDEF / 500.0, 100.0, 40.0 /         
       DATA SMLRDEF, MEDRDEF, LRGRDEF / 2.50, 3.50, 5.00 /
       DATA ISIMDEF / 2 /
       DATA DEFSGAM, DEFRGAM / 'simul.out', 'rate.out' /
       DATA DEFMVOL / 'merge.vol' /
