      subroutine add_conf(ic)
      implicit none
      include 'PARAMET.ECEPP'
      include 'PARAMET.ADD'
      include 'sizesclu.dat'
      include 'PARAMET.FIT'
      include 'COMMON.IOUNIT'
      include 'COMMON.MATRIX'
      include 'COMMON.MORASS'
      include 'molecule.inc'
      include 'submol.inc'
      integer ic,j,icanti,ii,jj,nparm
      double precision abjom
      do i=1,npeak
        abjom=0.0d0
        do j=1,num_pair(i)
          icanti=ind_pair(j,i)
          call anti_cantor(icanti,ii,jj)
          abjom=abjom+vol2ds(jj,ii)
cd        print *,'j=',j,' vol=',vol2ds(jj,ii)
        enddo !j
        bb(i,ic)=abjom
cd      write (jout,*) 'i=',i,' ii=',ii,' jj=',jj,' abjom=',abjom
      enddo ! i
      do i=1,ncoupl
        bb(npeak+i,ic)=coupl(i)
      enddo
      return
      end
c------------------------------------------------------------------------------
      subroutine anti_cantor(icanti,ii,jj)
      implicit none
      integer ii,jj,icanti
      ii=dint(1.5d0+0.5d0*sqrt(1.0d0+8.0d0*icanti))
      jj=icanti-(ii-1)*(ii-2)/2
      if (jj.le.0) then
        ii=ii-1
        jj=icanti-(ii-1)*(ii-2)/2
      endif
      return
      end
c------------------------------------------------------------------------------
      subroutine fit_noe
c      implicit none
      include 'PARAMET.ECEPP'
      include 'PARAMET.ADD'
      include 'sizesclu.dat'
      include 'PARAMET.FIT'
      include 'COMMON.IOUNIT'
      include 'COMMON.MATRIX'
      include 'COMMON.MARQ'
      include 'COMMON.MORASS'
      include 'COMMON.GEN100'
      include 'COMMON.THRLET'
      include 'COMMON.ATOMSS'
      include 'COMMON.XBOUNDX'
      include 'COMMON.METHYL'
      include 'COMMON.CLUSTER'
      include 'COMMON.CNTRL'
      double precision a(nmax,nmax),ainv(nmax,nmax),x(nmax),
     & sumweight,stdv,stdv_weight,stdx(nmax),work(nmax),stdsum,wmax
      double precision abjom,sumx,std,cost,devi,stdmin,hij
      double precision gnumi,xi,gtemp(100),f0,f1,rdif,deva(100),
     & dera(100,3),derai
      integer i,ii,jj,ipairi,j,k,il,ind,imin,listpi,listpj,ifail,
     & iresi,iresj,lresi,lresj,iconi,icom,icon(max_peak),kax,imax,iend,
     & nparm,nfun,ic
      double precision sxx,sxy,aa
      integer uiparm(1),nf
      double precision urparm(1)
      external fdum
      logical sing,lprn
      lprn=.false.
      do i=1,nmax
        x(i)=0.0D0
        do j=1,nmax
          a(i,j)=0.0D0
          ainv(i,j)=0.0D0
        enddo
      enddo
      print *,'npeak=',npeak
      print *,'nconf=',nfitted

cd    write (jout,'(/a)') 'The matrix of theoretical spectra'
cd    do i=1,npeak
cd      write (jout,'(i5,7f10.5/10(25x,5f10.5/))') 
cd   &   i,vol(i),wpeak(i),(bb(i,j),j=1,nfitted)
cd    enddo

      if (bystrov) then

C Calculate the differences of coupling constants calculated for subsequent
C conformations from measured constants.
      write (jout,'(a)') 'Deviations from coupling constants'
      do i=1,nfitted
        devi=0.0D0
        do j=npeak+1,npeak+ncoupl
          devi=devi+(vol(j)-bb(j,i))**2
        enddo
        write (jout,'(10f8.3)') (vol(j)-bb(j,i),j=npeak+1,npeak+ncoupl)
        stdx(i)=dsqrt(devi/ncoupl)
      enddo
C Sort deviations from coupling constants
      write (jout,'(i5,f7.3)') (i,stdx(i),i=1,nfitted)
      do i=1,nfitted
        icon(i)=i
      enddo
      do i=1,nfitted-1
        imin=i
        stdmin=stdx(i)
        do j=i+1,nfitted
          if (stdx(j).lt.stdmin) then
            imin=j
            stdmin=stdx(j)
          endif
        enddo
        stdx(imin)=stdx(i)
        stdx(i)=stdmin
        icom=icon(imin)
        icon(imin)=icon(i)
        icon(i)=icom
      enddo
      do i=1,ntyp_coupl
        write (jout,'(/a,i5,2x,3(a,f8.3))') 'Type',i,' a0=',aa0(i),
     &  ' a1=',aa1(i),' a2=',aa2(i)
      enddo
      write(jout,'(/2a/)')'Conformations as ranked acc. to agreement',
     &      ' with coupling constants:'
      write (jout,'(a)') 'Nr        Dev.     Coupling constants     ',
     &                   '-----------------------------------------'
      do i=1,nfitted
        write (jout,'(i4,10f7.3)') icon(i),stdx(i),(bb(npeak+j,icon(i)),
     &               j=1,ncoupl)
      enddo

      sumx=0.0D0
      do i=1,nfitted
        x(i)=1.0D0/stdx(i)**2
        sumx=sumx+x(i)
      enddo
      do i=1,nfitted
        x(i)=dlog(x(i)/sumx)
      enddo
      do i=1,ntyp_coupl
        x(nfitted+3*(i-1)+1)=aa0(i)
        x(nfitted+3*(i-1)+2)=aa1(i)
        x(nfitted+3*(i-1)+3)=aa2(i)
      enddo

C Set weights of the coupling terms.

      do i=npeak+1,npeak+ncoupl
        wpeak(i)=weight_coupl
      enddo
      do i=1,ntyp_coupl
        wpeak(npeak+ncoupl+3*(i-1)+1)=1.0d0/(sa0(i)*sa0(i))
        wpeak(npeak+ncoupl+3*(i-1)+2)=1.0d0/(sa1(i)*sa1(i))
        wpeak(npeak+ncoupl+3*(i-1)+3)=1.0d0/(sa2(i)*sa2(i))
      enddo

      write (jout,'(/a,f7.3)') 
     & 'The weight of the coupling-constant terms is',weight_coupl

      else

      do i=1,nfitted
        x(i)=-dlog(dfloat(nfitted))
      enddo

      endif ! bystrov

C Nonlinear fit.
      print *,'npeak=',npeak,' ncoupl=',ncoupl
      print *,'nfitted',nfitted,' ntyp_coupl',ntyp_coupl
      if (bystrov) then
        nparm=nfitted+3*ntyp_coupl
      else
        nparm=nfitted
      endif
      print *,'nparm',nparm
C Uncomment to check the gradient.
cd      x(nfitted+1)=x(nfitted+1)-0.5d0
cd      x(nfitted+2)=x(nfitted+2)+0.2d0
cd      x(nfitted+3)=x(nfitted+3)-1.0d0
cd      call func(nparm,x,nf,f0,uiparm,urparm,fdum)
cd      do i=1,ncoupl+3
cd        deva(i)=dvol(i+npeak)
cd        do j=1,3
cd          dera(i,j)=derv(i+npeak,nfitted+j)
cd        enddo
cd      enddo 
cd      call gradient(nparm,x,nf,gtemp,uiparm,urparm,fdum)
cd      write (jout,*) 'alpha_ent',alpha_ent,' entropy',entropy
cd      do i=1,nparm
cd        write (jout,*) 'gent',i,gent(i),'  g',i,g(i)
cd      enddo
cd      write (jout,'(a)') 'Comparison of analytical and numerical grad.'
cd      print *,'nparm=',nparm
cd      do i=1,nparm
cd        xi=x(i)
cd        x(i)=xi+1.0d-7
cd        call func(nparm,x,nf,f1,uiparm,urparm,fdum)
c        gnumi=-0.5d0*(f1-f0)/1.0d-7
cd        gnumi=(f1-f0)/1.0d-7
cd        x(i)=xi
c       if (i.gt.nfitted) then
c       do j=1,ncoupl+3
c         derai=(deva(j)-dvol(j+npeak))/1.0d-7
c         write (jout,'(2i5,3f20.5)')i,j,dera(j,i-nfitted),
c    &      derai
c       enddo
c       endif
cd        write (jout,'(i5,3e20.10)') i,gtemp(i),gnumi,
cd     &  (gtemp(i)-gnumi)/dabs(gnumi)
cd      enddo
cd      stop 
c end checking gradient
      if (minimizer .eq. -1) then
C Just calculate Boltzmann-average spectrum and compare it with the experimental
C spectrum
        emin=energy(1,1)
        write (jout,*) 'betbol',betbol
        do ic=1,nfitted
          weight=exp(-betbol*(energy(ic,1)-emin))
          x(ic)=weight
          sumweight=sumweight+weight
          write (jout,*) 'ic=',ic,' energy=',energy(ic,1),
     &                   ' weight=',weight,' sumweight=',sumweight
        enddo
        do ic=1,nfitted
          x(ic)=dlog(x(ic)/sumweight)
        enddo
        write (jout,'(i5,2e12.5)') (ic,x(ic),dexp(x(ic)),ic=1,nfitted)
        f0=rdif(nparm,nf,x,.true.) 
        sxy=0.0d0
        sxx=0.0d0
        do i=1,nfitted
          sxx=sxx+(vol(i)-dvol(i))**2*wpeak(i)
          sxy=sxy+(vol(i)-dvol(i))*vol(i)*wpeak(i)
        enddo
        aa=sxy/sxx
        do i=1,nfitted
          x(i)=x(i)+dlog(aa)
        enddo
        f0=rdif(nparm,nf,x,.true.)
      else if (minimizer .eq. 0) then
        call marquardt(jout,nparm,x,std)
      else
        call minsumsl(nparm,x,std)
      endif
C Compute standard deviations of parameters
      rl=0.0D0
      sumx=0.0D0
      do i=1,nfitted
        x(i)=dexp(x(i))
        sumx=sumx+x(i)
      enddo
c      write (jout,'(i5,e12.5)') (ic,x(ic),ic=1,nfitted)
      call heval1(nparm,x,.false.)
      do i=1,nparm
        do j=1,nparm
          ainv(i,j)=h(i,j)
        enddo ! j
      enddo ! i
      if (lprn) then
        write (jout,'(a)') 'Marix of normal equation system'
        call matout(nparm,jout,h)
      endif
      call matinvert(nparm,h,a,sing)
      do i=1,nparm
        do j=1,nparm
          hij=0.0d0
          do k=1,nparm
            hij=hij+ainv(i,k)*a(k,j)
          enddo
          h(i,j)=hij
        enddo
      enddo
      if (lprn) then
        write (jout,'(a)') 
     &      'Inverse of the matrix of normal equation system'
        call matout(nparm,jout,a)
        call matout(nparm,jout,h)
      endif ! lprn
C
C We have inverted the Hessian matrix of the working parameters, so we can 
C easily calculate their SD's from the Gauss-Markov theorem. However, our
C final parameters are not these, but the weights normalized to unity and
C the base intensity of the NOE peaks, which, incidentally, is the sum of all
C weights. Therefore, we have to transform the Hessian matrix, using the 
C Jacobian of the transformation of the working into the final variables.
C
C Calculate the Jacobian matrix of the transformation. 
C                   _      _
C (x ,...,x ) ---> (x ,...,x ,Sx)
C   1      n         1      n
C             n
C            ___
C where Sx = >   x 
C            ---  i
C            i=1
C
      do i=1,nfitted
        x(i)=x(i)/sumx
      enddo
      do i=1,nfitted
        do j=1,nfitted
          ainv(i,j)=-x(i)/sumx
        enddo !j
        ainv(i,i)=1.0d0/sumx+ainv(i,i)
        ainv(i,nfitted+1)=1.0d0
      enddo !i
C Transform the Hessian matrix into new variables.
      do i=nfitted+3*ntyp_coupl+1,nfitted+2,-1
        do j=nfitted+3*ntyp_coupl+1,nfitted+2,-1
          a(i,j)=a(i-1,j-1)
        enddo
      enddo
      do i=1,nfitted
        do j=1,nfitted+1
          hij=0.0d0
          do k=1,nfitted
            hij=hij+a(i,k)*ainv(k,j)
          enddo !k
          h(i,j)=hij
        enddo !j
      enddo !i
      do i=1,nfitted+1
        do j=1,nfitted+1
          hij=0.0d0
          do k=1,nfitted
            hij=hij+ainv(k,i)*h(k,j)
          enddo
          a(i,j)=hij
        enddo !j
      enddo !i
      if (lprn) then
        write (jout,'(a)') 'Transformed Hessian matrix.'
        call matout(nparm+1,jout,a)
      endif
      std=std/(npeak+ncoupl-nfitted)
      do i=1,nfitted+3*ntyp_coupl+1
        stdx(i)=dsqrt(std*a(i,i))
      enddo
      write (jout,'(a,f10.5)') 'Base intensity:',sumx
      write (jout,'(a,f10.5)') 'Standard deviation of base intensity:',
     &      stdx(nfitted+1)
cd    write (jout,'(a)') 'Weights of subsequent conformations'
cd    write (jout,'(6(1pe12.4))') (x(i),i=1,nfitted)
cd    write (jout,'(a)') 'Standard deviations of weights'
cd    write (jout,'(6(1pe12.4))') (stdx(i),i=1,nfitted)
C Sort weights
      do i=1,nfitted
        icon(i)=i
      enddo
      do i=1,nfitted-1
        imax=i
        wmax=x(i)
        do j=i+1,nfitted
          if (x(j).gt.wmax) then
            imax=j
            wmax=x(j)
          endif
        enddo
        x(imax)=x(i)
        x(i)=wmax
        wmax=stdx(imax)
        stdx(imax)=stdx(i)
        stdx(i)=wmax
        icom=icon(imax)
        icon(imax)=icon(i)
        icon(i)=icom
      enddo
      write (jout,'(/a/)') 'Conformations ranked according to weights:'
      write (jout,'(a)') ' Nr       Weight    StdWeight    SumWeight',
     &                   '-----------------------------------------'
c     iend=min0(10,nfitted)
      iend=nfitted
      sumweight=0.0d0
      do i=1,iend
        sumweight=sumweight+x(i)
        write (jout,'(i4,f12.5,e13.4,f13.5)') icon(i),x(i),stdx(i),
     &   sumweight
      enddo
      write (jout,'(a/)') '----------------------------------------'
c      write (jout,'(i5,f10.5)') (i,wpeak(i),i=1,npeak)
      stdv=0.0D0
      stdv_weight=0.0d0
      write (jout,'(5a)') '  No',' protons','  Vol_calc','   Vol_mes',
     &   '      dVol',
     &   '              Atoms/Residues'
      do i=1,npeak
        ipairi=ind_pair(1,i)
        call anti_cantor(ipairi,ii,jj) 
        listpi=list_prot(ii)
        iresi=kax(listpi)
        lresi=iabs(list(iresi))
        if (iresi.eq.1 .or. iresi.eq.inumrs) lresi=lresi+num_restypes
        listpj=list_prot(jj)
        iresj=kax(listpj)
        lresj=iabs(list(iresj))
        if (iresj.eq.1 .or. iresj.eq.inumrs) lresj=lresj+num_restypes
       write(jout,'(i4,2i4,3f10.5,5x,a3,i4,1x,a3,i4,3x,a3,i4,1x,a3,i4)')
     &  i,ii,jj,vol(i)-dvol(i),vol(i),dvol(i)*wpeak(i),
     &  ares(lresi),iresi,alph(listpi),listpi,
     &  ares(lresj),iresj,alph(listpj),listpj
        stdv=stdv+dvol(i)**2
        stdv_weight=stdv_weight+wpeak(i)*dvol(i)**2
        do j=2,num_pair(i)
          ipairi=ind_pair(j,i)
          call anti_cantor(ipairi,ii,jj)
          listpi=list_prot(ii)
          iresi=kax(listpi)
          lresi=iabs(list(iresi))
          if (iresi.eq.1 .or. iresi.eq.inumrs) lresi=lresi+num_restypes
          listpj=list_prot(jj)
          iresj=kax(listpj)
          lresj=iabs(list(iresj))
          if (iresj.eq.1 .or. iresj.eq.inumrs) lresj=lresj+num_restypes
          write(jout,'(i4,2i4,35x,a3,i4,1x,a3,i4,3x,a3,i4,1x,a3,i4)')
     &      i,ii,jj,ares(lresi),iresi,alph(listpi),listpi,
     &      ares(lresj),iresj,alph(listpj),listpj
        enddo !j
      enddo !i
      write (jout,'(a,f10.5)')'Weigthed sum of squares:',stdv_weight
      stdv=dsqrt(stdv/npeak)
      stdv_weight=dsqrt(stdv_weight/npeak)
      write (jout,'(/a,f10.5)')'Standard deviation in peak volume:',stdv
      write (jout,'(a,f10.5)')'Weighted deviation in peak volume:',
     &  stdv_weight

      if (bystrov) then

      write (jout,'(/a/)') 'Final coupling constants'
      write (jout,'(3(a,i1,a,f10.5,a,f10.5,a))')
     & (('a',i,'=',x(nfitted+3*(k-1)+i+1),'(',
     & stdx(nfitted+3*(k-1)+i+2),')  ',i=0,2),k=1,ntyp_coupl)
      stdv=0.0D0
      write (jout,'(4a)') 'Res Angle    Jcalc    Jexp'
      write (jout,'(a)') '--------------------------'
      do i=1,inumrs
        do j=1,nang(i)
          ind=npeak+icoupl(j,i)
          write (jout,'(2i3,4x,f8.3,f8.3)') i,iang(j,i),
     &                            vol(ind)-dvol(ind),vol(ind)
          stdv=stdv+dvol(ind)**2
        enddo ! j
      enddo ! i
      write (jout,'(/a,f10.5)') 
     &      'Weighted sum of squares:',weight_coupl*stdv
      stdv=dsqrt(stdv/ncoupl)
      write (jout,'(a,f10.5)') 
     &      'Standard deviation in coupling constant:',stdv

      endif
c     write (jout,'(/a/)') 
c    &  'Eigenvector analysis of the variance-covariance matrix.'
C Diagonalize the variance-covariance matrix
c     call f02faf('V','U',nfitted+1,a,nmax,stdx,work,nmax,ifail)
c     write (jout,'(/a/)') 
c    &  'Standard deviations along the main axes.'
c     do i=1,nfitted+1
c       stdx(i)=dsqrt(stdx(i)*std)
c       write(jout,'(i5,f10.5)') i,stdx(i)
c     enddo
c     write (jout,'(/a)') 
c    & 'Eigenvalues and eigenvectors of the variance-covariance matrix.'
c     call eigout(nfitted+1,nfitted+1,a,stdx)

      stop
      end
c-----------------------------------------------------------------------------
      SUBROUTINE EIGOUT(NC,NR,A,B)
      include 'PARAMET.ECEPP'
      include 'sizesclu.dat'
      include 'PARAMET.FIT'
      include 'COMMON.IOUNIT'
      double precision A(nmax,nmax),B(nmax)

      KA=1
      KC=6
    1 KB=MIN0(KC,NC)
      WRITE(JOUT,600) (I,I=KA,KB)
      WRITE(JOUT,601) (B(I),I=KA,KB)
      WRITE(JOUT,602)
    2 N=0
      DO 3  I=1,NR
      WRITE(JOUT,603) I,(A(I,J),J=KA,KB)
      N=N+1
      IF(N.LT.10) GO TO 3
      WRITE(JOUT,602)
      N=0
    3 CONTINUE
    4 IF (KB.EQ.NC) RETURN
      KA=KC+1
      KC=KC+6
      GO TO 1
  600 FORMAT (// 9H ROOT NO.,I4,9I11)
  601 FORMAT (/5X,10(1PE11.4))
  602 FORMAT (2H  )
  603 FORMAT (I5,10F11.5)
  604 FORMAT (1H1)
      END
