      subroutine read_spectrum
      implicit none
      include 'PARAMET.ECEPP'
      include 'PARAMET.ADD'
      include 'sizesclu.dat'
      include 'PARAMET.FIT'
      include 'COMMON.IOUNIT'
      include 'COMMON.ATOMSS'
      include 'COMMON.MATRIX'
      include 'COMMON.MORASS'
      include 'COMMON.XBOUNDX'
      character*3 res1,res2,atom1,atom2
      integer numres1,numres2,numat1,numat2,numprot1,numprot2
      integer i,j,k,l,ii,iii,icont,irec,icant,nprot1,nprot2
      double precision voli
      do i=1,max_peak
        vol(i)=0.0D0
      enddo
      npeak=0
C Read the experimental NOE spectrum.
      do ii=1,max_peak
        i=npeak+1
        read (jsumsl,'(2i5,f10.5,5x,a3,i4,1x,a3,i4,3x,a3,i4,1x,a3,2i4)',
     &            end=10,err=10)
     &  numprot1,numprot2,voli,res1,numres1,atom1,
     &  numat1,res2,numres2,atom2, numat2,icont
        if (numprot1.eq.0 .or. numprot2.eq.0) goto 10
        write (jout,'(2i5,f10.5,5x,a3,i4,1x,a3,i4,3x,a3,i4,1x,a3,i4)')
     &  numprot1,numprot2,voli,res1,numres1,atom1,
     &  numat1,res2,numres2,atom2, numat2
        if (alph(list_prot(numprot1)).ne.atom1) 
     &  write (jout,'(a,i5,2a,1x,a)') 
     &  'Warning. Name of proton',numprot1,
     &    ' does not match ECEPP name. ',alph(list_prot(numprot1)),atom1
        if (alph(list_prot(numprot2)).ne.atom2) 
     &  write (jout,'(a,i5,2a,1x,a)') 
     &  'Warning. Name of proton',numprot2,
     &    ' does not match ECEPP name. ',alph(list_prot(numprot2)),atom2
        iii=icant(numprot1,numprot2)
        if (icont.eq.0) then
C icont=0 means that this is a new NOE.
          if (nequiv(numprot1).lt.0) then
            write (jout,'(a,i5,a,i5)') 'Proton ',numprot1,
     &          ' is in the equivalence group of proton',
     &          numprot1+nequiv(numprot1)
            numprot1=numprot1+nequiv(numprot1)
          endif
          if (nequiv(numprot2).lt.0) then
            write (jout,'(a,i5,a,i5)') 'Proton ',numprot2,
     &          ' is in the equivalence group of proton',
     &          numprot2+nequiv(numprot2)
            numprot2=numprot2+nequiv(numprot2)
          endif
          if (numprot1.eq.numprot2) then
            write (jout,'(a,2i5,a)') 
     & 'The protons of this peak belong to same equivalence group.'
            goto 35
          endif
          iii=icant(numprot1,numprot2)
          nprot1=nequiv(numprot1)+1
          nprot2=nequiv(numprot2)+1
          write (jout,*) 'numprot1=',numprot1,' numprot2=',numprot2,
     &      ' nprot1=',nprot1,' nprot2=',nprot2
          if (npeak.gt.0) num_pair(npeak)=num_pair(npeak)+irec
          irec=0
          if (voli.lt.0.0d0) then
            do j=1,nprot1
              do k=1,nprot2
                iii=icant(iequiv(j,numprot1),iequiv(k,numprot2))
                excluded(iii)=.true.
              enddo ! k
            enddo ! j
            write (jout,'(2a,i4,2a,i4,a)') 'The NOE between ',
     &      alph(list_prot(numprot1)),numprot1,' and ',
     &      alph(list_prot(numprot2)),numprot2,
     &      ' and all equivalent protons has beed excluded.'
          elseif (.not. excluded(iii)) then 
C Check if this group of protons has already been listed.
            do j=npeak,1,-1
              if (ind_pair(1,j).eq.iii) then
                write (jout,'(a,2i5,a,i5)') 'Proton pair',numprot1,
     &          numprot2,' already present in peak',j
                write (jout,'(a,f10.5,a)') 'The read peak volume',
     &  voli,' has been added to the total volume of this group.'
                vol(j)=vol(j)+voli
                goto 33
              endif
            enddo
            l=0
            do j=1,nprot1
              do k=1,nprot2
                l=l+1
                ind_pair(l,npeak+1)=
     &          icant(iequiv(j,numprot1),iequiv(k,numprot2))
              enddo ! k
            enddo ! j
            npeak=npeak+1
            vol(npeak)=voli
            num_pair(npeak)=nprot1*nprot2
  33        continue
            write (jout,*) 'npeak=',npeak,' num_pair=',num_pair(npeak),
     &      ' ind_pair=',(ind_pair(l,i),l=1,num_pair(i))
          else
            write (jout,'(2a,i4,2a,i4,a)') 'The NOE between ',
     &      alph(list_prot(numprot1)),numprot1,' and ',
     &      alph(list_prot(numprot2)),numprot2,
     &      ' found in the experimental spectrum, but precluded.'
          endif 
        else if (npeak.gt.0) then
C icont<>0 means that this NOE is combined with the preceding one(s), due to
C chemical shift overlap.
          do j=1,num_pair(npeak)
            if (ind_pair(j,npeak).eq.iii) goto 34
          enddo
          irec=irec+1
          ind_pair(num_pair(npeak)+irec,npeak)=iii
          write (jout,*) 'npeak=',npeak,' irec=',irec,
     &      ' numprot1=',numprot1,
     &      ' numprot2=',numprot2,' iii=',iii
  34      continue
        endif
  35    continue
      enddo
   10 close (jsumsl)
      do i=1,npeak
        wpeak(i)=1.0D0/(vol(i)+wbase)
      enddo
      do ii=1,npeak
        write (jout,'(16i5)') ii,num_pair(ii),
     &          (ind_pair(irec,ii),irec=1,num_pair(ii))
      enddo
      write (jout,'(a)') 'Experimental NOE spectrum:'
      write (jout,'(a,i6)') 'npeak=',npeak
      do i=1,npeak
        call anti_cantor(ind_pair(1,i),numprot1,numprot2)
        write (jout,'(2i4,3x,2(3x,a,i4),f10.5)') 
     &  numprot1,numprot2,alph(list_prot(numprot1)),list_prot(numprot1),
     &  alph(list_prot(numprot2)),list_prot(numprot2),vol(i)
      enddo
      return
      end
