      subroutine read_bridge(jin,jout,errors)
      include 'PARAMET.ECEPP'
      logical errflag,errors,blankline
      character*80 line,line1,ucase
      common/loops/kcys,nhalf,npair(2*maxloop)
      errors=.false.
      nhalf=0
      read (jin,'(a)') line
      write (jout,'(2a)') '> ',line(1:78)
      do while (index(ucase(line),'$END').eq.0)
        ipos=1
        blankline=.false.
        errflag=.false.
        do while (.not. blankline)
          call mykey(line,line1,ipos,blankline,errflag)
          if (errflag) goto 10 
          errors=errors .or. errflag
          if (.not. blankline .and. .not. errflag) then
            if (nhalf.lt.2*maxloop) then
              nhalf=nhalf+1
              read (line1,*,err=10) npair(nhalf)
            else
              errors=.true.
              write (jout,1000) nhalf/2,maxloop
              return
            endif
          endif
        enddo
        read (jin,'(a)') line
        write (jout,'(2a)') '> ',line(1:78)
      enddo
      if (2*(nhalf/2).ne.nhalf) then
        errors=.true.
        write (jout,'(2a,i4,a)') 'Error in $BRIDGE: odd number of',
     & ' bridging residues has been specified (',nhalf,').'
      endif
cd    write (jout,'(16i5)') (npair(i),i=1,nhalf)
      return
   10 write (jout,'(a/a)') 'Read error in $BRIDGE in data line:',line
      errors=.true.
 1000 format ('Error in $BRIDGE: The number of bridges read (',i4,
     & ') exceeds maximum (',i4,').')
      return
      end
c------------------------------------------------------------------------------
      subroutine read_seq(jin,jout,errors)
      include 'PARAMET.ECEPP'
      include 'COMMON.GEN100'
      include 'COMMON.THRLET'
      include 'COMMON.PRAMX'
      include 'COMMON.SETUP'
      include 'COMMON.CNTRL'
      character*80 line,line1,ucase
      character*8 sequence(maxnum_res),temp_str
      character*3 res
      logical errflag,errors,err_res_nam,blankline,lower_case
      errors=.false.
      read (jin,'(a)') line
      write (jout,'(2a)') '> ',line(1:78)
      line1=ucase(line)
      iseq=1
      do while (index(line1,'$END').eq.0)
* Override commented lines.
         ipos=1
         blankline=.false.
         if (icode.lt.3) then 
* Numeric or three-letter code. A separator is required between residue IDs.
           do while (.not. blankline)                 
             call mykey(line,temp_str,ipos,blankline,errflag)
             if (errflag) write (jout,'(2a)')
     & 'Error when reading sequence in line: ',line
             errors=errors .or. errflag
             if (.not. blankline .and. .not. errflag) then
               if (iseq.le.maxnum_res) then
                 sequence(iseq)=temp_str
                 iseq=iseq+1
               else
                 errors=.true.
                 write (jout,1000) iseq,maxnum_res
                 goto 80
               endif
             endif
           enddo
         else
* One-letter code
           do while (.not.blankline)
             line1=' '
             call mykey(line,line1,ipos,blankline,errflag) 
             if (errflag) write (jout,'(2a)')
     & 'Error when reading sequence in line: ',line
             errors=errors .or. errflag
             if (.not. blankline .and. .not. errflag) then
               if (line1(1:1).eq.'@@') then
                 il=2
                 ipos1=3
               else 
                 il=1
                 ipos1=2
               endif
               iend=ilen(line1)
               if (iseq.le.maxnum_res) then
                 sequence(iseq)=line1(1:il)
               else
                 errors=.true.
                 write (jout,1000) iseq,maxnum_res
                 goto 80
               endif
               do while (ipos1.le.iend)
                 if (line1(ipos1:ipos1).eq.'+' .or. 
     &               line1(ipos1:ipos1).eq.'-' .or.
     &               line1(ipos1:ipos1).eq.'<' .or.
     &               line1(ipos1:ipos1).eq.'>' .or.
     &               line1(ipos1:ipos1).eq.'*' .or.
     &               line1(ipos1:ipos1).eq.'_') then
                   sequence(iseq)=line1(ipos1-il:ipos1)
                   ipos1=ipos1+1
                 else
                   iseq=iseq+1
                   if (ipos1.lt.iend .and. 
     &                      line1(ipos1:ipos1).eq.'@@') then
                     il=2
                     ipos1=ipos1+2
                   else
                     il=1
                     ipos1=ipos1+1
                   endif
                   if (iseq.le.maxnum_res) then
                       sequence(iseq)=line1(ipos1-il:ipos1-1)
                   else
                     errors=.true.
                     write (jout,1000) iseq,maxnum_res
                     goto 80
                   endif
                 endif
               enddo
               iseq=iseq+1
             endif
           enddo
         endif
         read (jin,'(a)') line
         write (jout,'(2a)') '> ',line(1:78)
         line1=ucase(line)
      enddo
   80 continue
cd    write (jout,'(10a8)') (sequence(i),i=1,iseq-1)
* If the user has specified the length of the chain, check whether the 
* found length of the chain is correct.
      length_of_chain=iseq-3
      if (nres.eq.0) nres=length_of_chain
      if (length_of_chain .ne. nres) then
        errors=.true.
        write (jout,'(a,i4,a,i4,a)') 
     & 'Error - the found number of residues (',length_of_chain,
     & ') does not match the number specified in $CNTRL (',nres,').' 
      endif
* Now decode the sequence.
      goto (10,20,30) icode
* Numeric code of the sequence
   10 do ires=1,nres+2
        read (sequence(ires),*,err=100) list(ires)
        goto 40
  100   write (jout,'(a,i4,2a)') 'Error in residue ',ires,': ',
     &   sequence(ires)
        errors=.true.
   40 enddo 
      return
* Three-letter code of the sequence.
   20 do ires=1,nres+2
        ils=ilen(sequence(ires))
        ichir=1
        err_res_nam=.false.
        if (ils.le.3) then
          res=sequence(ires)
          if (lower_case(res(1:1))) ichir=-1 
        elseif ( (ils.eq.4 .and. ucase(sequence(ires)(1:1)).eq.'D') 
     &  .or. (ils.eq.5 .and. ucase(sequence(ires)(1:2)).eq.'D-') ) then
          res=sequence(ires)(ils-2:ils)
          ichir=-1
        else
          err_res_nam=.true.
          errors=.true.
          write (jout,'(3a,i4)') 'Error - bad three-letter code ',
     & sequence(ires),' found in position',ires
        endif
        res=ucase(res)
        if (.not.err_res_nam) then
          i=1
          do while (res.ne.ares(i) .and. i.le.num_restypes+num_endgrp)
            i=i+1
          enddo
          if (i.gt.num_restypes+num_endgrp) then
            errors=.true.
            write (jout,1010) sequence(ires),ires
          else if (ires.ne.1 .and. ires.ne.nres+2) then
            list(ires)=ichir*i
          else
            list(ires)=i
          endif
          if (ires.gt.1 .and. ires.lt.nres+2 .and. i.gt.num_restypes) 
     &    then
            errors=.true.
            write (jout,'(3a,i4,a)') 
     &                      'Error - an end group ',sequence(ires),
     &      ' has been found in the position',ires,' of the chain.'
          elseif ((ires.eq.1 .or. ires.eq.nres+2).and.
     &             i.le.num_restypes) then
            errors=.true.
            if (ires.eq.1) write (jout,'(2a)')
     &         'Error - sequence is started with a full residue ',
     &          sequence(ires)
            if (ires.eq.nres+2) write (jout,'(2a)')
     &         'Error - sequence is terminated with a full residue ',
     &          sequence(ires)
          endif
        endif
      enddo
      list(1)=list(1)-num_restypes
      list(nres+2)=list(nres+2)-num_restypes
      write (jout,'(16i5)') (list(i),i=1,nres+2)
      return 
* One-letter code of the sequence. First process full residues.
   30 do ires=2,nres+1
        ils=ilen(sequence(ires))
        ichir=1
        if (lower_case(sequence(ires)(1:1)) .or. 
     &      lower_case(sequence(ires)(2:2)) ) ichir=-1 
        i=1  
        do while (ucase(sequence(ires)(1:3)).ne.one_let(i) .and. 
     &    i.le.num_restypes)
          i=i+1
        enddo
        if (i.gt.num_restypes) then
          errors=.true.
          write (jout,1010) sequence(ires),ires
        else
          list(ires)=ichir*i    
        endif 
      enddo
* End groups
      do ires=1,nres+2,nres+1
        ils=ilen(sequence(ires))
        i=num_restypes+1
        do while(ucase(sequence(ires)(1:2)).ne.one_let(i) .and. 
     &     i.le.num_restypes+num_endgrp)
          i=i+1
        enddo
        if (i.gt.num_restypes+num_endgrp) then
          errors=.true.
          write (jout,1010) sequence(ires),ires
        else
          list(ires)=i    
        endif 
      enddo
      list(1)=list(1)-num_restypes
      list(nres+2)=list(nres+2)-num_restypes
      write (jout,'(16i5)') (list(i),i=1,nres+2)
      return
 1000 format('Error - the number of residues (',i4,
     & ') has exceeded maximum (',i4,').')
 1010 format ('Error - unrecognized residue or end group ',a8,
     & ' in position',i4)
      end
c------------------------------------------------------------------------------
      subroutine read_spec(jin,jout,errors)
      include 'PARAMET.ECEPP'
      logical errflag,errors,blankline
      include 'COMMON.KVS'
      include 'COMMON.SETUP'
      include 'COMMON.TOR2'
      include 'COMMON.BONDSX'
      character*80 line,line1,ucase
      errors=.false.
      nvr=0
      numvr0=0
      read (jin,'(a)') line
      write (jout,'(2a)') '> ',line(1:78)
      do while (index(ucase(line),'$END').eq.0)
C
C IVARFLAG=5 (i.e. "NONE") then SPEC card if useless and the information 
C  will not be considered. We read the lines until $END card is found.  
C
        if (ivarflag.eq.5) goto 20
C
        if (ivarflag.eq.4) then
C IVARFLAG=4 means that the user specifies the variable angles explicitly.
          read (line,*,err=10) ires,nvi,(ndxarr0(k,ires),k=1,nvi)
          nv0(ires)=nvi
          numvr0=numvr0+nvi
          nvr=nvr+1  
          numvarres(nvr)=ires
        else
          ipos=1
          blankline=.false.
          errflag=.false.
          do while (.not. blankline)
            call mykey(line,line1,ipos,blankline,errflag)
            errors=errors .or. errflag
            if (errflag) goto 10 
            if (.not. blankline .and. .not. errflag) then
              if (nvr.lt.nres+2) then
                nvr=nvr+1
                read (line1,*,err=10) numvarres(nvr)
              else
                errors=.true.
                write (jout,1000) nres+2
                return
              endif
            endif
          enddo
        endif
 20     read (jin,'(a)') line
        write (jout,'(2a)') '> ',line(1:78)
      enddo
      if (nvarres.eq.0) then
        nvarres=nvr
      elseif (nvr.ne.nvarres) then
        write (jout,'(2a/a,i4,a,i4,a)') 
     &   'Error in $SPEC: the number of residues with ',
     &   'variable dihedrals specified in ','$CNTRL (',nvarres,
     &   ') is not equal to the number read here (',nvr,').'
        errors=.true.
      endif
      if (ivarflag.eq.4) then
        if (nvr.eq.0) then
          write (jout,'(2a/a)')
     &     'Error in $SPEC: VAR_ANGLES=SPEC was ',
     &     'specified in $CNTRL, but ',
     &     'no dihedral angle has been defined in the $SPEC card'
          errors=.true.
        endif
      endif
C Sort the NUMVARRES array and the rows of NDXARR and simultaneously
C check for repetitions. -- AL 11/02/93
      do i=1,nvarres
        imin=i
        ires=numvarres(i)
        nvi=nv0(ires)
        do j=i+1,nvarres
          jres=numvarres(j)
          if (ires.eq.jres) then
            write (jout,'(2a,i3,a)') 'Error in $SPEC data group. ',
     & 'Residue with variable angles',ires,' specified repeatedly.'
            errors=.true.
          else if (ires .gt. jres) then
            imin=j
            ires=jres 
          endif
        enddo
        if (imin.gt.i) call exch(numvarres(i),numvarres(imin))
      enddo             
      if (ivarflag.eq.4) then
        do i=1,nres+2
          nvi=nv0(i)  
          if (nvi .gt. 0) then
            do j=1,nvi
              jmin=j
              ndxji=ndxarr0(j,i)
              do k=j+1,nvi
                ndxki=ndxarr0(k,i)
                if (ndxji.eq.ndxki) then
                  write (jout,'(2a,i2,a,i3,a)') 
     & 'Error in $SPEC data group. ',
     & 'Angle',ndxji,' for residue',i,' specified repeatedly.'
                  errors=.true.
                else if (ndxji.gt.ndxki) then
                  jmin=k
                  ndxji=ndxki
                endif
              enddo
              call exch(ndxarr0(j,i),ndxarr0(jmin,i))
            enddo
          endif
        enddo
      endif
      write (jout,'(16i5)') (numvarres(i),i=1,nvarres)
      return
   10 write (jout,'(2a)')'Error when reading $SPEC in line: ',line
      errors=.true.
      return
 1000 format ('Error - the number of variable residues exceeds the ',
     & /,'total number of residues and end groups (',i4,').')
 1100 format ('Error - VAR_ANGLES and VAR_RES cards have been ',
     & ' specified',/,' simultaneously in $CNTRL.')
      end

