      SUBROUTINE SET_DEFAULTS
      INCLUDE 'PARAMET.ECEPP'
      include 'PARAMET.ADD'
      include 'sizesclu.dat'
      include 'PARAMET.FIT'
c      INCLUDE 'COMMON.MINPAR'
      INCLUDE 'COMMON.CNTRL'
      INCLUDE 'COMMON.FILES'
      INCLUDE 'COMMON.EXTPH'
      INCLUDE 'COMMON.SOLVAT'
      INCLUDE 'COMMON.OMTOR'
      INCLUDE 'COMMON.THERMO'
      INCLUDE 'COMMON.MOVE'
      INCLUDE 'COMMON.EDMC'
      INCLUDE 'COMMON.BIAS'
      INCLUDE 'COMMON.BRIDGES'
      INCLUDE 'COMMON.SCAN'
      INCLUDE 'COMMON.DEBUG'
      INCLUDE 'COMMON.TIME1'
      INCLUDE 'COMMON.KVS'
      INCLUDE 'COMMON.XBOUNDX'
      INCLUDE 'COMMON.BRAIN'
      INCLUDE 'COMMON.PRTBKTK'
      INCLUDE 'COMMON.VTFEX'
      include 'COMMON.MORASS'
      include 'COMMON.MARQ'
      include 'COMMON.MATRIX'
      include 'molecule.inc'
C     COMMON /IOUNIT/ IUNIT(14)
C Supress debugging. Set LPRNT to .true. intead of this, if you want extensive
C diagnostic output. This will however be very much!
      LPRNT=.FALSE.
      LPTOR=.FALSE.
C By default only energy will be evaluated
      IRUNTYP=1
C Set default time limit
      BATIME=10.0**10
C Set defaults for the parameters that control printing of Cartesian coords.
      PRINT=.FALSE.
C The sequence is by default read in ECEPP code
      ICODE=1
C All dihedral angles will be varied by default
      IVARFLAG=3
C No printing of atom exposed surfaces by default 
      ISFOUT=0
      ETHRESH=.1E+30
*******************************************************
C Defaults for force field
      IREP=0
C  use ECEPP potential (not the simplified one) 
      SIMPLE_POT=.FALSE.
C  COEN is the contact energy in Kcal/mol.
      COEN=10.0
      ICOMP(1)=1

      ICOMP(2)=0
      ICOMP(3)=0
      OMCON=.FALSE.
      FORCON=0.0
      INTOR=1
      TSTART=0.0
      TEND=0.0
      SURDER=.FALSE.
      PHS=0.0
      ICUTOFF=1
      VARDIEL=.FALSE.
      NONOVERLAP_ENE=.FALSE.
C No pre-minimization as a default.
      OVER_CUTOFF=0.0
********************************************************
C Assign database filenames
********************************************************
C Uncomment the following line if your version of FORTRAN does not
C support GETENV.
c     SOLVFILE='srfopt.set'
c     RADFILE='resrad.data'
c     READFILE='rsdata.oct93'
C Put here the name of your database directory.
c     DBS=' '
C Set default prefix for Cartesian-coordinate filenames.
c     COORPREF='coords'
********************************************************
C Uncomment the following line if your version of FORTRAN supports
C GETENV. OPENUNITS will take the filenames from C-shell script.
      CALL OPENUNITS
********************************************************
C Defaults for minimizers
      IMIN=1
      MAXFUN=1000
      MAXIT=1000
      AMAXSTEP=4.0
      VTNER1=0.1
      ABSTOL=0.001
      RELTOL=0.00001
      IDSCALE=0
      DVALUE=4.0
C*******************************************************
C Defaults for the Monte Carlo procedure

      MOVANG=2
      ISEED=-4493211
      BACKUP=3600.0
      RESTART=.FALSE.
      LICZM=200
      ICHCNF=0
      ARBT=0.1
      NREPMM=50
      NRANM=100
      NTERMM=20
      MAXEL=400
      EFINAL=-10000.0
      TLOW=1000.0
      TUP=1000.0
      NSTEPC=0
      NSTEPH=0
      NWIND=0
      NPRINT_ELEC=10
      OMPROB=5000.0
      NUMDEF=0
      EXCPRH=0.5
C Backbone backtracking.
      ITYPBK=1
C Max. no of variables changed at the same time during backtracking
C is equal to mxbktrc+2
      MXBKTRC=5
C logical variables used in routine PERTURB during backtracking.
      BKTKPR=.TRUE.
C Default RESTART file
      RESTFILE='edmc.rstart'
      RANDFILE='edmc.rndom'
********************************************************
C  Bridges
C Set the number of bridges at zero as a default
      NLOOP=0
C
********************************************************
C No chi-angle scanning as a default!
      NREAD=0
C No distance constraints during sampling except those implied by the 
C presence of bridges.
      WITHCNST=.FALSE.
      NHPB=0
      IS=0
      IE=0
C
C Default for Energy calculation, energy minimization and VTF. 
C Don't read multiple conformations.
      READCONFS= .FALSE.
C Don't generate random  conformations.
      ISTARTRND=0
C
C Default for VTF and Distance Constraints.
C
C No group definition of protons.
      igroupNum=0
C No pairs of bounds to read in.
      NPAIR1=0
      NPAIR2=0
C    default for weight on distance constraints energy.
      WEI_ENE=1.0
C Used torsional potential.
      IFLOV=0
C iorder=0       default; Order by range, a la Braun-Go
      IORDER=0
C  Only distance constraints up to rank irangmx will be used.
C  Default for irangmx should be set later to maximum no. of residues (INUMRS).
      IRANGMX=1000000
C  Original Max Vasquez program allows the definition of regions of
C sampling for each amino acids.
C J. of Biomol. Struc & Dyn. vol5 pp 757 (1988)
      REGSAMP=.FALSE.
C
C Minimization will be performed during VTF procedure.
      NOMINIM=.false.
C Defaults of NOE calculation setup
      mod_morass=1
      mod_calc=1
      mod_clust=1
      bystrov=.false.
      geminal=.false.
      vicinal=.true.
      rigid=.true.
      print_all_spectra=.false.
      equiv=2
      noe=1
      antinoe=2
      weight_coupl=0.10d0
      ntyp_coupl=2
      aa0(1)= 0.4d0
      aa1(1)=-1.1d0
      aa2(1)= 9.4d0
      sa0(1)= 2.0d0
      sa1(1)= 2.0d0
      sa2(1)= 2.0d0
      aa0(2)=14.9d0
      aa1(2)=-1.1d0
      aa2(2)=-9.4d0
      sa0(2)= 2.0d0 
      sa1(2)= 2.0d0
      sa2(2)= 2.0d0
C See comments in MORASS' procsim.f about the meaning of the variables.
      tau=taudef
      taum=taumdef
      time=timedef
      v0=v0def
      om0=om0def
      rcut=rcutdef
C Default baseline in NOE weight calculation.
      wbase=1.0d0
C Default weight of the coupling constants.
      weight_coupl=0.1d0
C Zero the matrix of the normal equation system.
      do i=1,max_peak
        dvol(i)=0.0d0
        do j=1,nmax
          bb(i,j)=0.0D0
        enddo
      enddo
C Default parameters of Marquardt's iteration procedure.
      maxit=1000
      maxmar=10
      maxfun=5000
      rl=100.0D0
      vmarq=10.0D0
      tolx=1.0D-3
      tolf=1.0D-3
      rtolf=1.0D-5
      tollam=1.0D0
      rlmin=1.0d-20
      
      RETURN
      END
